var EventManagerFlip = function( parent , elem )
{
	var _this					= {};
	
	_this.currDate				= new Date();
	
	_this.elem					= elem;	
	
	_this.parent				= parent;
	_this.objName				= "";
	_this.swipConfX				= 5;//%
	_this.swipConfTime			= 400;
	
	_this.moveConfX				= 20;//%
	
	_this.currDateTouchStart	= 0;
	_this.currDateTouchEnd		= 0;
	
	_this.goDoubleTouchTime		= 300;//ms

	_this.doubleTapTimeStart	= 0;
	_this.doubleTapTimeEnd		= 0;
	_this.isDoubleTapTimeStart	= 0;
	_this.isDoubleTapTimeEnd	= 0;
    
	_this.isMultiTouch 			= 0;
	_this.touchMoveEvent		= false;
	_this.originaleMoveEvent	= false;
	
	_this.moveDiffX				= 0;
    _this.moveDiffY				= 0;
    
    _this.touchMoveEventHist	= 0;
    
	_this.currentMouse_x		= 0;
	_this.currentMouse_y		= 0;
	
	_this.mouseStart_x			= 0;    
	_this.mouseStart_y			= 0;
	
	_this.touchable				= false;
	_this.handler 				= {};
	_this.handler.TouchMove		= "mousemove";
	_this.handler.TouchStart	= "mousedown";
	_this.handler.TouchEnd		= "mouseup";

	
	_this.touchableInfo			= isEventSupported("touchstart",elem[0]);
	
	_GLOBALS.touchableInfo		= _this.touchableInfo;
	
	//_this.touchableInfo			= false;
	
	if( _this.touchableInfo )
	{
		_this.touchable = true;
		_this.handler.TouchMove	= "touchmove";
		_this.handler.TouchStart= "touchstart";
		_this.handler.TouchEnd	= "touchend";
	}

	_this.myConstruct = function()
	{
		_this.isMultiTouch 			= 0;
		_this.moveTimeStart			= 0;
		_this.moveDiffX             = 0;
		_this.moveDiffY				= 0;
        
		_this.touchMoveEventHist	= 0;
		
		_this.touchStartEvent		= false;
		_this.touchMoveEvent		= false;
		_this.touchEndEvent			= false;
		_this.multiTouchEvent		= false;
		
		_this.currDateTouchStart	= 0;
		_this.currDateTouchEnd		= 0;
		
		_this.multiTouchEventOriginalXY	= false;
		return void(0);
	}
	
	_this.myConstruct();
	
	_this.unbindAll = function()
	{
		_this.myConstruct();
	}	
	
	_this.eventsDefault = function()
	{
		_this.elem[0].removeEventListener( _this.handler.TouchStart, _this.listenerTouchStart , false);
		_this.elem[0].addEventListener( _this.handler.TouchStart, _this.listenerTouchStart , false);
	}
	
	_this.listenerTouchStart = function(event)
	{
		//TODO date global
		_this.currDateTouchStart = new Date();
		_this.currDateTouchStart = _this.currDateTouchStart.getTime();
		_this.currDateTouchEnd = 0;
		_this.touchEndEvent		= false;
		_this.touchMoveEvent	= false;
		
		if( _this.touchable )
        {
			_this.touchStartEvent = event.targetTouches;
			
			//MULTI
			if ( event.targetTouches.length > 2 )
			{
				_this.multiTouchEvent = false;
				_this.removeEventsMultiTouchMoveStart();
				_this.goMultiDrop();
			}else if ( event.targetTouches.length > 1 )
			{
				_this.multiTouchEvent	= event.targetTouches;
				
				if( _this.multiTouchEventOriginalXY )
				{
					_this.multiTouchEventOriginalXY = _this.multiTouchEvent;
				}
				
				_this.eventsMultiTouchMoveStart();
				if(typeof(setForZoom) != "undefined")
				{
					//setForZoom();
				}
			}
			else
			{
				_this.multiTouchEvent		= false;
				_this.removeEventsMultiTouchMoveStart();
				
				_this.doubleTapStart( _this.currDateTouchStart );
				_this.eventsTouchMoveStart();
				_this.eventsTouchEnd();
			}			
        }
		else
		{
			_this.touchStartEvent		= event;			
			
			_this.multiTouchEvent		= false;
			_this.removeEventsMultiTouchMoveStart();
			
			_this.doubleTapStart( _this.currDateTouchStart );
			_this.eventsTouchMoveStart();
			_this.eventsTouchEnd();
		}
		UTILS.preventDefault(event);
		_this.busyActionByEvent();
	}
	
	_this.eventsTouchEnd = function()
	{
		_this.elem[0].removeEventListener( _this.handler.TouchEnd, _this.listenerTouchEnd , false);
		_this.elem[0].addEventListener( _this.handler.TouchEnd, _this.listenerTouchEnd , false);
	}
	
	_this.listenerTouchEnd = function(event)
	{
		_this.currDateTouchEnd = new Date();
		_this.currDateTouchEnd = _this.currDateTouchEnd.getTime();
		
		if( _this.touchable )
        {
			_this.touchEndEvent = event.targetTouches;
			_this.doubleTapEnd(_this.currDateTouchStart);
        }
		else
        {
        	_this.touchEndEvent = event;
    		_this.doubleTapEnd(_this.currDateTouchStart);
        }		
		_this.busyActionByEvent();
	}

	
	_this.eventsTouchMoveStart = function()
	{
		_this.elem[0].removeEventListener( _this.handler.TouchMove, _this.listenerTouchMove , false);
		_this.elem[0].addEventListener( _this.handler.TouchMove, _this.listenerTouchMove , false);
	}
	
	_this.listenerTouchMove = function(event)
	{
	_this.originaleMoveEvent = event;
		if( _this.touchable )
        {
			_this.touchMoveEvent = event.targetTouches;
        }
		else
        {
			_this.touchMoveEvent = event;
        }
		_this.busyActionByEvent();
	}
	
	_this.doubleTapEnd = function( t )
	{
		if(  (t > 0) && ((t - _this.doubleTapTimeEnd) <= _this.goDoubleTouchTime) && _this.isDoubleTapTimeStart )
		{
			_this.isDoubleTapTimeEnd	= true;
			_this.isDoubleTapTimeStart	= false;
			_this.doubleTapTimeStart	= 0;
			_this.doubleTapTimeEnd		= 0;
		}
		else
		{
			_this.doubleTapTimeEnd		= t;
			_this.isDoubleTapTimeStart	= false;
			_this.isDoubleTapTimeEnd	= false;
		}
	}
	
	_this.doubleTapStart = function( t )
	{
		if(  (t > 0) && ((t - _this.doubleTapTimeStart) <= _this.goDoubleTouchTime) )
		{
			_this.isDoubleTapTimeStart	= true;
		}
		else
		{
			_this.doubleTapTimeStart	= t;
			_this.isDoubleTapTimeStart	= false;
		}
	}
	
	_this.removeEventsMultiTouchMoveStart = function()
	{
		_this.elem[0].removeEventListener( _this.handler.TouchMove, _this.listenerMultiTouchMove , false);
	}
	
	_this.eventsMultiTouchMoveStart = function()
	{
		_this.elem[0].removeEventListener( _this.handler.TouchMove, _this.listenerMultiTouchMove , false);
		_this.elem[0].addEventListener( _this.handler.TouchMove, _this.listenerMultiTouchMove , false);
	}
	
	
	_this.listenerMultiTouchMove = function( event )
	{
		_this.multiTouchEvent = event.targetTouches;
	}
	
	_this.busyActionByEvent = function()
	{
		if( _this.isDoubleTapTimeEnd && _this.touchMoveEvent == false )
		{
			//DOUBLE_TAP
			// console.log("DOUBLE_TAP");
			var currEvt = _this.touchStartEvent;
			if( _this.touchable )
			{
				currEvt = _this.touchStartEvent[0]
			}else
			{
				currEvt = _this.touchStartEvent;
			}
			_this.parent.controlManager.scaleGo(false,false,currEvt,1);
			_this.isDoubleTapTimeEnd	= false;
			_this.isDoubleTapTimeStart	= false;
			_this.doubleTapTimeStart	= 0;
			_this.doubleTapTimeEnd		= 0;
		}
		else if( _this.touchStartEvent != false && _this.touchEndEvent == false && _this.touchMoveEvent == false && _this.multiTouchEvent == false )
		{
			// console.log("Touch START");
			//Touch START
			
			if(_this.timTCHEND)
			{
				clearTimeout(_this.timTCHEND);
				_this.timTCHEND = false;
			}
		}
		else if( _this.touchStartEvent != false && _this.touchEndEvent != false && _this.touchMoveEvent == false )
		{
			// console.log("Touch END");
			//Touch END
			
			/*Kev*/
			var didTouchLink;	
			if( _this.touchable ) {
				didTouchLink = _GLOBALS.main.linksManager.isTouchPointALink(_this.touchStartEvent[0].pageX, _this.touchStartEvent[0].pageY);	
			} else {
				didTouchLink = _GLOBALS.main.linksManager.isTouchPointALink(_this.touchStartEvent.pageX,_this.touchStartEvent.pageY);	
			}
			
			if (didTouchLink) {
				_this.timTCHEND = true;
				_this.unbindAll();
			} 				
			/*****/
			
			if(_this.timTCHEND)
			{
				clearTimeout(_this.timTCHEND);
				_this.timTCHEND = false;
			}else
			{			
				_this.timTCHEND = setTimeout(function()
				{
					_this.goTouchEnd();
					clearTimeout(_this.timTCHEND);
					_this.timTCHEND = false;
				},_this.goDoubleTouchTime)
			}
			
		}
		else if( _this.touchStartEvent != false && _this.touchEndEvent == false && _this.touchMoveEvent != false  && _this.multiTouchEvent == false )
		{
			//console.log("DRAG");
			//DRAG
			_this.isDoubleTapTimeEnd	= false;
			_this.isDoubleTapTimeStart	= false;
			_this.doubleTapTimeStart	= 0;
			_this.doubleTapTimeEnd		= 0;
			_this.goTouchDrag();
		}
		else if( _this.touchStartEvent != false && _this.touchEndEvent != false && _this.touchMoveEvent != false  && _this.multiTouchEvent == false )
		{
			//console.log("DROP");
			//DROP
			_this.goTouchDrop();
		}
		else if(  _this.multiTouchEvent != false && _this.touchEndEvent == false && _this.touchMoveEvent != false)
		{
			// console.log("MUTLITOUCHBEGIN");
			
			// console.log(_this.multiTouchEvent[0].pageX);
			// console.log(_this.multiTouchEvent[1].pageX);
			_this.goMultiDrag(_this.multiTouchEvent[0],_this.multiTouchEvent[1]);
		}
		else if(  _this.multiTouchEvent != false &&  _this.touchStartEvent != false && _this.touchEndEvent != false && _this.touchMoveEvent != false )
		{
			// console.log("MUTLITUCHEND");
			_this.removeEventsMultiTouchMoveStart();
			_this.multiTouchEventOriginalXY = false;
			_this.multiTouchEvent			= false;
			_this.touchEndEvent				= false;
			_this.goMultiDrop();
		}
	}
	
	
	_this.goSwipRight = function()
	{
		_this.parent.controlManager.prevPage();
	}
	
	
	_this.goSwipLeft = function()
	{
		_this.parent.controlManager.nextPage();
	}
	
	_this.goNoSwip = function()
	{
		_this.parent.controlManager.initialPage();
	}
	
	_this.goTouchEnd = function()
	{
		_this.parent.controlManager.showTools();
		_this.unbindAll();
	}
	
	
	_this.goTouchDrag = function()
	{
		var eventTouch = _this.touchMoveEvent;
		if( _this.touchable )
		{
			eventTouch = _this.touchMoveEvent[0];
		}
		
		if(!_this.touchMoveEventHist)
		{
			_this.moveTimeStart		= _this.currDateTouchStart;
			_this.mouseStart_x	= eventTouch.pageX;
            _this.mouseStart_y	= eventTouch.pageY;
			_this.touchMoveEventHist++;
			return void(0);
		}
		
		_this.currentMouse_x	= eventTouch.pageX;
		_this.currentMouse_y	= eventTouch.pageY;
        
		_this.moveDiffX = _this.currentMouse_x - _this.mouseStart_x;
        _this.moveDiffY = _this.currentMouse_y - _this.mouseStart_y;
        
        if( !_this.timeLastToAnimat )
		{
			_this.timeLastToAnimat	= new Date();
			_this.timeLastToAnimat	= _this.timeLastToAnimat.getTime();
		}
		
		_this.parent.controlManager.onDragElem( _this.moveDiffX , _this.moveDiffY , eventTouch );
		return void(0);
	}
		
	_this.goTouchDrop = function()
	{
		var swipConfXPourcCurrent = Math.floor((_this.swipConfX/100)*_GLOBALS.CONF.getDocument.width);
		
		_this.parent.controlManager.onDropElem( _this.moveDiffX );
		
		if( Math.abs(_this.moveDiffX) >= swipConfXPourcCurrent && ( _this.currDateTouchEnd-_this.currDateTouchStart ) <= _this.swipConfTime )
		{
			//console.log("Swip");
			if( _this.moveDiffX >= 0 )
			{
				//RIGHT
				_this.goSwipRight();
			}
			else
			{
				//LEFT
				_this.goSwipLeft();				
			}
		}
		else
		{
			var moveConfXPourcCurrent = Math.floor((_this.moveConfX/100)*_GLOBALS.CONF.getDocument.width);
			if( Math.abs(_this.moveDiffX) >= (moveConfXPourcCurrent) )
			{
				//console.log("Swip");
				if( _this.moveDiffX >= 0 )
				{
					//RIGHT
					_this.goSwipRight();
				}
				else
				{
					//LEFT
					_this.goSwipLeft();
				}				
	        }else
	        {
	        	//LEFT
				_this.goNoSwip();
	        }
		}
		UTILS.preventDefault(_this.originaleMoveEvent);
		_this.unbindAll();
	}
	
    _this.goMultiDrag = function(finger0,finger1)
	{
		if(_this.touchStartEvent && _this.touchStartEvent.length>2)
		{
			_this.goMultiDrop();
			return void(0);
		}
		_this.parent.controlManager.scaleGo(finger0,finger1);
	}
	
	_this.goMultiDrop = function()
	{
		_this.parent.controlManager.scaleEnd();
	}
    _this.eventsDefault();
}
_GLOBALS.callbackLoaded("EventManagerFlip");