var Main = function(parent)
{
	var _this 							= this;
	_this.parent						= parent;
	_this.templateManager				= new Object();
	_this.pagesLoader					= new Object();
	_this.xmlLinksList					= new Object();
	/*Kev*/	
	_this.linksManager 					= new Object();
	/*****/
	_this.eventManagerFlip				= new Object();
	_this.currElemPos 					= new Object();
	_this.pagesListConstructor			= new Object();
	_this.carrouselManager				= new Object();
	_this.popupSlideList				= new Object();
	_this.param							= new Object();
	_this.ifMasterManager				= new Object();
	_this.canvasManager					= new CanvasManager(_this);
	_this.controlManager 				= new ControlManager(_this);
	_this.blockCont						= null;
	_this.timeOfResize					= 500;
	_this.timeOfResizeMobile			= 300;
	_this.touchableInfo					= isEventSupported("touchstart",$(document)[0]);	
	_this.supportsOrientationChange;
	
	_this._construct = function()
	{
		return void(0);
	}
	
	_this.init = function()
	{
		_this.templateManager			= new TemplateManager(_this);
		_this.templateManager.listTpl	= _GLOBALS.CONF.getTemplatesList();
		_this.positionForSlider			= new PositionForSlider(_this);
		_this.templateManager.getList(
		function()
		{
			_this.xmlLinksList = new XmlLoader( _this , "xmlLinksList" , _GLOBALS.CONF.xmlNeededToLoadPath , _GLOBALS.CONF.getXmlNeededToLoad() , function()
			{
				var toolsXml = new Array();
				toolsXml.push("tools");
				_this.xmlToolsLoad = new XmlLoader( _this , "xmlToolsLoad" , _GLOBALS.CONF.systemPath+"xml_system/" , toolsXml , function()
				{
					_this.xmlLinksList.getXml.tools = _this.xmlToolsLoad.getXml.tools;
					_this.xmlToolsLoad = null;
					delete _this.xmlToolsLoad;
					_this.param = new Param();
					var langueXml = new Array();
					
					langueXml.push(_GLOBALS.CONF.lngKey+_GLOBALS.CONF.getDocument.lng);
					_this.xmlLangueLoad = new XmlLoader( _this , "xmlLangueLoad" , _GLOBALS.CONF.pathLangue , langueXml , function(info)
					{
						if(!info)
						{
							_GLOBALS.CONF.getDocument.lng = _GLOBALS.CONF.getDocument.lngDefault;
							// console.log(_GLOBALS.CONF.getDocument.lng);
							var langueXml = new Array();
							langueXml.push(_GLOBALS.CONF.lngKey+_GLOBALS.CONF.getDocument.lng);
							_this.xmlLangueLoad = new XmlLoader( _this , "xmlLangueLoad" , _GLOBALS.CONF.pathLangue , langueXml , function(info)
							{
								_this.xmlLinksList.getXml.langue = _this.xmlLangueLoad.getXml[_GLOBALS.CONF.lngKey+_GLOBALS.CONF.getDocument.lng];
								_this.xmlLangueLoad = null;
								delete _this.xmlLangueLoad;
								_this.loadFirstPage(_this.documentReadyCustomPreloader);
								/*Kev*/	 
								_this.linksManager = new LinksManager(_GLOBALS.main.xmlLinksList.getXml.liens);
								/*****/
							})						
						}else
						{
							_this.xmlLinksList.getXml.langue = _this.xmlLangueLoad.getXml[_GLOBALS.CONF.lngKey+_GLOBALS.CONF.getDocument.lng];
							_this.xmlLangueLoad = null;
							delete _this.xmlLangueLoad;
							_this.loadFirstPage(_this.documentReadyCustomPreloader);
							/*Kev*/	 
							_this.linksManager = new LinksManager(_GLOBALS.main.xmlLinksList.getXml.liens);
							/*****/
						}
					});
				});
			});
		});
	}
	
	_this.loadFirstPage = function( callback )
	{
		_this.blockCont = $(".blockCont");
		_this.pagesLoader = new PagesLoader( _this , _this.blockCont );
		_this.pagesLoader.objName = "pagesLoader";		
		_this.pagesLoader.preloadPageFrom(function( listLoadedArray , currentLoaded , currentLoadedNumber , needLoadedNumber )
		{
			if( currentLoadedNumber == needLoadedNumber )
			{
				_this.pagesLoader.imagePreloaded = new Array();
				callback();
			}
		});
	}

	_this.eventBegin = function()
	{
		_this.eventManagerFlip = new EventManagerFlip( _this , $(".listenerFlipable") );
	}
	
	_this.documentReadyCustomPreloader = function()
	{
		_this.param.checkMail();
		_GLOBALS.javascriptInit.stopPreladerSplashScreen(_this.documentReadyCustom)
	}
	
	_this.documentReadyCustom = function()
	{
		_this.eventBegin();
		_this.positionForSlider.alignAll();
		
		_this.supportsOrientationChange = "onorientationchange" in window,orientationEvent = _this.supportsOrientationChange ? "orientationchange" : "resize";
		
		UTILS.onResizeCustom(function()
		{
			_GLOBALS.idResize++;
			_this.positionForSlider.alignAll();
			// _this.carrouselManager.resetAll();
			_this.controlManager.showTools("hide");
		})
		
		if(_this.supportsOrientationChange && 1 === 2)
		{
			$(window).bind("orientationchange",function(e)
			{
				UTILS.onResizedCustom(e);
			});
		}else
		{
			$(window).bind("resize",function(e)
			{
				UTILS.onResizedCustom(e);
			});
		}		

		if( _this.xmlLinksList.getXml.menuParam )
		{
			if( _GLOBALS.CONF.menuCss.menuVisible )
			{
				_this.menuParamManager = new MenuParamManager( _this , "menuParamManager" , _this.xmlLinksList.getXml.menuParam , null );
			}else
			{
				_this.menuParamManager = false;
			}
			
			if( _this.menuParamManager )
			{
				_this.menuParamManager.getMenu();
			}
		}
		
		if( _GLOBALS.CONF.setDisableCarrousel )
		{
			_this.carrouselManager = new CarrouselManager( _this , "carrouselManager" )
			if( _this.carrouselManager )
			{
				_this.carrouselManager.getCarrouselManager();
			}
			UTILS.onResizeCustom(function()
			{
				_this.carrouselManager.resized();
				// $("."+_this.carrouselManager.carrouselClassName).css("bottom",0);
			})			
		}
		
		_this.controlManager.showTools("hide");
		
		//astuceMassi Active touch pour android voir aussi index.html
		$(document)[0].removeEventListener( "touchstart", _GLOBALS.initEventTouch , false);
	}
	
	_this._construct();
}
_GLOBALS.callbackLoaded("Main");