var PagesLoader = function( parent , blockCont )
{
	var _this					= this;
	_this.parent 				= parent;
	_this.objName				= "";
	_this.imagePreloaded 		= new Array();
	_this.lastPage 				= false;
	_this.pageCurrentOriginalIs	= _GLOBALS.CONF.pages.beginPage;
	_this.doublOrSimplePage		= 1;
	_this.pageCreated			= new Object();
	_this.preloadedNext 		= 0;
	_this.preloadedPrev 		= 0;
	_this.qteToLoadTT			= 0;
	_this.pageCreatedIndex		= new Object();
	_this.callBackListOnPageChange = new Array();
	_this.queryByGoToPage		= false;
	_this.noChangeOnResize		= false;
	
	
	
	_this.loadPagFunc = function( i , pathTextureLow , defaultName , preloadBy , qteToLoadTT , currentCallBack  )
	{
		// alert(_this.pageCurrentOriginalIs + " " + _GLOBALS.CONF.pages.beginPage);
		_this.pageCreatedIndex[i] = _this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+i] = new Image();
		_this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+i].onload = function()
		{
			_this.qteToLoadTT++;
			if( currentCallBack )
			{
				currentCallBack( _this.imagePreloaded , _GLOBALS.CONF.pages.defaultName+""+i , preloadBy , _this.qteToLoadTT );
			}
		}
		_this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+i].src = UTILS.getPathImage( pathTextureLow , i );
	}

	_this.preloadPageFrom = function( currentCallBack , timerActivat )
	{
		var preloadBy	= _GLOBALS.CONF.pages.preloadBy;
		
		if( preloadBy > _GLOBALS.CONF.pages.length )
		{
			preloadBy = _GLOBALS.CONF.pages.preloadBy = _GLOBALS.CONF.pages.length;
		}else if( preloadBy < 1)
		{
			preloadBy = _GLOBALS.CONF.pages.preloadBy = 1;
		}
		
		var pathTextureLow	= _GLOBALS.CONF.pages.pathTextureLow;
		var defaultName		= _GLOBALS.CONF.pages.defaultName;
		var pagesLength		= _GLOBALS.CONF.pages.length;
		var currPage		= _this.pageCurrentOriginalIs;		
		var befor			= Math.floor(preloadBy/2);
		var after			= Math.floor(preloadBy/2)+preloadBy%2;
		var countPassAfter	= 0;
		var countPassBefor	= 0;

		if( currPage < 1 )
		{
			currPage = 1;
		}
		else if( currPage > _GLOBALS.CONF.pages.length )
		{
			currPage = _GLOBALS.CONF.pages.length;
		}
		
		if( _GLOBALS.CONF.pages.doublePage && ( currPage !== 1 ) && UTILS.impair(currPage) )
		{
			currPage--;
		}
		
		if( currPage+after > pagesLength )
		{
			after = pagesLength-currPage;
		}
		
		if( befor >= currPage )
		{
			befor = currPage;
		}
		
		var checkDif = (preloadBy) - (after+befor);

		if( after > befor )
		{
			after+=checkDif;
		}else
		{
			befor+=checkDif;
		}

		var addressToLoadAfter = currPage+after;
		var addressToLoadBefor = currPage-befor;		
		_this.qteToLoadTT = 0;
		
		for( var i = addressToLoadBefor ; i <= addressToLoadAfter ; i++ )
		{
			if(i<1)
			{
				continue;
			}
			
			if(!_this.pageCreatedIndex[i])
			{
				_this.loadPagFunc( i , pathTextureLow , defaultName , preloadBy , _this.qteToLoadTT , currentCallBack );
			}			
		}
		
		_this.pageCurrentOriginalIs = currPage;
		_this.preloadedNext = addressToLoadAfter;
		_this.preloadedPrev = addressToLoadBefor;

		for( var J in _this.pageCreatedIndex )
		{
			if( J < addressToLoadBefor )
			{
				if(_this.pageCreatedIndex[J])
				{
					$(_this.pageCreatedIndex[J]).remove();
					_this.pageCreatedIndex[J] = null;
					delete _this.pageCreatedIndex[J];
					_this.removeOtherObjects(J);
				}				
			}
			else if(  J > addressToLoadAfter  )
			{
				if(_this.pageCreatedIndex[J])
				{
					$(_this.pageCreatedIndex[J]).remove();
					_this.pageCreatedIndex[J] = null;
					delete _this.pageCreatedIndex[J];
					_this.removeOtherObjects(J);
				}
			}
		}
		if( !currentCallBack )
		{
			for(var i = addressToLoadBefor ; i <= addressToLoadAfter ; i++ )
			{
				if(i<1)
				{
					continue;
				}
				i = _this.creatNow( i , timerActivat );
			}
			_this.queryByGoToPage = false;
		}
	}
	
	_this.creatNow2 = function(i , timerActivat )
	{
		var timeAnim = 0;
		if( timerActivat )
		{
			var timeAnim = "active";
		}
		if(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i])
		{
			_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs , timeAnim , false);
			return void(0);
		}
		
		_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] = $(_this.parent.canvasManager.texture(i));
		_this.pageCreatedIndex[i] = _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i];
		_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs , 0 , true );
		return void(0);
	}
	
	_this.creatNow = function( i , timerActivat )
	{
		if( _GLOBALS.CONF.pages.doublePage && ( i === 1 ) )
		{
			_this.creatNow2(i , timerActivat );
			return i;
		}else if( _GLOBALS.CONF.pages.doublePage && i === _GLOBALS.CONF.pages.length && UTILS.impair(_GLOBALS.CONF.pages.length) )
		{
			_this.creatNow2(i , timerActivat );
			return i;
		}
		
		if( _GLOBALS.CONF.pages.doublePage && UTILS.impair(i) )
		{
			i++;
		}
		
		_this.creatNow2( i , timerActivat );
		return i;
	}
	
	_this.removeOtherObjects = function(J)
	{
		var finit = 0;
		if(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)])
		{
			if(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)].remove)
			{
				_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)].remove();
			}
			if($(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)]).remove)
			{
				$(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)]).remove();
			}
			
			_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)] = null;
			delete _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)];
			finit++;
		}				
		if(_GLOBALS.main.currElemPos[J])
		{
			_GLOBALS.main.currElemPos[J] = null;
			delete _GLOBALS.main.currElemPos[J];
			finit++;
		}				
		if(_this.parent.canvasManager.textureContextList && _this.parent.canvasManager.textureContextList[_this.parent.canvasManager.canvasKey+J])
		{
			_this.parent.canvasManager.textureContextList[_this.parent.canvasManager.canvasKey+J] = null;
			delete _this.parent.canvasManager.textureContextList[_this.parent.canvasManager.canvasKey+J];
			finit++;
		}
		return finit;	
	}
	
	_this.prevPage = function(nb)
	{
		_this.doublOrSimplePage = _this.checkDoublePrev();
		
		if(nb)
		{
			var nextN = nb;
		}else
		{
			var nextN = _this.pageCurrentOriginalIs - _this.doublOrSimplePage;
		}	
		
		if( _this.lastPage )
		{
			_this.lastPage = false;
			nextN = _this.pageCurrentOriginalIs;
		}
			_GLOBALS.CONF.pages.pageCurrentIs = nextN;
			_this.pageCurrentOriginalIs = nextN;
		_this.preloadPageFrom(false,true);
		_this.onPageIsChanged();		
		return void(0);
	}
	
	_this.nextPage = function(nb)
	{
		_this.doublOrSimplePage = _this.checkDoubleNext();
		
		if(nb)
		{
			var nextN = nb;
		}else
		{
			var nextN = _this.pageCurrentOriginalIs + _this.doublOrSimplePage;
		}		
		
		_GLOBALS.CONF.pages.pageCurrentIs = nextN;
		_this.pageCurrentOriginalIs = nextN;
		
		_this.preloadPageFrom(false,true);
		_this.onPageIsChanged();
		
		return void(0);
	}

	_this.goToPage = function(nb)
	{
		_this.queryByGoToPage = true;
		nb = Math.floor(nb);
		if( nb > _this.pageCurrentOriginalIs )
		{
			_this.nextPage(nb);
		}else if( nb < _this.pageCurrentOriginalIs )
		{
			_this.prevPage(nb);
		}
	}

	_this.onPageIsChanged = function()
	{
		var len = _this.callBackListOnPageChange.length;
		for( var i = 0 ; i < len ; i++ )
		{
			_this.callBackListOnPageChange[i](_this.pageCurrentOriginalIs);
		}
	}
	
	_this.onPageChange = function( callBack )
	{
		_this.callBackListOnPageChange.push( callBack );
	}
	
	_this.checkDoubleNext = function(nb)
	{		
		if(!nb)
		{
			nb = _this.pageCurrentOriginalIs;
		}
		
		if( ( _GLOBALS.CONF.pages.doublePage && nb != 1 && nb < _GLOBALS.CONF.pages.length && !UTILS.impair(nb) ))
		{
			return 2;
			
		}
		return 1;
	}
	
	_this.checkDoublePrev = function()
	{
		if( ( _GLOBALS.CONF.pages.doublePage && _this.pageCurrentOriginalIs != 2 && _this.pageCurrentOriginalIs <= _GLOBALS.CONF.pages.length && !UTILS.impair(_this.pageCurrentOriginalIs) ))
		{
			return 2;
		}
		return  1;
	}
	
	_this.goDoublePage = function( forcePageFormat , noChangeOnResize , reset )
	{
		_GLOBALS.CONF.setDocument();
		
		if(reset)
		{
			forcePageFormat = null;
			forcePageFormat = null;
			noChangeOnResize = null;
			_this.noChangeOnResize = null;
		}
		
		if( forcePageFormat === false || forcePageFormat === true )
		{
			_GLOBALS.CONF.pages.doublePage = _this.forcedPageFormat = forcePageFormat;
			_this.noChangeOnResize = noChangeOnResize;
			UTILS.onResizedCustom(null);
			
		}else if( noChangeOnResize )
		{
			_this.noChangeOnResize = noChangeOnResize;
			UTILS.onResizedCustom(null);
		}
		else if( !_this.noChangeOnResize )
		{
			if( _GLOBALS.CONF.getDocument.height > _GLOBALS.CONF.getDocument.width )
			{
				_GLOBALS.CONF.pages.doublePage = false;
			}else
			{
				_GLOBALS.CONF.pages.doublePage = true;
			}
		}
		
		for( var J = 0 ; J <= _GLOBALS.CONF.pages.length ; J++ )
		{
			if( !_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)] )
			{
				continue;
			}
			
			if($(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)]).remove)
			{
				$(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)]).remove();
			}
			_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)] = null;
			delete _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)];
			_GLOBALS.main.currElemPos[J] = null;
			delete _GLOBALS.main.currElemPos[J];	
			continue;				
		}
        
		_this.parent.canvasManager.textureContextList = null;
		delete _this.parent.canvasManager.textureContextList;
		_this.parent.canvasManager.textureContextList = new Object();
		_this.pageCreated = null;
		_this.pageCreatedIndex = null;
		_this.pageCreatedIndex = new Object();
		_this.pageCreated = new Object();
		
	    _this.parent.positionForSlider.getInfoPosition();
		_this.preloadPageFrom(false,0);
		return _GLOBALS.CONF.pages.doublePage;
	}
}
_GLOBALS.callbackLoaded("PagesLoader");