var PagesLoader = function( parent , blockCont )
{
	var _this					= this;
	_this.parent 				= parent;
	_this.objName				= "";
	_this.imagePreloaded 		= new Array();
	_this.lastPage 				= false;
	_this.pageCurrentOriginalIs	= _GLOBALS.CONF.pages.beginPage;
	_this.doublOrSimplePage		= 1;
	_this.pageCreated			= new Object();
	_this.preloadedNext 		= 0;
	_this.preloadedPrev 		= 0;
	_this.preloadedNextBy 		= 0;
	_this.preloadedPrevBy 		= 0;
	_this.beginCC				= 1;
	
	_this.loadPagFunc = function( i , pathTextureLow , defaultName , imgFormat , preloadBy , qteToLoadTT , currentCallBack  )
	{
		_this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+i] = new Image();
		_this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+i].onload = function()
		{
			_this.qteToLoadTT++;
			if( currentCallBack )
			{
				currentCallBack( _this.imagePreloaded , _GLOBALS.CONF.pages.defaultName+""+i , preloadBy , _this.qteToLoadTT );
			}
		}
		_this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+i].src = pathTextureLow+defaultName+(i)+imgFormat;
	}
	
	_this.preloadPageFrom = function( currentCallBack )
	{
		
		if( _GLOBALS.CONF.pages.preloadBy > _GLOBALS.CONF.pages.length )
		{
			_GLOBALS.CONF.pages.preloadBy = _GLOBALS.CONF.pages.length;
		}
		
		var pathTextureLow	= _GLOBALS.CONF.pages.pathTextureLow;
		var defaultName		= _GLOBALS.CONF.pages.defaultName;
		var imgFormat		= _GLOBALS.CONF.pages.imgFormat;
		var pagesLength		= _GLOBALS.CONF.pages.length;
		var currPage		= _this.pageCurrentOriginalIs;
		var befor			= Math.floor(_GLOBALS.CONF.pages.preloadBy/2);
		var after			= Math.floor(_GLOBALS.CONF.pages.preloadBy/2)+_GLOBALS.CONF.pages.preloadBy%2;
		var countPassAfter	= 0;
		var countPassBefor	= 0;
		
		if( currPage < 1 )
		{
			currPage = 1;
		}
		else if( currPage > _GLOBALS.CONF.pages.length )
		{
			currPage = _GLOBALS.CONF.pages.length;
		}
		
		if( _GLOBALS.CONF.pages.doublePage && ( currPage != 1 ) && UTILS.impair(currPage) )
		{
			currPage--;
		}
		
		
		while( countPassAfter+countPassBefor < _GLOBALS.CONF.pages.preloadBy && countPassAfter+countPassBefor < pagesLength )
		{
			for( var i = currPage ; (i < currPage+after) && (i < pagesLength) ; i++ )
			{
				countPassAfter++;
			}			
			befor += after-countPassAfter;			
			for( var i = currPage ; (i > currPage-befor) && (i > 1) ; i-- )
			{
				countPassBefor++;
			}
			after = befor-countPassBefor;
		}
		
		var addressToLoadAfter = currPage + countPassAfter;
		var addressToLoadBefor = currPage - countPassBefor;

		_this.qteToLoadTT = 0;
		for( var i = currPage ; i <= addressToLoadAfter ; i++ )
		{
			// console.log("After "+i);
			_this.loadPagFunc( i , pathTextureLow , defaultName , imgFormat , _GLOBALS.CONF.pages.preloadBy , _this.qteToLoadTT , currentCallBack );
		}
		for( var i = currPage ; i > addressToLoadBefor ; i-- )
		{
			// console.log("Before "+i);
			_this.loadPagFunc( i , pathTextureLow , defaultName , imgFormat , _GLOBALS.CONF.pages.preloadBy , _this.qteToLoadTT , currentCallBack );
		}		
		
		_this.pageCurrentOriginalIs = currPage;
		_this.preloadedNext = addressToLoadAfter;
		_this.preloadedPrev = addressToLoadBefor;
		
		
		// for( var J in _this.imagePreloaded )
		// {
			// if( J < addressToLoadBefor )
			// {
				// _this.imagePreloaded[J].remove();
				// _this.imagePreloaded[J] = null;
				// delete _this.imagePreloaded[J];
			// }else if(  J > addressToLoadAfter  )
			// {
				// _this.imagePreloaded[J].remove();
				// _this.imagePreloaded[J] = null;
				// delete _this.imagePreloaded[J];
			// }
		// }
	}
	_this.preloadPageFromOLD = function( currentCallBack )
	{
		var qteRetir = 0;
		var qteToLoadTT = 0;
		var qteToLoadCC = 1;
		
		if( _this.pageCurrentOriginalIs < 1 || _this.pageCurrentOriginalIs > _GLOBALS.CONF.pages.length )
		{
			_this.pageCurrentOriginalIs = 1;
		}
		
		if( _GLOBALS.CONF.pages.doublePage && (_this.pageCurrentOriginalIs != 1 ) && UTILS.impair(_this.pageCurrentOriginalIs) )
		{
			_this.pageCurrentOriginalIs--;
		}
		
		if( _GLOBALS.CONF.pages.preloadBy > _GLOBALS.CONF.pages.length )
		{
			_GLOBALS.CONF.pages.preloadBy = _GLOBALS.CONF.pages.length;
		}
		
		_this.preloadedPrevBy = _this.preloadedPrev = Math.floor( _GLOBALS.CONF.pages.preloadBy/2 );
		_this.preloadedNextBy = _this.preloadedNext = Math.abs( _this.preloadedPrev - _GLOBALS.CONF.pages.preloadBy );

		if( ( _this.pageCurrentOriginalIs - _this.preloadedPrev ) < 1  )
		{
			qteRetir = _this.preloadedPrev;
			_this.preloadedPrev = _this.preloadedPrev-(Math.abs(_this.pageCurrentOriginalIs - _this.preloadedPrev)+1);
			
			if( _this.preloadedPrev < 1 )
			{
				_this.preloadedPrev = 1;
			}
			
			qteRetir = qteRetir - _this.preloadedPrev;
			_this.preloadedNext += qteRetir;			
			_this.preloadedPrevBy = _this.preloadedPrev;
		}else
		{
			_this.preloadedPrev = _this.pageCurrentOriginalIs - _this.preloadedPrev;
		}
		
		if( ( _this.pageCurrentOriginalIs + _this.preloadedNext ) > _GLOBALS.CONF.pages.length  )
		{
			var tt = _this.pageCurrentOriginalIs + _this.preloadedNext;
			_this.preloadedNext = Math.abs(_this.preloadedNext - ( tt-_GLOBALS.CONF.pages.length ));
			
			_this.preloadedNextBy = _this.preloadedNext;
			_this.preloadedNext = _this.pageCurrentOriginalIs + _this.preloadedNext;
			
		}else
		{
			_this.preloadedNextBy = _this.preloadedNext;
			_this.preloadedNext = _this.pageCurrentOriginalIs + _this.preloadedNext;
		}
		
		qteToLoadTT = _this.preloadedPrevBy+_this.preloadedNextBy+1;
		
		if(_this.pageCurrentOriginalIs <=1 )
		{
			qteToLoadTT = _this.preloadedPrevBy+_this.preloadedNextBy;	
			_this.beginCC = _this.pageCurrentOriginalIs-_this.preloadedPrev + 1;
		}
		else if ( _this.pageCurrentOriginalIs >= _GLOBALS.CONF.pages.length )
		{
			_this.beginCC = _this.pageCurrentOriginalIs-_this.preloadedPrev+1;
		}else
		{
			_this.beginCC = _this.preloadedPrev;
		}
		
		if( _GLOBALS.CONF.pages.length === 1 )
		{
			qteToLoadTT = 1;
		}
		
		for( var i = _this.beginCC ; i <= _this.preloadedNext ; i++ )
		{		
			if( _this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+i] )
			{
				continue;
			}
			_this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+i] = new Image();
			
			if(currentCallBack)
			{
				$.ajax(
				{
					xhr: function()
					{
						var xhr = new window.XMLHttpRequest();
						//Download progress
						xhr.addEventListener("progress", function(evt)
						{
							if (evt.lengthComputable)
							{
								var percentComplete = evt.loaded / evt.total;
								//Do something with download progress
								//console.log(evt);
							}
						}, false);
						return xhr;
					},type: 'POST',url: _GLOBALS.CONF.pages.pathTextureLow+_GLOBALS.CONF.pages.defaultName+""+(i)+""+_GLOBALS.CONF.pages.imgFormat ,data: {},
					success: function(data)
					{
						_this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+i].src = _GLOBALS.CONF.pages.pathTextureLow+_GLOBALS.CONF.pages.defaultName+""+(i)+""+_GLOBALS.CONF.pages.imgFormat;
						currentCallBack( _this.imagePreloaded , _GLOBALS.CONF.pages.defaultName+""+i , qteToLoadCC , qteToLoadTT );
					}(i)
				});				
			}
			qteToLoadCC++;
			continue;
		}
		
		return void(0);
	}
	
	_this.creatFirstPages = function(callBack)
	{
		if( _GLOBALS.CONF.pages.doublePage && (_this.pageCurrentOriginalIs != 1 ) && UTILS.impair(_GLOBALS.CONF.pages.length) && UTILS.impair(_this.pageCurrentOriginalIs) )
		{
			_this.pageCurrentOriginalIs--;
		}
		
		for( var i = _this.preloadedPrev ; i <= _this.preloadedNext ; i++ )
		{
			if( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] || ( _GLOBALS.CONF.pages.doublePage && i != 1 && i < _GLOBALS.CONF.pages.length && UTILS.impair(i) ) )
			{
				continue;
			}
			
			_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] = $(_this.parent.canvasManager.texture(i));
			_this.parent.actionAfterAnimAppend[i] = (_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i]);
			_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs , 0 );
			continue;
		}
		
		if(callBack)
		{
			callBack();
		}
		return void(0);
	}
	
	_this.creatNextPages = function()
	{
		if( UTILS.impair(_this.preloadedPrev) && _this.preloadedPrev > 2 )
		{
			_this.preloadedPrev--;
		}
		
		for( var i = _this.preloadedPrev ; i <= _this.preloadedNext ; i++ )
		{
			if( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] )
			{
				if( (i === _this.pageCurrentOriginalIs || i === _this.pageCurrentOriginalIs-1 ||  i === _this.pageCurrentOriginalIs+1) && !_GLOBALS.CONF.pages.doublePage )
				{
					_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs );
					continue;
				}
				else if( _GLOBALS.CONF.pages.doublePage && (i===1))
				{
					_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs );
					continue;
				}
				else if( _GLOBALS.CONF.pages.doublePage && i != 1 && i < _GLOBALS.CONF.pages.length && !UTILS.impair(i) )
				{
					_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(i)] , (i) , _this.pageCurrentOriginalIs );
					continue;
				}else if( _GLOBALS.CONF.pages.doublePage && i === _GLOBALS.CONF.pages.length && !UTILS.impair(i) )
				{
					_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs );
				}
				continue;
			}else if( _GLOBALS.CONF.pages.doublePage && i != 1 && i < _GLOBALS.CONF.pages.length && UTILS.impair(i) )
			{			
				continue;
			}

			_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] = $(_this.parent.canvasManager.texture(i));
			_this.parent.actionAfterAnimAppend[i] = (_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i]);
			_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs , 0 );
			continue;
		}
		
		if( Object.keys(_this.pageCreated).length > _GLOBALS.CONF.pages.preloadBy )
		{
			var checkNext = 0;
			for( var J = (_this.preloadedPrev-1) ; J > 0 ; J-- )
			{
				
				if( checkNext >=2 )
				{
					break;
				}
				
				if(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)])
				{
					_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)].remove();
					_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)] = null;
					delete _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)];
				}
				
				if(_GLOBALS.main.currElemPos[J])
				{
					_GLOBALS.main.currElemPos[J] = null;
					delete _GLOBALS.main.currElemPos[J];
				}
				
				if(_this.parent.canvasManager.textureContextList && _this.parent.canvasManager.textureContextList["canvas_"+J])
				{
					_this.parent.canvasManager.textureContextList["canvas_"+J] = null;
					delete _this.parent.canvasManager.textureContextList["canvas_"+J];
				}
				checkNext=0;
				continue;
			}
		}
	}
	
	
	_this.creatPrevPages = function()
	{
		if( UTILS.impair(_this.preloadedNext) && _this.preloadedNext < _GLOBALS.CONF.pages.length && _this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+(_this.preloadedNext+1)])
		{
			_this.preloadedNext++;
		}
		
		for( var i = _this.preloadedPrev ; i <= _this.preloadedNext ; i++ )
		{
			if( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] )
			{
				if( (i === _this.pageCurrentOriginalIs || i === _this.pageCurrentOriginalIs-1 ||  i === _this.pageCurrentOriginalIs+1) && !_GLOBALS.CONF.pages.doublePage )
				{
					_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs );
					continue;
				}
				else if( _GLOBALS.CONF.pages.doublePage && (i===1))
				{
					_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs );
					continue;
				}
				else if( _GLOBALS.CONF.pages.doublePage && i != 1 && i < _GLOBALS.CONF.pages.length && !UTILS.impair(i) )
				{
					_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(i)] , (i) , _this.pageCurrentOriginalIs );
					continue;
				}else if( _GLOBALS.CONF.pages.doublePage && i === _GLOBALS.CONF.pages.length && !UTILS.impair(i) )
				{
					_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs );
				}
				continue;
			}else if( _GLOBALS.CONF.pages.doublePage && i != 1 && i < _GLOBALS.CONF.pages.length && UTILS.impair(i) )
			{			
				continue;
			}

			_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] = $(_this.parent.canvasManager.texture(i));
			_this.parent.actionAfterAnimAppend[i] = (_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i]);
			_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs , 0 );
			continue;
		}
		
		var checkNext = 0;
		
		if( Object.keys(_this.pageCreated).length > _GLOBALS.CONF.pages.preloadBy )
		{
			for( var J = _this.preloadedNext ; J <= _GLOBALS.CONF.pages.length ; J++ )
			{
				if( checkNext >= 2 )
				{
					break;
				}
				
				if( !_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)] )
				{
					checkNext++;
					continue;
				}
				
				_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)].remove();
				_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)] = null;
				delete _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)];
					
				_GLOBALS.main.currElemPos[J] = null;
				delete _GLOBALS.main.currElemPos[J];
					
				_this.parent.canvasManager.textureContextList["canvas_"+J] = null;
				delete _this.parent.canvasManager.textureContextList["canvas_"+J];
				
				checkNext = 0;
				
				continue;
			}
		}
	}
	
	_this.prevPage = function(nb)
	{
		_this.doublOrSimplePage = _this.checkDoublePrev();
		
		if(nb)
		{
			var nextN = nb;
		}else
		{
			var nextN = _this.pageCurrentOriginalIs - _this.doublOrSimplePage;
		}	
		
		if(_this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+nextN])
		{
			if( _this.lastPage )
			{
				_this.lastPage = false;
				nextN = _this.pageCurrentOriginalIs;
			}
			_GLOBALS.CONF.pages.pageCurrentIs = nextN;
			_this.pageCurrentOriginalIs = nextN;
		}
		_this.preloadPageFrom();
		_this.creatPrevPages();		
		return void(0);
	}
	
	_this.nextPage = function(nb)
	{
		_this.doublOrSimplePage = _this.checkDoubleNext();
		
		if(nb)
		{
			var nextN = nb;
		}else
		{
			var nextN = _this.pageCurrentOriginalIs + _this.doublOrSimplePage;
		}		
		
		if(_this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+nextN])
		{
			_GLOBALS.CONF.pages.pageCurrentIs = nextN;
			_this.pageCurrentOriginalIs = nextN;
		}

		_this.preloadPageFrom();
		_this.creatNextPages();
		return void(0);
	}

	_this.goToPage = function(nb)
	{
		if( nb > _this.pageCurrentOriginalIs )
		{
			_this.nextPage(nb);
		}else if( nb < _this.pageCurrentOriginalIs )
		{
			_this.prevPage(nb);
		}
		
	}

	_this.checkDoubleNext = function(nb)
	{		
		if(!nb)
		{
			nb = _this.pageCurrentOriginalIs;
		}
		
		if( ( _GLOBALS.CONF.pages.doublePage && nb != 1 && nb < _GLOBALS.CONF.pages.length && !UTILS.impair(nb) ))
		{
			return 2;
			
		}
		return 1;
	}
	
	_this.checkDoublePrev = function()
	{
		
		if( ( _GLOBALS.CONF.pages.doublePage && _this.pageCurrentOriginalIs != 2 && _this.pageCurrentOriginalIs <= _GLOBALS.CONF.pages.length && !UTILS.impair(_this.pageCurrentOriginalIs) ))
		{
			// console.log(_GLOBALS.CONF.pages.doublePage);
			// console.log(_this.pageCurrentOriginalIs);
			return 2;
		}
		return  1;
	}
	
	_this.goDoublePage = function()
	{
		_GLOBALS.CONF.setDocument();
		
		if( _GLOBALS.CONF.getDocument.height > _GLOBALS.CONF.getDocument.width )
		{
			_GLOBALS.CONF.pages.doublePage = false;
		}else
		{
			_GLOBALS.CONF.pages.doublePage = true;
		}
		
		for( var J = 0 ; J <= _GLOBALS.CONF.pages.length ; J++ )
		{
			if( !_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)] )
			{
				continue;
			}
			_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)].remove();
			_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)] = null;
			delete _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)];
			_GLOBALS.main.currElemPos[J] = null;
			delete _GLOBALS.main.currElemPos[J];	
			continue;				
		}
        
		_this.parent.canvasManager.textureContextList = null;
		delete _this.parent.canvasManager.textureContextList;
		_this.parent.canvasManager.textureContextList = new Object();
		_this.pageCreated = null;
		_this.pageCreated = new Object();
		
	    _this.parent.positionForSlider.getInfoPosition();
		_this.preloadPageFrom();
		_this.creatFirstPages();

		return _GLOBALS.CONF.pages.doublePage;
	}
}