var Param = function()
{
	_this = this;
	
	_this._construct = function()
	{
		// _this.param
		_this.parameters = _GLOBALS.main.xmlLinksList.getXml.param;
		_this.getLogo();
		_this.decalagePage();
		_this.setlngDefault();
		_this.setTitle();
		_this.setNbPages();
		_this.getFond();
		_this.setPages_W_H();
		_this.menu_alpha();
		_this.getMenu();
		_this.getLien();
	}
	
	_this.setNbPages = function()
	{
		var nbPages = _this.parameters.find("parameter[name=nbPages]").attr("value");
		_GLOBALS.CONF.pagesOnInit.length = parseInt(nbPages);
		_GLOBALS.CONF.pages.length = parseInt(nbPages);
	}
	
	_this.setPages_W_H = function()
	{
		// heightB
		var width = _this.parameters.find("parameter[name=widthB]").attr("value");
		var height = _this.parameters.find("parameter[name=heightB]").attr("value");
		_GLOBALS.CONF.pagesOnInit.width = parseInt(width)/2;
		_GLOBALS.CONF.pagesOnInit.height = parseInt(height);
		_GLOBALS.CONF.pages.width = parseInt(width)/2;
		_GLOBALS.CONF.pages.height = parseInt(height);
	}
	
	_this.getFond = function()
	{
		_this.fond = {};
		_this.fond.color = _this.parameters.find("parameter[name=coulFond]").attr("value");
		if( _this.fond.color )
		{
			_this.fond.color = UTILS.hex16(_this.fond.color);
			var elem = $("body");
			var colorRgb = new convertHexToRGB( _this.fond.color , 1 );
			var rad = UTILS.getRadiant( elem , colorRgb[0]+","+colorRgb[1]+","+colorRgb[2] , _this.fond.color , colorRgb[3] , 1 , 50 );
			var elemStyle = elem.attr("style");
			
			if(!elemStyle)
			{
				elem.attr( "style" , rad );
			}else
			{
				elem.attr( "style" , elemStyle+";"+rad );
			}
		}
		else
		{
			_this.fond.color = _this.parameters.find("parameter[name=sBackgroundColor]").attr("value");
			_this.fond.color = parseInt(_this.fond.color,16).toString(16);
			$("body").css(
			{
				backgroundColor:"#"+_this.fond.color
			});
		}
		_GLOBALS.CONF.getDocument.fond = _this.fond;

	}
	
	_this.setTitle = function()
	{
		if($.trim($("title").text()) == "")
		{
			var title = _this.parameters.find("parameter[name=pdf]").attr("value");
			title = title.slice(0,-4);
			$("title").text(title);
		}
	}
	
	_this.setlngDefault = function()
	{
		var urlLng = _GLOBALS.x_y_z_Manager.getVar("lng");
		
		var lng = _GLOBALS.CONF.getDocument.lngDefault;
		
		lngDef = _this.parameters.find("parameter[name=lng]").attr("value");
		if( lngDef && $.trim(lngDef) != "" )
		{
			_GLOBALS.CONF.getDocument.lngDefault = lngDef;
		}else
		{
			lngDef = _GLOBALS.CONF.getDocument.lngDefault;
		}
		
		if( urlLng && $.trim(urlLng) != "" )
		{
			lng = urlLng;
		}
		_GLOBALS.CONF.getDocument.lng = lng;
		_GLOBALS.CONF.lngIsSeted = true;
	}
	
	_this.menu_alpha = function()
	{
		var menu_alpha = _this.parameters.find("parameter[name=menu_alpha]").attr("value");
		_GLOBALS.CONF.menu_alpha = parseInt(menu_alpha);
	}
	
	_this.getMenu = function()
	{
		_this.menu = {};
		_this.menu.menu_alpha			= _this.parameters.find("parameter[name=menu_alpha]").attr("value");
		_this.menu.menu_drop_shadow		= _this.parameters.find("parameter[name=menu_drop_shadow]").attr("value");
		_this.menu.menuVisible			= _this.parameters.find("parameter[name=menuVisible]").attr("value");
		_this.menu.menu_reflect_alpha	= _this.parameters.find("parameter[name=menu_reflect_alpha]").attr("value");
		
		if( _this.menu.menuVisible != "false" )
		{
			_this.menu.menuVisible = true;
			if( _this.menu.menu_alpha )
			{
				_this.menu.menu_alpha = parseInt(_this.menu.menu_alpha)/100;
			}else
			{
				_this.menu.menu_alpha = 1;
			}
			
			if( _this.menu.menu_drop_shadow == "false" )
			{
				_this.menu.menu_drop_shadow = false;
			}else
			{
				_this.menu.menu_drop_shadow = true;
			}
			
			if( !_this.menu.menu_reflect_alpha )
			{
				_this.menu.menu_drop_shadow = "50";
			}
		}
		else
		{
			_this.menu.menuVisible			= false;
			_this.menu.menu_alpha			= 0;
			_this.menu.menu_drop_shadow 	= 0;
			_this.menu.menu_reflect_alpha 	= 0;
		}
		
		
		_GLOBALS.CONF.menuCss = _this.menu;
	}

	_this.decalagePage = function()
	{
		var decalagePage = _this.parameters.find("parameter[name=decalagePage]").attr("value");
		_GLOBALS.CONF.decalagePage = parseInt(decalagePage);
	}

	_this.getLogo = function()
	{
		var getLogo		= _this.parameters.find("parameter[name=logo]").attr("value");
		var getLogoInfo	= {};
		var getLogoLien	= false;
		var logoScale	= false;
		
		if( getLogo && getLogo.length )
		{
			var logoVisible = _this.parameters.find("parameter[name=logoVisible]").attr("value");
			if( logoVisible.length && logoVisible == "false" )
			{
				getLogoInfo.logoName = "";
				getLogoInfo.logoVisible = false;
			}else
			{
				getLogoInfo.logoName = getLogo;
				getLogoInfo.logoVisible = true;
				
				logoScale = _this.parameters.find("parameter[name=logo_scale]").attr("value");
				getLogoLien = _this.parameters.find("parameter[name=logoLien]").attr("value");
				
				var logoMenuURL = _this.parameters.find("parameter[name=logoMenuURL]").attr("value");
				if(logoMenuURL)
				{
					getLogoLien = logoMenuURL;
				}
			}
		}else
		{
			getLogoInfo.logoName		= "";
			getLogoInfo.logoVisible		= false;
		}

		if(logoScale && logoScale == "true")
		{
			getLogoInfo.logoScale = true;
		}

		if(getLogoLien)
		{
			getLogoInfo.logoLien = getLogoLien;
		}
		getLogoInfo.path = "";
		// console.log(getLogoInfo);
		_GLOBALS.CONF.logo = getLogoInfo;
	}

	_this.getLien = function() 
	{
		var getCoulLien = _this.parameters.find("parameter[name=coulLien]").attr("value");
		var getLien = {};
		
		if ( getCoulLien && getCoulLien.length )
		{
        	var hexCoul = UTILS.hex16(getCoulLien);
        	var rgbColor = convertHexToRGB( hexCoul , 0.2);
        
			getLien.coulLien = rgbColor[0] + ',' + rgbColor[1] + ',' + rgbColor[2];
			
		}
		
		_GLOBALS.CONF.lienInfo = getLien;
	}
	
	_this.checkMail = function()
	{
		var mailPath = $.trim(_this.parameters.find("parameter[name=mailPath]").attr("value"));
		var mailInfo = {};
		
		mailInfo.type = "webservice";
		mailInfo.path = "envoiAmi.jsp";
		if(_GLOBALS.isMaster)
		{
			mailInfo.type = "mailto";
		}
		
		if( mailPath == "mailto" )
		{
			mailInfo.type = "mailto";
		}else if( mailPath != "" )
		{
			mailInfo.type = "webservice";
			mailInfo.path = mailPath;
		}
		// console.log(mailInfo);
		_GLOBALS.CONF.mailInfo = mailInfo;
	}
	_this._construct();
}
_GLOBALS.callbackLoaded("Param");