var PositionForSlider = function(parent)
{
	var _this					= this;
	_this.parent				= parent;
	_this.posCurrentOfElem		= 0;
	_this.currElem				= null;
	_this.defaultPosElementY	= 0;
	_this.lastElemIndex			= 0;
	_this.centerPosXe			= 0;
	
	_this.positionIt = function( currElem , index , currPageN , timeConfCustom , appendIt )
	{
		index			= Math.floor(index);
		currPageN		= Math.floor(currPageN);
		timeConfCustom	= (timeConfCustom !== 0)?_GLOBALS.CONF.pages.animationManager.transitionTime:timeConfCustom;
		_GLOBALS.main.currElemPos[index] = (typeof _GLOBALS.main.currElemPos[index] != "object")?new Object():_GLOBALS.main.currElemPos[index];
		_GLOBALS.main.currElemPos[index].y = _this.defaultPosElementY;
		// currElem.clearQueue();
		var funcToCall = false;
		if( index < currPageN )
		{
			funcToCall = _this.posLeft;
		}
		else if( index == currPageN )
		{
			funcToCall = _this.posCenter;
		}
		else if( index > currPageN )
		{
			funcToCall = _this.posRight;
		}

		if(funcToCall)
		{
			var tT = 16;
			if(!timeConfCustom)
			{
				funcToCall( currElem , index , 0 , appendIt );
				return void(0);
			}
			funcToCall( currElem , index , timeConfCustom , appendIt );
		}
		return void(0);
	}

	_this.posRight = function( currElem , index , timeConfCustom , appendIt )
	{
		var transitTo = {x:_GLOBALS.CONF.getDocument.width,y:0};
		if( appendIt )
		{
			currElem.transition(transitTo, 0 , _GLOBALS.CONF.pages.animationManager.swipEasing);
			_this.parent.blockCont.append(currElem);
		}else if( transitTo && !appendIt && _this.parent.pagesLoader.queryByGoToPage )
		{
			currElem.transition(transitTo, timeConfCustom ,_GLOBALS.CONF.pages.animationManager.swipEasing);
		}
		_GLOBALS.main.currElemPos[index].x = _GLOBALS.CONF.getDocument.width;
	}
	
	_this.posCenter = function( currElem , index , timeConfCustom , appendIt )
	{
		if( index == 1 || index == _GLOBALS.CONF.pages.length )
		{
			currElem.clearQueue();
		}
		_this.currElem = null;
		delete _this.currElem;
		var transitTo = {x:_this.centerPosXe,y:0};
		if(_GLOBALS.timerDrawCanvas)
		{
			clearTimeout(_GLOBALS.timerDrawCanvas);
		}

		if(appendIt)
		{
			currElem.transition(transitTo, 0 , _GLOBALS.CONF.pages.animationManager.swipEasing);
			_this.parent.blockCont.append(currElem);
			
			_GLOBALS.timerDrawCanvas = setTimeout(function()
			{
				_this.parent.controlManager.drawCanvas();
			},_GLOBALS.CONF.pages.timeToLoadHD);	
		}else if( transitTo && !appendIt || _this.parent.pagesLoader.queryByGoToPage )
		{
			if( _this.lastElemIndex && _this.lastElemIndex === index ||  _this.parent.pagesLoader.queryByGoToPage )
			{
				currElem.transition(transitTo, timeConfCustom ,_GLOBALS.CONF.pages.animationManager.swipEasing);
			}
			_this.lastElemIndex = index;
		}
		
		_GLOBALS.timerDrawCanvas = setTimeout(function()
		{
			_this.parent.controlManager.drawCanvas();
		},_GLOBALS.CONF.pages.timeToLoadHD);
		_GLOBALS.main.currElemPos[index].x = _this.centerPosXe;
	}
	
	_this.posLeft = function( currElem , index , timeConfCustom , appendIt )
	{
		var transitTo = {x:-_GLOBALS.CONF.getDocument.width,y:0};
		if(appendIt)
		{
			currElem.transition(transitTo, 0 , _GLOBALS.CONF.pages.animationManager.swipEasing);
			_this.parent.blockCont.append(currElem);
			
		}else if( transitTo && !appendIt && _this.parent.pagesLoader.queryByGoToPage )
		{
			currElem.transition(transitTo, timeConfCustom ,_GLOBALS.CONF.pages.animationManager.swipEasing);
		}
		
		_GLOBALS.main.currElemPos[index].x = -_GLOBALS.CONF.getDocument.width;
	}
	
	_this.onDragElem = function( diffPosX )
	{
		clearTimeout(_GLOBALS.timerDrawCanvas);
		if( !_this.currElem )
		{
			_this.currElem = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
		}
		
		_this.posCurrentOfElem = _GLOBALS.main.currElemPos[_this.parent.pagesLoader.pageCurrentOriginalIs].x+diffPosX;
		
		// $("canvas").clearQueue();
		
		_this.currElem.transition(
        {
        	x: _this.posCurrentOfElem
        },0,_GLOBALS.CONF.pages.animationManager.defEasing);
		
		// if(_this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs+1)])
		// {
			// _this.currElemP2 = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs+1)];
			// _this.currElemP2.transition(
			// {
				// x: _this.posCurrentOfElem+_GLOBALS.CONF.getDocument.width
			// },0,_GLOBALS.CONF.pages.animationManager.defEasing);
		// }
		// if(_this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs-1)])
		// {
			// _this.currElemP2 = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs-1)];
			// _this.currElemP2.transition(
			// {
				// x: -_GLOBALS.CONF.getDocument.width+_this.posCurrentOfElem
			// },0,_GLOBALS.CONF.pages.animationManager.defEasing);
		// }
	}
	
	_this.onDropElem = function( diffPosX )
	{
		if( !_this.currElem )
		{
			_this.currElem = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
		}
		_GLOBALS.main.currElemPos[_this.parent.pagesLoader.pageCurrentOriginalIs].x = _GLOBALS.main.currElemPos[_this.parent.pagesLoader.pageCurrentOriginalIs].x+diffPosX;  
	}

	_this.getInfoPosition = function()
	{
		_GLOBALS.CONF.setDocument();
		
		var pageW				= _GLOBALS.CONF.pagesOnInit.width;
		var pageWX2				= pageW;
		var pageH				= _GLOBALS.CONF.pagesOnInit.height;		
		var pageOutW			= _GLOBALS.CONF.pages.width;
		var pageOutH			= _GLOBALS.CONF.pages.height;		
		var docW				= _GLOBALS.CONF.getDocument.width;
		var docH				= _GLOBALS.CONF.getDocument.height;		
		var currScaleOut		= _GLOBALS.CONF.pagesOnInit.currScale;
		var keepMaxResolution	= _GLOBALS.CONF.pages.keepMaxResolution;	
		var nbFloat				= 1000;
		var prW					= 0;
		var prH					= 0;
		var operatDouble		= 1;
		var propCibleScale		= prW;
		_GLOBALS.CONF.pages.currScale	= currScaleOut;		
		
		if( _GLOBALS.CONF.pages.doublePage )
		{
			pageWX2 *= 2;
			operatDouble = 2;
		}
		
		if( ((docH > pageH) && (docW > pageWX2)) && keepMaxResolution )
		{
			pageOutH	= pageH;
			pageOutW	= pageW;
		}else
		{
			prW = Math.floor(docW/pageWX2*nbFloat)/nbFloat;
			prH = Math.floor(docH/pageH*nbFloat)/nbFloat;
			
			if( prW<prH )
			{
				propCibleScale	= prW;            
			}else
			{
				propCibleScale	= prH;
			}
			
			currScaleOut	= propCibleScale;
			pageOutH		= pageH*propCibleScale;
			pageOutW		= (pageWX2*propCibleScale)/operatDouble;
		}
		
		_GLOBALS.CONF.pages.width		= pageOutW;
		_GLOBALS.CONF.pages.height		= pageOutH;
		_GLOBALS.CONF.pages.currScale	= currScaleOut;		
		return void(0);
	}
	
	_this.alignAll = function()
	{
		if( _this.parent.controlManager.resetZoomInfo && !_this.parent.controlManager.autoriseChangePage )
		{
			_this.parent.controlManager.resetZoomInfo();
		}
		_this.parent.pagesLoader.goDoublePage();
		// _this.positionAll();
		return void(0);
	}
	
	
	_this._construct = function()
	{
		return void(0);
	}
	
	_this._construct();
	
}
_GLOBALS.callbackLoaded("PositionForSlider");