var RechercheSlider = function( parent , objName )
{
	var _this = this;
	_this.objName;
	_this.parent;
	_this.tools				= parent.xmlLinksList.getXml.tools;
	_this.contDiv			= "";
	_this.objectToAppend	= "";
	_this.appendToElem		= "";
	_this.thumbs			= {};
	_this.thumbs.width		= "";
	_this.thumbs.height		= "";
	_this.thumbs.marginLeft	= "";
	_this.imgList			= {};
	_this.carrouselClassName	= "";
	_this.thumbSizeW		= 0;
	_this.carrouselTouchMoveIs = false;
	_this.carrouselTouchMovePosXDif = 0;
	_this.carrouselTouchMovePosXDifOriginal = 0;
	_this.posElem			= 0;
	_this.originPosElem		= 0;
	_this.maxthumbs			= 5;
	_this.rotatTime			= 300;
	_this.xTime				= 200;
	_this.goToThumbTimer	= false;
	_this.perspectiveCss3	= "100px";
	_this.degCss3			= "360";
	_this.countNeedLoad		= 0;
	
	_this.addressToLoadAfter = 0;
	_this.addressToLoadBefor = 0;
		
	_this._construct = function()
	{
		if(!_this.checkIfCustomEnabled())
		{
			return false;
		}
		
		_this.constructMenuCss();
	}
	
	_this.transitBasic = function( elem , posOrNeg , timeT )
	{
		if(!timeT)
		{
			timeT = 0;
		}
		elem.clearQueue();
		elem.transition(
		{
			perspective: _this.perspectiveCss3,
			rotateY: _this.degCss3*posOrNeg
		},timeT);
		elem.attr("style",elem.attr("style")+";transform:translateZ(100px)")
		return false;
	}
	
	_this.checkIfCustomEnabled = function()
	{
		var carrousel = _this.tools.find("carrousel");
		_this.carrouselClassName = carrousel.attr("className");
		_this.objectToAppend = "<div class='"+_this.carrouselClassName+"'></div>";
		_this.appendToElem = $(carrousel.attr("appendToElem"));
		
		if( !carrousel.attr("enabled") || carrousel.attr("enabled") == "false" )
		{
			return false;
		}
		// thumbs
		var thumbs = carrousel.find("thumbs");
		_this.thumbs.width = Math.floor(thumbs.attr("width"));
		_this.thumbs.height = Math.floor(thumbs.attr("height"));
		_this.thumbs.marginLeft = Math.floor(thumbs.attr("marginLeft"));
		
		return true;
	}
	
	_this.constructMenuCss = function()
	{
		var carrousel = _this.tools.find("carrousel");
		var defCss = carrousel.children("defCss");
		var styleCur = "";
		if(defCss)
		{
			styleCur = document.createElement("style");
			$(styleCur).append(defCss.text());
			$("head").append($(styleCur));
		}
	}
	
	_this.carrouselTouchMove = function(event,curThis)
	{
		var eventTouch = event;
		if(_GLOBALS.main.touchableInfo)
		{
			eventTouch = eventTouch.originalEvent.touches[0];
		}
		
		_this.carrouselTouchMoveIs = true;	
		_this.carrouselTouchMovePosXDif = (_this.carrouselTouchMovePosXDifOriginal - eventTouch.pageX);
		_this.posElem = _this.originPosElem - _this.carrouselTouchMovePosXDif;
		
		if( _this.posElem >= 0 || _GLOBALS.CONF.getDocument.width >= (_this.thumbSizeW*_GLOBALS.CONF.pages.length))
		{
			_this.posElem = 0;
			_this.originPosElem = 0;
			_this.carrouselTouchMovePosXDifOriginal = eventTouch.pageX;
		}else if( _this.posElem-_GLOBALS.CONF.getDocument.width <= -(_this.thumbSizeW*_GLOBALS.CONF.pages.length) && (_GLOBALS.CONF.getDocument.width<_this.thumbSizeW*_GLOBALS.CONF.pages.length))
		{
			_this.posElem = -(_this.thumbSizeW*_GLOBALS.CONF.pages.length)+_GLOBALS.CONF.getDocument.width;
			_this.originPosElem = _this.posElem;
			_this.carrouselTouchMovePosXDifOriginal = eventTouch.pageX;
			
			//nombre de thumbs par ecran
			var nThumbsLastForGetCurrent = -Math.floor(((_this.posElem/_this.thumbSizeW)-(_this.maxthumbs/2))-1);
			_this.thumbsManager(nThumbsLastForGetCurrent);
		}else
		{
			//nombre de thumbs par ecran
			var nThumbsLastForGetCurrent = -Math.floor(((_this.posElem/_this.thumbSizeW)-(_this.maxthumbs/2))-1);
			_this.thumbsManager(nThumbsLastForGetCurrent);
		}
		$(".sousCarrousel").clearQueue();
		$(".sousCarrousel").transition(
		{
			x:_this.posElem
		}, 0 )
		return false;
	}
	
	_this.carrouselTouchStart = function(event,curThis)
	{
		var eventTouch = event;
		
		if(_GLOBALS.main.touchableInfo)
		{
			eventTouch = eventTouch.originalEvent.touches[0];
		}
		// var target = event.target || event.srcElement;
		// event est l'objet Event
		
		_this.carrouselTouchMovePosXDifOriginal = eventTouch.pageX;
		
		var elemPos = $(".sousCarrousel").position();
		var elemPosX = elemPos.left;
		_this.originPosElem = elemPosX;
		
		if(_GLOBALS.main.touchableInfo)
		{
			curThis.bind( "touchmove" , function(e)
			{
				_this.carrouselTouchMove(e);
			})
		}else
		{
			curThis.bind( "mousemove" , function(e)
			{
				_this.carrouselTouchMove(e);
			})
		}
		

		UTILS.preventDefault(event);
		return false;
	}
	
	_this.goToThumb = function( gotoPage , target )
	{
		if(!target)
		{
			var target = $(".sousCarrousel").find("[gotopage="+gotoPage+"]");
			if( !target.length )
			{
				return void(0);
			}
		}
		
		var currPos	= 0;
		var leftP	= 0;

		currPos		= $(target).position();
		var targetX	= leftP = currPos.left;
		
		if( leftP < _this.originalPosThumbCenter )
		{
			leftP = 0;
		}else
		{
			leftP = leftP - _this.originalPosThumbCenter;
		}
		$(".sousCarrousel").clearQueue();
		$(".sousCarrousel").transition(
		{
			x:-leftP
		}, _this.xTime )

		
		$(".positioneur").clearQueue();
		
		var posX =  (targetX)
		var scaleW = 2;
		var xOrigine = 0;
		var checPair = UTILS.byPageIfDouble(gotoPage);
		if(checPair.isDouble)
		{
			scaleW = 2;	
		}
		else
		{
			scaleW = 1;
		}

		$(".positioneur").transition(
		{
			x:posX,
			scale:[scaleW,1]
		},_this.xTime)
		
		_this.lastTarget = $(target);
		return false;
	}
	
	_this.carrouselTouchEnd = function(event,curThis)
	{
		var eventTouch = event;
		if(_GLOBALS.main.touchableInfo)
		{
			eventTouch = eventTouch.originalEvent.touches[0];
		}
		
		_this.carrouselTouchMovePosXDifOriginal = 0;
		if(_GLOBALS.main.touchableInfo)
		{
			curThis.unbind("touchmove");
		}else
		{
			curThis.unbind("mousemove");
		}
		
		if(_this.carrouselTouchMoveIs)
		{
			_this.carrouselTouchMovePosXDif = 0;
			_this.carrouselTouchMoveIs = false;
			return void(0);
		}
		
		var target = event.target || event.srcElement;		
		
		var gotoPage = $(target).attr("gotopage");
		if(gotoPage)
		{
			_GLOBALS.main.controlManager.goToPage(gotoPage);
			_this.thumbsManager(gotoPage, function()
			{
				_this.goToThumb( gotoPage , target );
			})
		}

		UTILS.preventDefault(event);
	}
	
	
	_this.loadThumbImg = function( i , diapo , addTo , thumbSizeW , needToload , callBack )
	{
		if(_this.imgList[i])
		{
			_this.imgList[i].askForDeletable = false;
			_this.countNeedLoad++;
			if( _this.countNeedLoad >= needToload && callBack )
			{
				callBack();
			}
			return void(0);
		}
		var posXImg = 0;
		var currImg = new Image();
		$(currImg).attr("goToPage",i);
		$(currImg).clearQueue();
		
		var checPair = UTILS.byPageIfDouble(i);
		if(checPair.isDouble)
		{
			if( checPair.isDoublePage[1] )
			{
				posXImg = (i-1)*thumbSizeW+((_this.thumbs.marginLeft)/2);
			}else
			{
				posXImg = ((i-1)*thumbSizeW-((_this.thumbs.marginLeft)))-1;
			}			
		}
		else
		{
			posXImg = (i-1)*thumbSizeW+((_this.thumbs.marginLeft)/2);
		}
		
		
		$(currImg).transition(
		{
			left:posXImg
		},0);
		
		_this.transitBasic( $(currImg) , 1 );
		currImg.onload = function()
		{
			_this.countNeedLoad++;
			var testFinde = addTo.find("[goToPage="+i+"]");
			if(!testFinde.length)
			{
				addTo.append($(this));
			}
			
			_this.transitBasic( $(this) , 0 , _this.rotatTime );
			if( _this.countNeedLoad >= needToload && callBack )
			{
				callBack();
			}			
		}
		currImg.src = UTILS.getPathImage( diapo , i );
		_this.imgList[i] = currImg;
		return void(0);
	}
	
	_this.resetAll = function()
	{
		if(_this.imgList)
		{
			//cleanOthers
			for( var J in _this.imgList )
			{
				$(".sousCarrousel").children("img").remove();
				_this.imgList[J] = null;
				delete _this.imgList[J];
			}
			// _this.thumbsManager();
			// _this.goToThumb(  _GLOBALS.main.pagesLoader.pageCurrentOriginalIs+1  );
		}
	}
	
	_this.thumbsManager = function( loadAddThumbs , callBack )
	{
		if(_this.imgList)
		{
			//cleanOthers
			for( var J in _this.imgList )
			{
				if( J < _this.addressToLoadBefor )
				{
					_this.imgList[J].askForDeletable = true;
					$(_this.imgList[J]).clearQueue();
					$(_this.imgList[J]).transition(
					{
						rotateY: _this.degCss3
					},_this.rotatTime,function()
					{
						var currJ = $(this).attr("goToPage");
						if(!_this.imgList[currJ] || !_this.imgList[currJ].askForDeletable )
						{
							return false;
						}
						$(this).remove();
						_this.imgList[currJ] = null;
						delete _this.imgList[currJ];
						return false;
					});
				}else if(  J > _this.addressToLoadAfter )
				{
					_this.imgList[J].askForDeletable = true;
					$(_this.imgList[J]).clearQueue();
					$(_this.imgList[J]).transition(
					{
						rotateY: _this.degCss3
					},_this.rotatTime,function()
					{
						var currJ = $(this).attr("goToPage");
						if(!_this.imgList[currJ] || !_this.imgList[currJ].askForDeletable )
						{
							return false;
						}
						$(this).remove();
						_this.imgList[currJ] = null;
						delete _this.imgList[currJ];
						return false;
					});
				}
			}
		}
		var currPage = 0;
		if( loadAddThumbs )
		{
			currPage = Math.floor(loadAddThumbs);
		}else
		{
			currPage = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
		}
		
		var diapo		= _GLOBALS.CONF.pages.Diapo;
		var thumbSizeW	= _this.thumbSizeW;
		var pagesLength	= _GLOBALS.CONF.pages.length;
		
		if( _this.maxthumbs > pagesLength )
		{
			_this.maxthumbs = pagesLength;
		}
		else if( _this.maxthumbs < 1)
		{
			_this.maxthumbs = 1;
		}		
		
		var befor = Math.floor(_this.maxthumbs/2);
		var after = Math.floor(_this.maxthumbs/2)+_this.maxthumbs%2;
		var addTo = $(".sousCarrousel");
		var countPassAfter = 0;
		var countPassBefor = 0;
		
		if( currPage+after > pagesLength )
		{
			after = pagesLength-currPage;
		}
		
		if( befor > currPage )
		{
			befor = currPage-1;
		}
		
		var checkDif = _this.maxthumbs - (after+befor);
		
		if( after > befor )
		{
			after+=checkDif;
		}else
		{
			befor+=checkDif;
		}
		
		_this.addressToLoadAfter = currPage+after;
		_this.addressToLoadBefor = currPage-befor;
		
		_this.countNeedLoad = 0;
		
		for( var i = currPage ; i <= _this.addressToLoadAfter ; i++ )
		{
			_this.loadThumbImg( i , diapo, addTo , thumbSizeW , after+befor , callBack );
		}

		for( var i = currPage ; i >= _this.addressToLoadBefor ; i-- )
		{
			_this.loadThumbImg( i , diapo , addTo , thumbSizeW , after+befor , callBack );
		}
		return false;
	}
	
	_this.resized = function()
	{
		_this.thumbSizeW = (_this.thumbs.width)+(_this.thumbs.marginLeft)*2;
		//nombre de thumbs par ecran
		_this.originalPosThumb = Math.floor(_GLOBALS.CONF.getDocument.width/_this.thumbSizeW)+1;
		
		if( _this.maxthumbs < _this.originalPosThumb )
		{
			_this.maxthumbs =_this.originalPosThumb;
		}
		_this.originalPosThumbCenter = (Math.floor(_GLOBALS.CONF.getDocument.width/2))-(_this.thumbSizeW/2);
		return false;
	}
	
	_this.getCarrouselManager = function()
	{
		_this.resized();
		var pagesLength	= _GLOBALS.CONF.pages.length;
		var thumbSizeW	= _this.thumbSizeW;
		var sizeCarW	= pagesLength*thumbSizeW;
		var diapo		= _GLOBALS.CONF.pages.Diapo;
		var objIntern	= $(_this.objectToAppend);
		
		objIntern.append("<div class='sousCarrousel' style='height:100%;width:"+sizeCarW+"px;' ><div class='positioneur' ></div></div>");
		
		_this.appendToElem.append(objIntern);
		$(".positioneur").css(
		{
			width:_this.thumbs.width,
			transformOrigin: '0px 0px'
		});
		if(_GLOBALS.main.touchableInfo)
		{
			$("."+_this.carrouselClassName).bind('touchstart', function(event)
			{
				_this.carrouselTouchStart( event , $(this) );	
			});
			
			$("."+_this.carrouselClassName).bind('touchend', function(event)
			{
				_this.carrouselTouchEnd( event , $(this) );	
			});
		}else
		{
			$("."+_this.carrouselClassName).bind("mousedown",function(event)
			{
				_this.carrouselTouchStart( event , $(this) );
			})
			
			$("."+_this.carrouselClassName).bind("mouseup",function(event)
			{
				_this.carrouselTouchEnd( event , $(this) );
			})
		}
		
		_this.thumbsManager();
		
		_GLOBALS.main.pagesLoader.onPageChange(function(currPage)
		{
			if(_this.goToThumbTimer)
			{
				clearTimeout(_this.goToThumbTimer);
			}
			
			_this.goToThumbTimer = setTimeout(function()
			{
				_this.thumbsManager(currPage, function()
				{
					if(_GLOBALS.main.controlManager.showToolsInfo)
					{
						_this.goToThumb( currPage );
					}
				})
			},60)		
		});
		
		_GLOBALS.main.controlManager.onShowTools(function(info)
		{
			if(info)
			{
				_this.thumbsManager();
				_this.goToThumb(  _GLOBALS.main.pagesLoader.pageCurrentOriginalIs  );
			}
		});
		
		return false;
	}
	
	return _this._construct();	
}
_GLOBALS.callbackLoaded("RechercheSlider");