var CarrouselManager = function( parent , objName )
{
	var _this = this;
	_this.objName = objName;
	_this.parent;
	_this.tools				= parent.xmlLinksList.getXml.tools;
	_this.contDiv			= "";
	_this.objectToAppend	= "";
	_this.appendToElem		= "";
	_this.thumbs			= {};
	_this.thumbs.width		= "";
	_this.thumbs.height		= "";
	_this.thumbs.marginLeft	= "";
	_this.imgList			= {};
	_this.carrouselClassName	= "";
	_this.thumbSizeW		= 0;
	_this.carrouselTouchMoveIs = false;
	_this.carrouselTouchMovePosXDif = 0;
	_this.carrouselTouchMovePosXDifOriginal = 0;
	_this.posElem			= 0;
	_this.originPosElem		= 0;
	_this.maxthumbs			= 5;
	_this.rotatTime			= 0.2;
	_this.xTime				= 200;
	_this.goToThumbTimer	= false;
	_this.perspectiveCss3	= "100px";
	_this.degCss3			= "90";
	_this.countNeedLoad		= 0;
	_this.countNeedLoadonLoading = 0;
	_this.carrousel			= false
	_this.addressToLoadAfter = 0;
	_this.addressToLoadBefor = 0;
	_this.timeScroll		= 0;
	_this.languePage		= _GLOBALS.main.xmlLinksList.getXml.langue.find("menuitem[index=93]").attr("label");
	_this.retirateur = 0;
	_this.sousCarrouselWidth = 0;
	_this.positioneurInfo	= {};
	_this._construct = function()
	{
		_this.resetDataSwip();
		if(!_this.checkIfCustomEnabled())
		{
			return false;
		}
		
		_this.constructMenuCss();
	}

	_this.transitBasic = function( elem , posOrNeg , timeT )
	{
		if( _GLOBALS.userAgentManager.userAgent.name == "ipad" || _GLOBALS.userAgentManager.userAgent.type != "phone" )
		{
			var vT = (!timeT)?0:timeT;		
			setTimeout(function()
			{
				elem.css(
				{
					transition: "all "+vT+"s",
					y: 150*posOrNeg
				})
			},vT);
		}
		
		return false;
	}
	
	
	_this.checkIfCustomEnabled = function()
	{
		var carrousel = "";
		if(!_this.carrousel)
		{
			carrousel = _this.carrousel = _this.tools.find("carrousel");
		}else
		{
			carrousel = _this.carrousel;
		}
		
		_this.carrouselClassName = carrousel.attr("className");
		_this.sousCarrousel = _this.carrouselClassName+" .sousCarrousel";
		_this.objectToAppend = $("<div class='"+_this.carrouselClassName+"'></div>");
		_this.appendToElem = $(carrousel.attr("appendToElem"));
		
		if( !carrousel.attr("enabled") || carrousel.attr("enabled") == "false" )
		{
			return false;
		}
		// thumbs
		var thumbs = carrousel.find("thumbs");
		_this.thumbs.width = Math.floor(thumbs.attr("width"));
		_this.thumbs.height = Math.floor(thumbs.attr("height"));
		_this.thumbs.marginLeft = Math.floor(thumbs.attr("marginLeft"));
		
		return true;
	}
	
	_this.constructMenuCss = function()
	{
		var carrousel = "";
		if(!_this.carrousel)
		{
			carrousel = _this.carrousel = _this.tools.find("carrousel");
		}else
		{
			carrousel = _this.carrousel;
		}
		var defCss = carrousel.children("defCss");
		var styleCur = "";
		if(defCss)
		{
			styleCur = document.createElement("style");
			$(styleCur).append(defCss.text());
			$("head").append($(styleCur));
		}
	}
	
	_this.listenDiffX			= 100;
	_this.listenDiffXSwip		= 10;
	_this.listenDiffTimeSwip	= 2500;
	
	_this.resetDataSwip = function()
	{
		_this.listenDiffXArr		= new Array();
		_this.listenDiffTimeArr		= new Array();
		_this.diffXOrg				= 0;
		_this.diffX					= 0;
		_this.timeCurr				= 0;
		_this.timeDiffOrig			= 0;
		_this.timeDiff				= 0;
	}
	
	_this.carrouselTouchMove = function( event , curThis )
	{
		//nombre de thumbs par ecran
		var nThumbsLastForGetCurrent = -Math.floor(((parseFloat(_this.posElem)/_this.thumbSizeW)-(_this.maxthumbs/2))-1);
		if(nThumbsLastForGetCurrent<1)
		{
			nThumbsLastForGetCurrent = 1;
		}
		_this.thumbsManager(nThumbsLastForGetCurrent);
		
		_this.posElem =  _this.originPosElem + (_this.carrouselTouchMovePosXDif - _this.carrouselTouchMovePosXDifOriginal);
		if(_this.posElem >= _GLOBALS.CONF.getDocument.width/2)
		{
			_this.originPosElem	= _GLOBALS.CONF.getDocument.width/2;
			_this.posElem		= _this.originPosElem;
			_this.carrouselTouchMovePosXDifOriginal	= _this.carrouselTouchMovePosXDif;
		}
		else if(_this.posElem <= _GLOBALS.CONF.getDocument.width/2 - _this.sousCarrouselWidth )
		{
			_this.originPosElem				= _GLOBALS.CONF.getDocument.width/2 - _this.sousCarrouselWidth;
			_this.posElem					= _this.originPosElem;
			_this.carrouselTouchMovePosXDifOriginal	= _this.carrouselTouchMovePosXDif;
		}
		
		curThis.clearQueue();
		
		curThis.transition(
		{
			x:_this.posElem
		},0);
	}
	
	_this.goToThumb = function( gotoPage )
	{
		var sousElem = $("."+_this.sousCarrousel);
		var target = sousElem.find("li[gotopage="+gotoPage+"]");
		
		if( !target.length )
		{
			return void(0);
		}

		var currSousX = _this.posElem;
		var xToPos = _this.imgList[gotoPage].infoPos.x;
		
		var xToL = xToPos - currSousX;
		var scaleW = 2;
		var checPair = UTILS.byPageIfDouble(parseInt(gotoPage));
		var widthCarrouselClassName;
		
		if(checPair.isDouble)
		{
			scaleW = 2;
			widthCarrouselClassName = (_GLOBALS.CONF.getDocument.width/2)-(_this.thumbs.width*checPair.isDoublePage[1]);
			xToPos -= (_this.thumbs.width*checPair.isDoublePage[2]);
		}
		else
		{
			scaleW = 1;
			widthCarrouselClassName = (_GLOBALS.CONF.getDocument.width/2)-(_this.thumbs.width/2);
		}
		
		_this.posElem = (xToL-widthCarrouselClassName);
		sousElem.clearQueue();
		
		sousElem.transition(
		{
			x : -(currSousX+xToL-widthCarrouselClassName)
		},200);
		
		_this.positioneurInfo.X = xToPos;
		_this.positioneurInfo.W = scaleW*_this.thumbs.width;
		
		$(".positioneur").css(
		{
			x: _this.positioneurInfo.X,
			width:_this.positioneurInfo.W
		})
		
		_this.posElem = -(currSousX+xToL-widthCarrouselClassName);
		_this.originPosElem =  -(currSousX+xToL-widthCarrouselClassName);
	}
	
	_this.loadThumbImg = function( i , diapo , addTo , thumbSizeW , needToload , callBack )
	{
		if(_this.imgList[i])
		{
			_this.imgList[i].askForDeletable = false;
			_this.countNeedLoadonLoading++;
			if( parseInt(_this.countNeedLoad) === parseInt(_this.countNeedLoadonLoading) && callBack )
			{
				callBack();
			}
			return void(0);
		}

		var posXImg = 0;
		var currImg = new Image();
		var onClick = "";
		var currImgLi = "<li "+onClick+" ><span goToPage='"+i+"'>"+UTILS.byOffsetIndex(i)+"</span></li>"
		currImgLi = $(currImgLi);
		$(currImg).attr("goToPage",i);
		currImgLi.attr("goToPage",i);
		currImgLi.clearQueue();
		
		var checPair = UTILS.byPageIfDouble(i);
		if(checPair.isDouble)
		{
			if( checPair.isDoublePage[1] )
			{
				posXImg = (i-1)*thumbSizeW+((_this.thumbs.marginLeft)/2);
			}else
			{
				posXImg = ((i-1)*thumbSizeW-((_this.thumbs.marginLeft)))-1;
			}			
		}
		else
		{
			posXImg = (i-1)*thumbSizeW+((_this.thumbs.marginLeft)/2);
		}
		
		currImgLi.css(
		{
			x:posXImg
		})		
		
		_this.transitBasic( currImgLi , 1 );
		currImg.onload = function()
		{
			_this.countNeedLoadonLoading++;
			var testFinde = addTo.find("[goToPage="+i+"]");
			
			if(!testFinde.length)
			{
				currImgLi.append($(this));
				addTo.append(currImgLi);
			}
			_this.transitBasic( currImgLi , 0 , _this.rotatTime );
			if( parseInt(_this.countNeedLoad) === parseInt(_this.countNeedLoadonLoading) && callBack )
			{
				callBack();
			}			
		}
		currImg.src = UTILS.getPathImage( diapo , i );
		_this.imgList[i] = currImgLi;		
		_this.imgList[i].infoPos = {};
		_this.imgList[i].infoPos.x = posXImg;
		
		return void(0);
	}

	_this.reposImg = function()
	{
		var thumbSizeW = _this.thumbSizeW;
		for( var J in _this.imgList )
		{
			var checPair = UTILS.byPageIfDouble(J);
			if(checPair.isDouble)
			{
				if( checPair.isDoublePage[1] )
				{
					posXImg = (J-1)*thumbSizeW+((_this.thumbs.marginLeft)/2);
				}else
				{
					posXImg = ((J-1)*thumbSizeW-((_this.thumbs.marginLeft)))-1;
				}			
			}
			else
			{
				posXImg = (J-1)*thumbSizeW+((_this.thumbs.marginLeft)/2);
			}
			
			_this.imgList[J].css(
			{
				x:posXImg
			})
			_this.imgList[J].infoPos = {};
			_this.imgList[J].infoPos.x = posXImg;
		}
	}
	
	_this.resetAll = function()
	{
		if(_this.imgList)
		{
			//cleanOthers
			for( var J in _this.imgList )
			{
				var curILi = $("."+_this.sousCarrousel).children("li[gotopage]");
				curILi.remove();
				_this.imgList[J] = null;
				delete _this.imgList[J];
			}
		}
	}
	
	_this.removeThumb = function(J)
	{
		setTimeout(function()
		{
			var currJ = $(_this.imgList[J]).attr("goToPage");
			
			if(!_this.imgList[currJ] || !_this.imgList[currJ].askForDeletable )
			{
				return false;
			}
			
			$(_this.imgList[J]).remove();
			_this.imgList[currJ] = null;
			delete _this.imgList[currJ];
		},_this.rotatTime);	
	}
	
	_this.thumbsManager = function( loadAddThumbs , callBack )
	{
		if(_this.imgList)
		{
			for( var J in _this.imgList )
			{
				if( J < _this.addressToLoadBefor || J > _this.addressToLoadAfter )
				{
					_this.imgList[J].askForDeletable = true;
					_this.transitBasic( $(_this.imgList[J]) , 0 , _this.rotatTime );					
					_this.removeThumb(J);
				}
			}
		}
		
		var currPage = 0;
		
		if( loadAddThumbs )
		{
			currPage = Math.floor(loadAddThumbs);
		}else
		{
			currPage = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
		}
		
		var diapo		= _GLOBALS.CONF.pages.Diapo;
		var thumbSizeW	= _this.thumbSizeW;
		var pagesLength	= _GLOBALS.CONF.pages.length;
		
		if( _this.maxthumbs > pagesLength )
		{
			_this.maxthumbs = pagesLength;
		}
		else if( _this.maxthumbs < 1)
		{
			_this.maxthumbs = 1;
		}		
		
		var befor = Math.floor(_this.maxthumbs/2);
		var after = Math.floor(_this.maxthumbs/2)+_this.maxthumbs%2;
		var addTo = $("."+_this.sousCarrousel);
		var countPassAfter = 0;
		var countPassBefor = 0;
		
		if( currPage+after > pagesLength )
		{
			after = pagesLength-currPage;
		}
		
		if( befor > currPage )
		{
			befor = currPage-1;
		}
		
		var checkDif = _this.maxthumbs - (after+befor);
		
		if( after > befor )
		{
			after+=checkDif;
		}else
		{
			befor+=checkDif;
		}
		
		_this.addressToLoadAfter = currPage+after;
		_this.addressToLoadBefor = currPage-befor;
		
		_this.countNeedLoadonLoading = 0;
		_this.countNeedLoad = 0;
		_this.countNeedLoad = after+befor;
		
		for( var i = currPage ; i <= _this.addressToLoadAfter && i!==0 && i <= pagesLength ; i++ )
		{
			_this.loadThumbImg( i , diapo, addTo , thumbSizeW , after+befor , callBack );
		}

		for( var i = currPage ; i >= _this.addressToLoadBefor  && i!==0 && i <= pagesLength ; i-- )
		{
			_this.loadThumbImg( i , diapo , addTo , thumbSizeW , after+befor , callBack );
		}
		
		return false;
	}
	
	_this.resized = function()
	{
		_this.thumbSizeW = (_this.thumbs.width)+(_this.thumbs.marginLeft)*2;
		//nombre de thumbs par ecran
		_this.originalPosThumb = Math.floor(_GLOBALS.CONF.getDocument.width/_this.thumbSizeW)+1;
		
		if( _this.maxthumbs < _this.originalPosThumb )
		{
			_this.maxthumbs =_this.originalPosThumb;
		}
		_this.originalPosThumbCenter = (Math.floor(_GLOBALS.CONF.getDocument.width/2))-(_this.thumbSizeW/2);
		return false;
	}
	
	_this.setInfoImg = function(elem)
	{
		_this.thumbinfo = elem;
		_this.thumbs.width = Math.floor(_this.thumbinfo.width);
		_this.thumbs.height = Math.floor(_this.thumbinfo.height);
		_this.imgByStep = Math.floor(_GLOBALS.CONF.getDocument.width/(_this.thumbinfo.width*_this.ifDouble));
	}
	
	_this.checkImageInfo = function(callback)
	{
		var imagec = new Image();
		var checkD = UTILS.byPageIfDouble(1);
		if( checkD["isDoubleDoc"] )
		{
			_this.ifDouble = 2;
		}
		
		imagec.onload = function()
		{
			_this.thumbinfo = this;
			_this.thumbs.width = Math.floor(_this.thumbinfo.width);
			_this.thumbs.height = Math.floor(_this.thumbinfo.height);
			
			_this.imgByStep = Math.floor(_GLOBALS.CONF.getDocument.width/(_this.thumbinfo.width*_this.ifDouble));
			if(callback)
			{
				callback();
			}
		}
		imagec.src = UTILS.getPathImage( _GLOBALS.CONF.pages.Diapo , 1 );		
	}
	
	
	_this.creatEvent = function()
	{
		_this.carrouselTouchMovePosXDif			= 0;
		_this.carrouselTouchMovePosXDifOriginal	= 0;
		
		var elem = $("."+_this.carrouselClassName);
		var elemSous = $("."+_this.sousCarrousel);
		if( _GLOBALS.touchableInfo )
		{
			elem.unbind("touchstart");
			elem.bind("touchstart", function(e)
			{
				_this.carrouselTouchMoveIs = false;
				if( !_this.carrouselTouchMovePosXDifOriginal )
				{
					_this.carrouselTouchMovePosXDifOriginal	= e.originalEvent.touches[0].pageX;
				}
				
				$(this).unbind("touchmove");
				$(this).bind("touchmove", function(eMove)
				{
					_this.carrouselTouchMoveIs = true;
					_this.carrouselTouchMovePosXDif = eMove.originalEvent.touches[0].pageX;				
					_this.carrouselTouchMove( eMove , elemSous);
					UTILS.preventDefault(eMove);
				});
				
				UTILS.preventDefault(e);
			});
			
			elem.unbind("touchend");
			elem.bind("touchend", function(e)
			{
				if(!_this.carrouselTouchMoveIs)
				{
					_this.carrouselTouchMoveIs = false;
					var gtOpage = parseInt($(e.target).attr("gotopage"));
					if(gtOpage && gtOpage > 0 )
					{
						_GLOBALS.main.controlManager.goToPage(gtOpage);
					}
				}
				
				_this.carrouselTouchMovePosXDif			= 0;
				_this.carrouselTouchMovePosXDifOriginal	= 0;
				_this.originPosElem = _this.posElem;
				$(this).unbind("mousemove");				
			});
		}else
		{
			elem.unbind("mousedown");
			elem.bind("mousedown", function(e)
			{
				_this.carrouselTouchMoveIs = false;
				if( !_this.carrouselTouchMovePosXDifOriginal )
				{
					_this.carrouselTouchMovePosXDifOriginal	= e.pageX;
				}
				
				$(this).unbind("mousemove");
				$(this).bind("mousemove", function(eMove)
				{
					_this.carrouselTouchMoveIs = true;
					_this.carrouselTouchMovePosXDif = eMove.pageX;				
					_this.carrouselTouchMove( eMove , elemSous);
					UTILS.preventDefault(eMove);
				});
				
				UTILS.preventDefault(e);
			});
			
			elem.unbind("mouseup");
			elem.bind("mouseup", function(e)
			{
				if(!_this.carrouselTouchMoveIs)
				{
					_this.carrouselTouchMoveIs = false;
					var gtOpage = parseInt($(e.target).attr("gotopage"));
					if(gtOpage && gtOpage > 0 )
					{
						_GLOBALS.main.controlManager.goToPage(gtOpage);
					}
				}
				
				_this.carrouselTouchMovePosXDif			= 0;
				_this.carrouselTouchMovePosXDifOriginal	= 0;
				_this.originPosElem = _this.posElem;
				$(this).unbind("mousemove");				
			});
		}
		
	}
	
	_this.getCarrouselManager = function()
	{
		_this.sousCarrouselElem = $("<ul class='sousCarrousel' style='height:100%;' ><li class='positioneur' ></li></ul>");
		_this.objectToAppend.append(_this.sousCarrouselElem);
		_this.appendToElem.append(_this.objectToAppend);
		_this.checkImageInfo(function()
		{
			_this.getCarrouselManagerC1();
		});
	}
	
	_this.getCarrouselManagerC1 = function()
	{
		_this.resized();
		var pagesLength	= _GLOBALS.CONF.pages.length;
		var thumbSizeW	= _this.thumbSizeW;
		var sizeCarW	= pagesLength*thumbSizeW;
		_this.sousCarrouselWidth = sizeCarW;
		var diapo		= _GLOBALS.CONF.pages.Diapo;
		var objIntern	= $(_this.objectToAppend);
		
		_this.sousCarrouselElem.css("width",sizeCarW);
		
		_this.positioneurInfo.W = _this.thumbs.width;
		
		$(".positioneur").css(
		{
			width:_this.positioneurInfo.W
		});

		_this.thumbsManager();
		
		_GLOBALS.main.pagesLoader.onPageChange(function(currPage)
		{
			if(!_GLOBALS.main.controlManager.showToolsInfo)
			{
				return void(0);
			}

			if(_this.goToThumbTimer)
			{
				clearTimeout(_this.goToThumbTimer);
			}
			
			_this.goToThumbTimer = setTimeout(function()
			{
				_this.thumbsManager( _GLOBALS.main.pagesLoader.pageCurrentOriginalIs , function()
				{
					if(_GLOBALS.main.controlManager.showToolsInfo)
					{
						_this.goToThumb( _GLOBALS.main.pagesLoader.pageCurrentOriginalIs );
					}
				})
			},60)
			return void(0);
		});
		
		UTILS.onResizeCustom(function()
		{
			_this.thumbsManager();
			// _this.resized();
			_this.reposImg();
				setTimeout( function()
				{
					_this.goToThumb( _GLOBALS.main.pagesLoader.pageCurrentOriginalIs  );
				}, 400 );
		});
		
		_GLOBALS.main.controlManager.onShowTools(function(info)
		{
			if(info)
			{
				// $("."+_this.carrouselClassName).css("bottom",0);
				_this.thumbsManager();
				setTimeout( function()
				{
					_this.goToThumb( _GLOBALS.main.pagesLoader.pageCurrentOriginalIs  );
				}, 400 );
			}
		});
		
		_this.creatEvent();
		
		return false;
	}
	return _this._construct();
}
_GLOBALS.callbackLoaded("CarrouselManager");