var Config = function( parent , urlVarId )
{
	var _this					= this;
	_this.versionASP			= "v2";
	_this.systemPath			= _GLOBALS.javascriptInit.path;
	//reserved for changing dynamically
	_this.clientPath			= "./";
	_this.vendors				= "";
	_this.pages					= {};
	
	_this.getDocument			= {};
	_this.getDocument.fond		= {};
	_this.getDocument.fond.color	= "#ffffff";
	_this.getDocument.lngDefault	= "fr";
	_this.getDocument.lng			= "fr";
	
	_this.logo					= {};
	_this.lienInfo				= {};
	_this.xmlNeededToLoadPath	= "";
	_this.xmlNeededToLoad		= new Array();
	_this.iconesPath			= "";
	_this.lngKey				= "langue_";
	_this.pathMobile			= _this.systemPath;
	_this.pathLangue			= _this.pathMobile+"lng/";
	_this.usePaginationPointeurCustom = false;
	_this.menu_alpha			= 1;
	_this.decalagePage			= 0;
	_this.startPageName			= "startPage";
	_this.mailInfo				= {};
	_this.lngIsSeted			= false;
	_this.setDisableCarrousel	= true;
	
	
	_this.iconesDefaultParam	=
	{
		teinte : "#000000"
	};
	
	
	
	_this.vendorsList	= ['ms','Ms', 'moz', 'Moz', 'webkit', 'Webkit', 'o', 'O'];
	
	//like constant WARNING not changing this object dynamically for changing use "pagesDynamiqueInfo"	
	
	_this.pagesOnInit = {}
	
	_this.getTemplatesList = function()
	{
		var templatesPath = "templates/";
		var templatesList = {};		
		// templatesList.popupSlide = templatesPath+"popupSlide.tpl";
		return templatesList;
	}
	
	_this.getVendor = function()
	{
		return _this.vendors;
	}
	
	_this.getClientPath = function()
	{
		return _this.clientPath;
	}
	
	_this.getXmlNeededToLoad = function()
	{
		return _this.xmlNeededToLoad;
	}

	
	_this.getIconesPath = function()
	{
		return _this.iconesPath;
	}	
	
	_this.setIconesPath = function()
	{
		_this.iconesPath = _this.systemPath+"icones_1/";
	}
	
	_this.setDocument = function()
	{
		_this.getDocument.width		= $(window).width();
		_this.getDocument.height	= $(window).height();
	}
	
	_this.setVendor = function()
	{
		var vStyle = $("body")[0].style;
		var vendorsList = _this.vendorsList;
		var vendorsListLength = vendorsList.length;
		for(var x = 0; x < vendorsListLength && typeof vStyle[_this.vendors+"Transition"] != "string"; ++x)
		{
			_this.vendors = vendorsList[x];
		}
	}
	
	_this.setXmlNeededToLoad = function()
	{
		_this.xmlNeededToLoad = new Array("menu2","menuParam","texte" , "param","liens");
	}
	
	_this.setClientPath = function()
	{
		_this.clientPath = urlVarId+"/";
	}
	
	_this.setAllPath = function()
	{
		_this.setClientPath();
		_this.xmlNeededToLoadPath = _this.getClientPath();
		_this.setPagesOnInit();
		_this.setPaginationPointeur();
	}

	_this.getLogoLien = function()
	{
		return _this.logo.path = _this.getClientPath()+_this.logo.logoName;
	}
	
	_this.setPagesOnInit = function()
	{
		_this.pagesOnInit = 
		{
			doublePage			: true,
			keepMaxResolution	: false,
			width				: 1024,
			height				: 1356,
			currScale			: 1,
			currScaleMaxDiff	: 2,
			currScaleMinDiff	: 0,
			scaleDoublTapMax	: 2,
			scaleDoublTapMin	: 0,
			sensibleZoom		: 0.004,
			beginPage			: _GLOBALS.urlStartPage,
			//min 4
			preloadBy			: 8,
			pageCurrentIs		: 1,
			length				: 40,
			timeToLoadHD		: 400,
			pathTextureHigh		: _this.getClientPath()+'Zoom/',
			pathTextureLow		: _this.getClientPath()+'Low/',
			Diapo				: _this.getClientPath()+'Diapo/',
			/*Kev*/
			videoFichePath		: _this.getClientPath()+'fiches/',
			videoIncrustePath	: _this.getClientPath()+'multimedia/',
			imageFichePath		: _this.getClientPath()+'fiches/',
			imageIncrustePath	: _this.getClientPath()+'multimedia/',
			/*****/
			forFisrtPreloadIsBy	: 6,
			defaultName			: "page",
			imgFormat			: ".jpg",
			listElem			: new Array(),
			animationManager	:
			{
				swipTime	: 150,
				zoomTime	: 100,
				transitionTime	: 200,
				//ToDo check problem bounce for android 3.1
				swipEasing	: "linear",
				defEasing	: "linear"
			},
			canvasKey			: "canvas_",
			element				: "element",
			textureHigh			: "pathTextureHigh",
			textureLow			: "pathTextureLow",
			getTextureHigh		: "getTextureHigh",
			getTextureLow		: "getTextureLow"
		}
		
		if(_GLOBALS.isMaster)
		{
			_this.pagesOnInit.pathTextureLow = _this.getClientPath()+"Big1/";
		}
	}
	
	_this.setPaginationPointeur = function()
	{
		if( _this.usePaginationPointeurCustom )
		{
			if(!_this.listPagePointeur)
			{
				_this.usePaginationPointeurCustom = false;
				_this.setPaginationPointeur();
			}else
			{
				_this.pagesOnInit.length = _this.listPagePointeur.length;
			}
		}else
		{
			_this.listPagePointeur = new Array();			
			for( var j = 1 ; j <= _this.pagesOnInit.length ; j++ )
			{
				_this.listPagePointeur.push(j);
			}
		}
	}
	
	_this.getPaginationPointeur = function(i)
	{
		if( _this.listPagePointeur[i] )
		{
			return _this.listPagePointeur[i];
		}else
		{
			return false;
		}
	}
	
	_this._construct = function()
	{
		_this.setAllPath();
		_this.setIconesPath();
		_this.setXmlNeededToLoad();
		_this.pages = UTILS.clone(_this.pagesOnInit);
		_this.setDocument();
		_this.setVendor();
		return void(0);
	}
	
	_this._construct();
}
_GLOBALS.callbackLoaded("Config");