var ControlManager = function(parent)
{
	var _this 				= this;
	_this.parent 			= parent;
	_this.scaleXDefault 	= 0;
	_this.autoriseChangePage = true;
	_this.originalMiddleX 	= null;
	_this.originalMiddleY 	= null;
	_this.diffScaleDef		= 0;
	_this.diffScale			= 0;
	_this.originalScaleDiff	= 0;
	_this.transformDiffX 	= 0;
	_this.transformDiffY 	= 0;
	_this.transformDiffDefX = 0;
	_this.transformDiffDefY = 0;
	_this.currPosFingerX 	= null;
	_this.currPosFingerY 	= null;
	_this.requestAnimationFrame = false;
	_this.needScaleTo		= 0;
	_this.scaledTo			= false;
	_this.originalScaleDiffMaxDiff = _GLOBALS.CONF.pages.currScaleMaxDiff;
	_this.originalScaleDiffMinDiff = _GLOBALS.CONF.pages.currScaleMinDiff;
	_this.byOneFingers		= false;
	_this.showToolsInfo		= 0;
	_this.onScaleGoList		= new Array();
	_this.onScaleGoListEnd	= new Array();	
	_this.toolsList			= new Array();
	_this.toolsListAction	= {};
	_this.onshowToolsArray	= new Array();
	_this.onTransitionPageWait	= false;
	_this.onTransitionPageArray	= new Array();
	
	_this.showTools = function(info)
	{
		if( !_this.toolsList.length )
		{
			var tools = _this.parent.xmlLinksList.getXml.tools;
			tools.children().each(
			function(e)
			{
				if( $(this).attr("enabled") == "true" )
				{
					_this.toolsList.push($(this));
				}
			});
		}
		
		if( info == "hide" )
		{
			_this.showToolsInfo = 0;
		}
		else if( info == "show" )
		{
			_this.showToolsInfo = 1;
		}
		else if( !_this.showToolsInfo )
		{
			_this.showToolsInfo = 1;
		}
		else
		{
			_this.showToolsInfo = 0;
		}
		
		for( var J in _this.toolsList )
		{
			if( !_this.toolsListAction[J] )
			{
				_this.toolsListAction[J]						= {};
				_this.toolsListAction[J].obj					= _this.toolsList[J];
				_this.toolsListAction[J].className				= _this.toolsListAction[J].obj.attr("className");
				_this.toolsListAction[J].attrAfterTransition	= dataToObject(_this.toolsListAction[J].obj.attr("afterTransition"));
				_this.toolsListAction[J].attrBeforTransition	= dataToObject(_this.toolsListAction[J].obj.attr("beforTransition"));
				_this.toolsListAction[J].attrAfterCss			= dataToObject(_this.toolsListAction[J].obj.attr("afterCss"));
				_this.toolsListAction[J].attrBeforCss			= dataToObject(_this.toolsListAction[J].obj.attr("beforCss"));
				_this.toolsListAction[J].attrTimeTransition		= _this.toolsListAction[J].obj.attr("timeTransition");
				_this.toolsListAction[J].javascriptCustom		= _this.toolsListAction[J].obj.children("javascriptCustom").text();
				// console.log();
			}
			
			var obj = _this.toolsListAction[J];
			
			if(!_this.toolsListAction[J].attrTimeTransition)
			{
				_this.toolsListAction[J].attrTimeTransition = 0;
			}
			
			if( !_this.showToolsInfo )
			{
				//HIDE TOOLS
				if( _this.toolsListAction[J].attrBeforTransition && _this.toolsListAction[J].attrAfterTransition )
				{
					$("."+_this.toolsListAction[J].className).css(_this.toolsListAction[J].attrBeforTransition);
					setTimeout(function(cJ)
					{
						$("."+_this.toolsListAction[cJ].className).css(_this.toolsListAction[cJ].attrBeforCss);
					},_this.toolsListAction[J].attrTimeTransition,J);
				}
			}
			else
			{
				//SHOW TOOLS
				$("."+_this.toolsListAction[J].className).css(_this.toolsListAction[J].attrAfterCss);
				setTimeout(function(cJ)
				{
					$("."+_this.toolsListAction[cJ].className).css(_this.toolsListAction[cJ].attrAfterTransition);
				},1,J)
				
			}
			
			if(_this.toolsListAction[J].javascriptCustom)
			{
				_this.toolsListAction[J].javascriptCustom = eval(_this.toolsListAction[J].javascriptCustom);
			}			
		}
		
		_this.onShowedTools();
	}
	
	_this.onShowTools = function(callback)
	{
		_this.onshowToolsArray.push(callback);
	}
	
	_this.onShowedTools = function()
	{
		var tL = _this.onshowToolsArray.length;
		for( var i = 0 ; i < tL ; i++ )
		{
			_this.onshowToolsArray[i](_this.showToolsInfo);
		}
	}
	
	_this.nextPage = function()
	{
		if(!_this.autoriseChangePage)
		{
			return void(0);
		}
		
		var toAddIndexNext = 1;
		var infoPage = UTILS.byPageIfDouble(_this.parent.pagesLoader.pageCurrentOriginalIs);			
		if( infoPage["isDouble"] )
		{
			toAddIndexNext = 2;
		}
		
		if( _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs+toAddIndexNext)] )
		{
			var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs+toAddIndexNext)];
			// currElemeIs.css('z-index',"1");
			var obj={};
			obj["x"] = 0;
			//obj["z-index"] =1;
			currElemeIs.transition(obj,_GLOBALS.CONF.pages.animationManager.transitionTime,"out");
		}
		
		if( _this.parent.pagesLoader.pageCurrentOriginalIs < _GLOBALS.CONF.pages.length && infoPage["isDouble"] && (_this.parent.pagesLoader.pageCurrentOriginalIs+1) == _GLOBALS.CONF.pages.length )
		{
			
		}
		else if( _this.parent.pagesLoader.pageCurrentOriginalIs < _GLOBALS.CONF.pages.length )
		{
			var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
			// currElemeIs.css('z-index',"0");
			var obj={};
			obj["x"] = -_GLOBALS.CONF.getDocument.width;
			//obj["z-index"] =0;
			currElemeIs.transition(obj,(_GLOBALS.CONF.pages.animationManager.transitionTime/1.5));
		}else
		{
			var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
			// currElemeIs.clearQueue();
			// currElemeIs.css('z-index',"1");
			var obj={};
			obj["x"] = 0;
			// //obj["z-index"] =1;
			currElemeIs.transition(obj,_GLOBALS.CONF.pages.animationManager.transitionTime,"out");
		}
		
		setTimeout(function()
		{
			_this.parent.pagesLoader.nextPage();
		},16)
		return void(0);
	}
	
	_this.prevPage = function()
	{
		if(!_this.autoriseChangePage)
		{
			return void(0);
		}

		var toAddIndexNext = 1;
		var infoPage = UTILS.byPageIfDouble(_this.parent.pagesLoader.pageCurrentOriginalIs-toAddIndexNext);			
		if( infoPage["isDouble"] )
		{
			toAddIndexNext = 2;
		}
		
		if( _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs-toAddIndexNext)] )
		{
			var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs-toAddIndexNext)];
			// currElemeIs.css('z-index',"1");
			var obj={};
			obj["x"] = 0;
			//obj["z-index"] =1;
			currElemeIs.transition(obj,_GLOBALS.CONF.pages.animationManager.transitionTime,"out");
		}	
		
		if( _this.parent.pagesLoader.pageCurrentOriginalIs > 1 )
		{
			var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
			// currElemeIs.css('z-index',"0");
			var obj={};
			obj["x"] = _GLOBALS.CONF.getDocument.width;
			//obj["z-index"] =0;
			currElemeIs.transition(obj,(_GLOBALS.CONF.pages.animationManager.transitionTime/1.5));
		}else
		{
			var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
			// currElemeIs.clearQueue();
			// currElemeIs.css('z-index',"1");
			var obj={};
			obj["x"] = 0;
			//obj["z-index"] =1;
			currElemeIs.transition(obj,_GLOBALS.CONF.pages.animationManager.transitionTime,"out");
		}
		
		setTimeout(function()
		{
			_this.parent.pagesLoader.prevPage();
		},16)
		return void(0);
	}
	
	_this.goToPage = function(nb)
	{
		if(_this.scaledTo)
		{
			_this.scaleEnd()
			_this.scaleGo(false,false,false,1);
			
			setTimeout(function()
			{
				/*Kev*/
				_this.parent.linksManager.goToPage(nb);	
				/*****/
				_this.parent.pagesLoader.goToPage(nb);
			},_GLOBALS.CONF.pages.animationManager.zoomTime+10);
			return void(0);
		}
		
		if(!_this.autoriseChangePage)
		{
			return void(0);
		}
		
		/*Kev*/
		_this.parent.linksManager.goToPage(nb);	
		/*****/
		
		_this.parent.pagesLoader.goToPage(nb);
		return void(0);
	}
	
	_this.onDragElem = function( moveDiffX , moveDiffY , eventTouch )
	{
		if(!_this.autoriseChangePage)
		{
			_this.parent.controlManager.scaleGo(false,false,eventTouch,0);
			return void(0);
		}
		
		/*Kev*/
		_this.parent.linksManager.onDragElem();
		/*****/
		
		_this.onTransitionPageWait = true;
		_this.parent.positionForSlider.onDragElem( moveDiffX );
		return void(0);
	}	
	
	_this.onDropElem = function(moveDiffX)
	{
		if(!_this.autoriseChangePage)
		{
			_this.scaleEnd();
			return void(0);
		}
		
		/*Kev*/
		_this.parent.linksManager.onDropElem();
		/*****/
		
		_this.onTransitionPageWait = false;
		_this.parent.positionForSlider.onDropElem( moveDiffX );
		return void(0);
	}	
	
	_this.onTransitionPage = function(callBack)
	{
		_this.onTransitionPageArray.push(callBack);
		return _this.onTransitionPageArray.length;
	}
	
	_this.onTransitionedPage = function()
	{
		if( _this.onTransitionPageWait )
		{
			return false;
		}
		
		var tL = _this.onTransitionPageArray.length;
		for( var i = 0 ; i < tL ; i++ )
		{
			_this.onTransitionPageArray[i]( i , _this.parent.pagesLoader.pageCurrentOriginalIs );
		}
	}
	
	_this.initialPage = function()
	{
		if(!_this.autoriseChangePage)
		{
			return void(0);
		}
		
		_this.parent.positionForSlider.positionIt( _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs] , _this.parent.pagesLoader.pageCurrentOriginalIs , _this.parent.pagesLoader.pageCurrentOriginalIs );
		return void(0);
	}
	
	_this.resetZoomInfo = function()
	{
		// _this.scaleGo(false,false);
		var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
		var difProp = _GLOBALS.CONF.pages.sensibleZoom;
		_this.autoriseChangePage = false;
		
		_this.currPosFingerX	= 0;
		_this.currPosFingerY	= 0;
		
		_this.needScaleTo		= _GLOBALS.CONF.pages.scaleDoublTapMin;
	
		_this.diffScale =  0;
		// currElemeIs.clearQueue();
		currElemeIs.transition(
		{
			x: 0
		},0);
		
		_this.scaledTo = false;
		_this.autoriseChangePage = true;
		_this.lastIndexPage = _this.parent.pagesLoader.pageCurrentOriginalIs;
	}
	
	_this.onScaleGo = function( addCallback , addCallbackEnd)
	{
		if(addCallback)
		{
			_this.onScaleGoList.push(addCallback);
		}		
		if(addCallbackEnd)
		{
			_this.onScaleGoListEnd.push(addCallbackEnd);
		}
		return void(0);
	}
	
	_this.onScaledGo = function( inOut )
	{
		if(inOut)
		{
			var sclLength = _this.onScaleGoList.length;
			for( var i = 0; i < sclLength ; i++ )
			{
				_this.onScaleGoList[i]();
			}
		}else
		{
			var sclLength = _this.onScaleGoListEnd.length;
			for( var i = 0; i < sclLength ; i++ )
			{
				_this.onScaleGoListEnd[i]();
			}
		}
		return void(0);		
	}
	
	_this.scaleGo = function(finger0,finger1,touchStartEvent,getScale)
	{
		var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
		var difProp = _GLOBALS.CONF.pages.sensibleZoom;
		_this.autoriseChangePage = false;
		
		if( !finger0 && !finger1 )
		{
			_this.byOneFingers = true;
			if(touchStartEvent)
			{
				finger0 = touchStartEvent;
				finger1 = touchStartEvent;
			}else
			{
				finger0 = {};
				finger1 = {};
				finger0.pageX =  _GLOBALS.CONF.getDocument.width/2;
				finger1.pageX =  _GLOBALS.CONF.getDocument.width/2;
			}			
		}
		else
		{
			if(_this.byOneFingers)
			{
				_this.byOneFingers = false;
				_this.scaleEnd();
			}
		}

		if(getScale)
		{
			if(_this.scaledTo)
			{
				_this.needScaleTo		= _GLOBALS.CONF.pages.scaleDoublTapMin;
			}
			else
			{
				_this.needScaleTo		= _GLOBALS.CONF.pages.currScaleMaxDiff/2;
				_this.originalScaleDiff	= 0;
				_this.diffScaleDef		= _this.needScaleTo;
				// _this.transformDiffDefX = _GLOBALS.CONF.getDocument.width/2;
				// _this.transformDiffDefY = _GLOBALS.CONF.getDocument.height/2;
			}
		}
		
		/*By one fingers OR By two fingers*/
		var middleX		= (finger0.pageX+finger1.pageX)/2;
		var middleY		= (finger0.pageY+finger1.pageY)/2;
		
		_this.currPosFingerX = middleX;
		_this.currPosFingerY = middleY;
		
		if(!_this.originalMiddleX)
		{
			_this.originalMiddleX = middleX;
			_this.originalMiddleY = middleY;
		}
		
		
		_this.transformDiffX = _this.transformDiffDefX+(_this.originalMiddleX-middleX);
		_this.transformDiffY = _this.transformDiffDefY+(_this.originalMiddleY-middleY);
		
		var a2			= Math.pow(Math.abs(finger0.pageX-finger1.pageX),2);
		var b2			= Math.pow(Math.abs(finger0.pageY-finger1.pageY),2);
		var c2			= Math.sqrt(a2+b2);
		_this.diffScale	= (c2*difProp);
		
		if(!_this.originalScaleDiff)
		{
			_this.originalScaleDiff = _this.diffScale;
		}
	
		_this.diffScale =  (_this.diffScale - _this.originalScaleDiff) + _this.diffScaleDef;

		if( _this.diffScale <= _this.originalScaleDiffMinDiff )
		{
			_this.diffScale				= _this.originalScaleDiffMinDiff;
			_this.autoriseChangePage	= true;
		}
		else if( _this.diffScale >= _this.originalScaleDiffMaxDiff )
		{
			_this.diffScale = _this.originalScaleDiffMaxDiff;
		}

		currElemeIs.transition(
		{
			x: 0			
		},0);
		
		if( _GLOBALS.userAgentManager.userAgent.type == "phone" || _GLOBALS.userAgentManager.userAgent.name == "ipad" && 1==2)
		{
			if(getScale)
			{
				if(_this.scaledTo)
				{
					_this.scaledTo = false;
					_this.autoriseChangePage = true;
					_this.scaleEnd();
					_this.onScaledGo(false);
				}else
				{
					_this.goRenderSimple();
					_this.scaledTo = true;
					_this.scaleEnd();
					_this.onScaledGo(true);
				}
			}else
			{
				_this.reScaleCanvas( _this.diffScale , _this.transformDiffX , _this.transformDiffY , _this.currPosFingerX , _this.currPosFingerY );
			}			
		}else
		{
			if(!_this.requestAnimationFrame)
			{
				if(getScale)
				{
					if(_this.scaledTo)
					{
						_this.scaledTo = false;
						_this.autoriseChangePage = true;
						_this.scaleEnd();
						_this.onScaledGo(false);
					}else
					{
						_this.goRenderSimple();
						_this.scaledTo = true;
						_this.scaleEnd();
						_this.onScaledGo(true);
					}
				}else
				{
					_this.goRender();
				}
			}
		}
		
		_this.lastIndexPage = _this.parent.pagesLoader.pageCurrentOriginalIs;
	}
	
	_this.scaleEnd = function()
	{
		drawCanvasTime( null , 1 , _this.requestAnimationFrame );		
		_this.requestAnimationFrame = false;
		_this.originalMiddleX		= null;
		_this.originalMiddleY		= null;
		
		if( !_this.autoriseChangePage )
		{
			_this.scaledTo			= true;
			_this.originalScaleDiff	= 0;
			_this.diffScaleDef		= _this.diffScale;
			_this.transformDiffDefX = _this.transformDiffX;
			_this.transformDiffDefY = _this.transformDiffY;			
		}else
		{
			_this.scaledTo = false;
			_this.reScaleCanvasToInitAnim( _this.diffScale , _this.transformDiffX , _this.transformDiffY , null , function()
			{
				_this.diffScale				= 0;
				_this.originalScaleDiff 	= 0;
				_this.diffScaleDef			= 0;
				_this.transformDiffDefX 	= 0;
				_this.transformDiffDefY 	= 0;
				_this.transformDiffX		= 0;
				_this.transformDiffY		= 0;
				_this.autoriseChangePage	= true;
			},false);
		}
		return void(0);
	}

	_this.reScaleCanvas = function( scaleDiff , diffX , diffY , currPosFingerX , currPosFingerY )
	{
		var cvs = _this.parent.canvasManager.textureContextList[_GLOBALS.CONF.pages.canvasKey+_this.parent.pagesLoader.pageCurrentOriginalIs];
		_this.parent.canvasManager.constructPos( cvs , _this.parent.pagesLoader.pageCurrentOriginalIs , scaleDiff , diffX , diffY , function(elem)
		{
			var numCur = 0;
			if(	cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur] && cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw )
			{
				cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw();
			}
			else if( cvs[_GLOBALS.CONF.pages.getTextureLow+numCur] && cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw )
			{
				cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw();
			}
			
			var numCur = 1;
			if(	cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur] && cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw )
			{
				cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw();
			}
			else if( cvs[_GLOBALS.CONF.pages.getTextureLow+numCur] && cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw )
			{
				cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw();
			}
			return void(0);
		},currPosFingerX , currPosFingerY , _this);
		return void(0);	
	}
	
	_this.goRender = function()
	{
		_this.reScaleCanvas( _this.diffScale , _this.transformDiffX , _this.transformDiffY , _this.currPosFingerX , _this.currPosFingerY );
		_this.requestAnimationFrame = drawCanvasTime( _this.goRender );
	}
	
	_this.goRenderSimple = function()
	{
		_this.reScaleCanvasToInitAnim( _this.diffScale , _this.transformDiffX , _this.transformDiffY , false , false , true);
	}
	
	_this.reScaleCanvasToInitAnim = function( scaleDiff , diffX , diffY , callBack, callBackAfterAnim , lowToHigh )
	{
		var elem		= _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
		var cvs			= _this.parent.canvasManager.textureContextList[_GLOBALS.CONF.pages.canvasKey+_this.parent.pagesLoader.pageCurrentOriginalIs];
		var cDiffX		= 0 ;
		var cDiffY		= 0 ;

		elem.animate(
		{
			getEasingAnim:1
		},
		{
			step:function( now , fx )
			{
				if(lowToHigh)
				{
					cScaleDiff	= (_this.originalScaleDiffMaxDiff/2)*now;				
				}else
				{
					cScaleDiff	= (scaleDiff/2)-(scaleDiff/2)*now;
				}
				
				cDiffX		= diffX*(1-now);
				cDiffY		= diffY*(1-now);
				
				if( cScaleDiff <= _this.originalScaleDiffMinDiff )
				{
					cScaleDiff = _this.originalScaleDiffMinDiff;
				}
				else if( cScaleDiff > _this.originalScaleDiffMaxDiff )
				{
					cScaleDiff = _this.originalScaleDiffMaxDiff;
				}
				
				_this.parent.canvasManager.constructPos( cvs , _this.parent.pagesLoader.pageCurrentOriginalIs , cScaleDiff , cDiffX , cDiffY , function(cvs)
				{
					var numCur = 0;
					if(	cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur] && cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw )
					{
						cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw();
					}
					else if( cvs[_GLOBALS.CONF.pages.getTextureLow+numCur] && cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw )
					{
						cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw();
					}
					
					var numCur = 1;
					if(	cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur] && cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw )
					{
						cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw();
					}
					else if( cvs[_GLOBALS.CONF.pages.getTextureLow+numCur] && cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw )
					{
						cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw();
					}
					return void(0);
				});
			},
			complete:function()
			{
				$(this)[0].getEasingAnim = 0;
				
				if(callBackAfterAnim)
				{
					callBackAfterAnim();
				}
				// _this.scaleEnd();
			},
			duration:_GLOBALS.CONF.pages.animationManager.zoomTime,
			easing:"linear"
		});	
	}
	
	
	_this.drawCanvas = function()
	{
		var numCur = 0;
		var cvs = _this.parent.canvasManager.textureContextList[_GLOBALS.CONF.pages.canvasKey+_this.parent.pagesLoader.pageCurrentOriginalIs];
		if(	cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur] && !cvs[_GLOBALS.CONF.pages.textureHigh+numCur].drawed )
		{
			cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur]();
		}
		
		var numCur = 1;
		if(	cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur] && !cvs[_GLOBALS.CONF.pages.textureHigh+numCur].drawed )
		{
			cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur]();
		}
	}
	
	_this._construct = function()
	{
		return void(0);
	}
	_this._construct();
}
_GLOBALS.callbackLoaded("ControlManager");