var JavascriptInit = function(parent)
{
	var _this					= this;
	_this.minify				= false;
	_this.path					= "./mobile/";
	_this.pathJs				= _this.path+"js/";
	_this.preloaderPath			= _this.path+"img/preloader.png";
	_this.callbackLoadedCount	= 0;
	_this.animatyeRotatStat		= 0;
	_this.animPreladerSplashScreenStat = true;
	_this.preloaderSplashScreenId = "#preloaderSplashScreen";
	_GLOBALS.currentPage			= 0;
	_GLOBALS.isMaster			= false;
	_this.consoleLog			= null;
	
	_this.debugDisable = function()
	{
		_this.consoleLog = console.log;
		console.log = function()
		{
			return void(0);
		}
	}
	// _this.debugDisable();
	
	_this.debugEnable = function()
	{
		console.log = _this.consoleLog;
	}
	
	_this.appendMinimumHtml  = function()
	{
		$("script").remove();
		_GLOBALS.urlStartPage	= 1;
		_GLOBALS.x_y_z_Manager	= new X_y_z_Manager();
		_GLOBALS.CONF	= new Config( this , _GLOBALS.x_y_z_Manager.urlVarId );
		_GLOBALS.main	= new Main(_GLOBALS);
		_GLOBALS.main.init();
	}
	
	_GLOBALS.getCurrentPage = function()
	{
		if( _GLOBALS.main && _GLOBALS.main.pagesLoader && _GLOBALS.main.pagesLoader.pageCurrentOriginalIs )
		{
			return _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
		}
		return 1;
	};

	_GLOBALS.callbackLoadedTmp = function(name)
	{
		
	}
	
	_GLOBALS.callbackLoaded = function(name)
	{
		_this.callbackLoadedCount++;
		if( _this.callbackLoadedCount >= Object.keys(_this.jList).length )
		{
			_GLOBALS.ifMasterManager = new IfMasterManager(_GLOBALS);
			_GLOBALS.ifMasterManager.checkByAjax(function()
			{
				_this.appendMinimumHtml();
			})
		}
	}
	
	_this.initSlide = function()
	{
		for( var J in _this.jList )
		{
			_this.loadJs( _this.pathJs+_this.jList[J] , null );
		}
	}
	
	if(_this.minify)
	{
		_this.jList =
		{
			minify				: "min.js"
		}
	}else
	{
		_this.jList =
		{
			utils				: "utils.js",
			ifMasterManager		: "ifMasterManager.js",
			easing				: "easing.js",
			jqueryTransit		: "jquery.transit.js",
			templateManager		: "templateManager.js",
			xmlLoader			: "xmlLoader.js",
			eventManagerFlip	: "eventManagerFlip.js",
			pagesLoader			: "pagesLoader.js",
			main				: "main.js",
			config				: "config.js",
			positionForSlider	: "positionForSlider.js",
			canvasManager		: "canvasManager.js",
			controlManager		: "controlManager.js",
			menuParamManager	: "menuParamManager.js",
			fonctionaliteMenuManager	: "fonctionaliteMenuManager.js",
			carrouselManager	: "carrouselManager.js",
			rechercheTextXml	: "rechercheTextXml.js",
			popupSlide			: "popupSlide.js",
			x_y_z_Manager		: "x_y_z_Manager.js",
			param				: "param.js",
			sommaireManager		: "sommaireManager.js",
			vignetteManager		: "vignetteManager.js",
			linksManager		: "linksManager.js",
			popupLink			: "popupLink.js",
			mailManager			: "mailManager.js",
			pageSwfLoader		: "pageSwfLoader.js"
		}
	}

	_this.loadJs = function( sUrl , oParams )
	{
		for (sName  in oParams)
		{
			if( sUrl.indexOf("?")  != -1 )
			{
				sUrl  += "&";
			}
			else
			{
				sUrl  += "?";
			}
			sUrl  += encodeURIComponent(sName) + "=" +  encodeURIComponent(oParams[sName]);
        }
 
        var DSLScript  = document.createElement("script");
        DSLScript.src  = sUrl;
        DSLScript.type = "text/javascript";
        document.head.appendChild(DSLScript);
	}
	
	_this.animPreladerSplashScreen = function(target)
	{
		setTimeout(function()
		{
			target.css("transform","rotate("+_this.animatyeRotatStat+"deg)");
			
			if(_this.animPreladerSplashScreenStat)
			{
				_this.animPreladerSplashScreen(target);
			}
			
			_this.animatyeRotatStat+=10;
			
			if( _this.animatyeRotatStat > 360 )
			{
				_this.animatyeRotatStat = 0;
			}
		},20);
	}
	
	_this.setTargetPreloader = function()
	{
		_this.preloaderSplashScreenId = $(_this.preloaderSplashScreenId);
		return _this.preloaderSplashScreenId;
	}
	
	_this.stopPreladerSplashScreen = function(callback)
	{
		
		_this.animPreladerSplashScreenStat = false;
		_this.preloaderSplashScreenId.fadeOut(200,function()
		{
			_this.preloaderSplashScreenId.remove();
		
			if(callback)
			{
				callback();
			}
		})		
	}
	
	
	_this.initPreladerSplashScreen = function()
	{
		_this.setTargetPreloader();
		_this.preloaderSplashScreenId.css(
		{
			background:"transparent url('"+_this.preloaderPath+"') no-repeat center",
		})
		
		_this.animPreladerSplashScreen(_this.preloaderSplashScreenId);
	}
	
	_this._construct = function()
	{
		_this.initPreladerSplashScreen();
	}
	_this._construct();
}

_GLOBALS = this;
_GLOBALS.touchableInfo	= false;
_GLOBALS.idResize		= 0;

//astuceMassi Active touch pour android voir aussi main.js
_GLOBALS.initEventTouch = function()
{
	return void(0);
}

$(document)[0].addEventListener( "touchstart", _GLOBALS.initEventTouch , false);
_GLOBALS.userAgentManager = new UserAgentManager(_GLOBALS);
if(_GLOBALS.userAgentManager.userAgent.type == "phone" )
{
	$('meta[name=viewport]').attr('content', "initial-scale=0.6 ,user-scalable=yes ,minimum-scale=0.6 ,maximum-scale=0.6");
}else
{
	//$('meta[name=viewport]').attr('content', "initial-scale=1.1 ,user-scalable=yes ,minimum-scale=1.0 ,maximum-scale=1.1");
	//$('meta[name=viewport]').attr('content', "initial-scale=1.0 ,user-scalable=no ,minimum-scale=1.0 ,maximum-scale=1.0");
}

$(document).bind('ready',function()
{
	$("body").append('<div id="preloaderSplashScreen" style="width:100%;height:100%"></div>');
	$("body").append("<div class='blockCont' ></div><div class='listenerFlipable'></div>");
	setTimeout(function()
	{
		$(".blockCont").fadeIn(500);
	},500);

	_GLOBALS.javascriptInit = new JavascriptInit();
	_GLOBALS.javascriptInit.initSlide();
})