/*Kev*/

_GLOBALS.LinkTypeZoomPartiel 		= "Zoom partiel";
_GLOBALS.LinkTypeVideoFiche 		= "Vidéo";
_GLOBALS.LinkTypeVideoIncruster 	= "Vidéo incruster";
_GLOBALS.LinkTypeLightbox 			= "Lightbox";
_GLOBALS.LinkTypeWeb 				= "Lien web";
_GLOBALS.LinkTypeGalerie 			= "Galerie";
_GLOBALS.LinkTypeFiche 				= "Fiche";
_GLOBALS.LinkTypeImageFiche 		= "Image";
_GLOBALS.LinkTypeImageIncruster 	= "Image incruster";
_GLOBALS.LinkTypeAudio 				= "Audio";
_GLOBALS.LinkTypeGotoPage 			= "Aller à la page";
_GLOBALS.LinkTypePhone 				= "Téléphone";
_GLOBALS.LinkTypeMail 				= "Mail";
_GLOBALS.LinkTypeIconeDefault		= "Icone";
_GLOBALS.LinkTypeAnimation			= "Animation";
_GLOBALS.LinkTypeNone 				= "none";

_GLOBALS.VideoExtSupported = ["m4v","ogv","webm"];
_GLOBALS.VideoTypeSupported = ["video/mp4","video/ogg","video/webm"];

_GLOBALS.IconeSupported = ["flash","gotoPage","video","pen","link","mail","photo","picture","sound"];


function customLog(obj) {
	//console.log(obj);
}

	
var VideoIncruster = function(lien, parent) {
	var _this = this;
	_this.lienObj;
	_this.html;
	_this.element;
	_this.timer = null;
	_this.fullScreenState = false; 
	_this.video = null;
	_this.parent;
	_this.needDestroy = false;
	      
               			
	_this._construct = function()
	{
        _this.lienObj = lien;
        _this.parent = parent;
        customLog("Nouvelle objet video construit");
        
	}
	
	_this.setElement = function(elem) {
		_this.element = elem;
		_this.video = $(elem).find('#v')[0];
		_this.timer = setInterval( _this.truc, 300);
		customLog("element video creer");
	}
	
	_this.truc = function() {
		if (_this.fullScreenState != _this.video.webkitDisplayingFullscreen) {
			
			_this.fullScreenState = _this.video.webkitDisplayingFullscreen;
			customLog("fullscreen is " + ((_this.fullScreenState)?'YES':'NO'));
			
			if (_this.needDestroy && !_this.fullScreenState) {
				customLog("video n'est plus en fullscreen");
				_this.parent.showVideo();
			}
		}
	}
		
	_this.destroyVideo = function() {
				
		if (_this.fullScreenState) {
			customLog("video en fullscreen, donc on ne detruit pas");
			_this.needDestroy = true;
			return;
		}
		
		customLog("on detruit l'element video du DOM");
		_this.video = null;
		clearInterval(_this.timer);
		$(_this.element).remove();
		_this.element = null;
	}
	
	_this.resizeVideo = function() {
		$(_this.element).css('left',_this.lienObj.xScreen+'px');
	    $(_this.element).css('top',_this.lienObj.yScreen+'px');
		$(_this.element).css('width',_this.lienObj.w+'px');
	    $(_this.element).css('height',_this.lienObj.h+'px');
	    customLog("Resize de la video");	
	}
	
	_this.hideVideo = function() {
		if (_this.fullScreenState) {
			return;
		}
		if ($(_this.element).hasClass('show')) {
			$(_this.element).removeClass('show');
			$(_this.element).addClass('hide');
			customLog("on masque juste l'element video");
		}
	}

	_this.showVideo = function() {
		if (_this.fullScreenState) {
			return;
		}
		if ($(_this.element).hasClass('hide')) {
			customLog("l'element video est juste masquer, donc on le show");
			$(_this.element).removeClass('hide');
			$(_this.element).addClass('show');	
		}
	}
	
	_this.getHtml = function(videoTag) {
		_this.html = '<div class="linkVideo '+_this.lienObj._id+' show" href="';
		_this.html += _this.lienObj.url;
		_this.html += '" style="';
		_this.html += 'left:' + _this.lienObj.xScreen + 'px; ' + 'top:' + _this.lienObj.yScreen + 'px; ' + 'width:' + _this.lienObj.w + 'px; ' + 'height:' + _this.lienObj.h + 'px; ';
		_this.html += '">'
		_this.html += videoTag;
		_this.html +='</div>';
		return _this.html;
	}

	_this._construct();	
}


var LinkObj = function( linkAttr ) {
	var _this = this;
	_this._id = 0;
	_this.lienInfo;
	_this.xOrig = 0;
	_this.xScreen = 0;
	_this.x = 0;
	_this.yOrig = 0;
	_this.yScreen = 0;
	_this.y = 0;
	_this.wOrig = 0;
	_this.w = 0;
	_this.hOrig = 0;
	_this.h = 0;
	_this.url = "";
	_this.urlvideo = new Array();
	_this.target = "";
	
	_this.pagenum = "";
	_this.type;
	_this.currScale = 1;
	_this.lightboxW = 0;
	_this.lightboxH = 0;
	
	_this.color = "";
	_this.opacity = 0.05;
	_this.border = true;
	_this.borderWidth = 1;
	
	_this.elem = null;
	_this.linkTypeManager = new LinkTypeManager();
	
	 _this._construct = function()
	{
        _this.xOrig = parseInt($(linkAttr).attr('x'));
		_this.yOrig = parseInt($(linkAttr).attr('y'));
        _this.wOrig = parseInt($(linkAttr).attr('w'));
		_this.hOrig = parseInt($(linkAttr).attr('h'));
		_this.pagenum = $(linkAttr).attr('pagenum');
		
        if ($(linkAttr).attr('url') != undefined)
        	_this.url = $(linkAttr).attr('url');
        else if ($(linkAttr).attr('page') != undefined)
        	_this.url = "page:" + $(linkAttr).attr('page');
        
        if ($(linkAttr).attr('lightboxHeight') != undefined) {
        	_this.lightboxH = $(linkAttr).attr('lightboxHeight');
        	if (_this.lightboxH.match(/^[0-9]+$/g))
        		_this.lightboxH += 'px';
        }

        if ($(linkAttr).attr('lightboxWidth') != undefined) {
        	_this.lightboxW = $(linkAttr).attr('lightboxWidth');
        	if (_this.lightboxW.match(/^[0-9]+$/g))
        		_this.lightboxW += 'px';
        }
        
        if ($(linkAttr).attr('target') != undefined)
        	_this.target = $(linkAttr).attr('target');
        	
      	_this.lienInfo = _GLOBALS.CONF.lienInfo;
		_this.color = _this.lienInfo.coulLien;
		
		if ( _this.lienInfo.opacityLien)
			_this.opacity = _this.lienInfo.opacityLien;
		
		if ( _this.lienInfo.borderLien)
			_this.border = _this.lienInfo.borderLien;
			
		if ( _this.lienInfo.borderWLien)
			_this.borderWidth = _this.lienInfo.borderWLien;
		
		this.type = _this.linkTypeManager.getLinkType(_this);
		_this.linkTypeManager = null;
	}
	
	_this.resizeLink = function(currScale, decalageX, decalageY) {
		_this.currScale = currScale;
		_this.x = Math.round(_this.xOrig*currScale);
        _this.y = Math.round(_this.yOrig*currScale);
        _this.xScreen = _this.x + decalageX;
        _this.yScreen = _this.y + decalageY;
        _this.w = Math.round(_this.wOrig*currScale);
        _this.h = Math.round(_this.hOrig*currScale);
       
	}
	
	_this.setIcon = function(type) {
		/*var filename = '';
		if (type == _GLOBALS.LinkTypeVideoIncruster || type == _GLOBALS.LinkTypeVideoFiche)
			filename = 'video.png';
		else 
			return;
		
		var img = new Image();
		img.src = _GLOBALS.CONF.iconesPath + filename; 
		img.onload = function(){
			_this.icon = this;
		}*/	
	}
	
	_this._construct();
}


var LinkTypeManager = function() {
	var _this = this;
	
	_this.getLinkType = function( lien ) {
		var reg;
		if (lien.url.length == 0) {
			return _GLOBALS.LinkTypeNone;
		}
		
		if (lien.target == "swf_fiche" || lien.target == "swf_video") {
			var extension = UTILS.getFileExtension(lien.url);
			if (extension == "jpg" || extension == "png") {
				return (lien.target == "swf_fiche") ? _GLOBALS.LinkTypeImageFiche : _GLOBALS.LinkTypeImageIncruster;
			}
			if (extension == "swf") {
				return _GLOBALS.LinkTypeNone;				
			}		
			if (extension == "flv") {
				for (var i = 0; i < _GLOBALS.VideoExtSupported.length; i++) {
					lien.urlvideo[i] = UTILS.getFilenameWithoutExtension(lien.url) + "." + _GLOBALS.VideoExtSupported[i];
    			} 							
				return (lien.target == "swf_fiche") ? _GLOBALS.LinkTypeVideoFiche : _GLOBALS.LinkTypeVideoIncruster;
			}
			customLog('alerte 1 ! '); 
		}
		
		if (lien.target == "_blank") {
			reg = /lightbox:/g;	
			if (lien.url.match(reg)) {
				var newurl = lien.url.replace('lightbox:', '');
				lien.url = newurl;
				return _GLOBALS.LinkTypeLightbox;
			}
			reg = /http:/g;
			if (lien.url.match(reg)) {
				return _GLOBALS.LinkTypeWeb;
			}
			customLog('alerte 2 ! ');
		}
		
		if (lien.target == "_self") {
			reg = /mailto:/g;
			if (lien.url.match(reg)) {
				return _GLOBALS.LinkTypeMail;
			}
			customLog('alerte 3 ! ');
		}
		
		if (lien.target.length == 0) {
			reg = /page:/g;
			if (lien.url.match(reg)) {
				var newurl = lien.url.replace('page:', '');
				lien.url = newurl;
				return _GLOBALS.LinkTypeGotoPage;
			}
		}
		
		customLog('lien non reconnu ! ');
		customLog(lien);
		return _GLOBALS.LinkTypeNone;	
	}
}



var LinksManager = function( links ) {
    
    var _this = this;
    _this.links;
    _this.pageWidth;
    _this.pageHeight;
    _this.redrawLinksTimer = null;
    _this.videoTimer = null;
    _this.videoIncruster = new Array();
    _this.animations = new Array();
    _this.linkLoader;
    
    _this.popupLink;
    
    _this._construct = function()
	{
		
		_this.pageWidth  = _GLOBALS.CONF.pagesOnInit.width;
        _this.pageHeight = _GLOBALS.CONF.pagesOnInit.height;
        
		var nbPages = _GLOBALS.CONF.pages.length;
        _this.links = new Array();
        
        var _id = 0;        
        for (var pagenum = 1; pagenum <= nbPages; pagenum++) {
        	var linksForPage = $(links).find('page[num='+pagenum+']').find('lien');
        	$(linksForPage).attr("pagenum",pagenum);
             
            _this.links[pagenum] = new Array(); 
                        
        	for (var i = 0; i < linksForPage.length; i++) {
           		var lien = new LinkObj(linksForPage[i]);
           		lien.setIcon(lien.type);
           		lien._id = _id;
           		
           		if (lien.type != _GLOBALS.LinkTypeNone && !_this.isDoublonLinks(_this.links[pagenum], lien)) {
           			_this.links[pagenum].push(lien);           			
           		}
           		
           		_id++;
        	}
        }
	}
    
    _this.isDoublonLinks = function( liensArr , lienToCheck) {
    	
    	return false;
    	
    	for (var i = 0; i < liensArr.length; i++) {
    		var lien = liensArr[i];
    		var tolerence = 5;
    		var xDif = Math.abs(lien.xOrig-lienToCheck.xOrig);
    		var yDif = Math.abs(lien.yOrig-lienToCheck.yOrig);
    		var wDif = Math.abs(lien.wOrig-lienToCheck.wOrig);
    		var hDif = Math.abs(lien.hOrig-lienToCheck.hOrig);
    		if (xDif < tolerence && yDif < tolerence && wDif < tolerence && hDif < tolerence) {
    			if (lien.url != lienToCheck.url) {
    				customLog('Doublon found mais pas la meme url !');
    				customLog(lien);
    				customLog(lienToCheck);
    			}
    			return true;
    		}
    	}
    	return false;
    }
        
    _this.getLinksForPage = function( pagenum, currScale, decalageX, decalageY)
    
	{ 
		var linksForPage = _this.links[pagenum];
		//customLog(linksForPage);
		for (var i = 0; i < linksForPage.length; i++) {
           		var lien = linksForPage[i];
				lien.resizeLink(currScale, decalageX, decalageY);         	
        }
        return linksForPage;
    }
    
    _this.currentPageIsDouble = function() {
    	var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
    	var infoPage = UTILS.byPageIfDouble(pagenum);
    	customLog(infoPage);
		return ( infoPage["isDouble"] );
    }
    
    _this.isTouchPointALink = function( offsetX, offsetY ) {  	
    	var linksFounded = new Array();
    	
    	var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
		
		var pageToShow = (_this.currentPageIsDouble()) ? 2 : 1;

    	for (var j = 0; j < pageToShow; j++) {
    		var pagen = pagenum+j;
    		for (var i = 0; i < _this.links[pagen].length; i++) {
    			var lien = _this.links[pagen][i];
    			if ((offsetX >= lien.xScreen && offsetX <= lien.xScreen + lien.w) && (offsetY >= lien.yScreen && offsetY <= lien.yScreen + lien.h)) {
    				customLog("trouved !!!!!!");
    				if (lien.type != _GLOBALS.LinkTypeImageIncruster && lien.type != _GLOBALS.LinkTypeVideoIncruster && lien.type != _GLOBALS.LinkTypeAnimation)
    					linksFounded.push(lien);
    			}
    		}
    	}
    	if (linksFounded.length > 0) {
    		//customLog(linksFounded);
    		/*var bestMatch = linksFounded[0];
    		for (var i = 1; i < linksFounded.length; i++) {
    			var lien = linksFounded[i];
    			if (bestMatch.w * bestMatch.h > lien.w * lien.h) {
    				bestMatch = lien;
    			}
    		}*/    		
    		var bestMatch = linksFounded[linksFounded.length-1];    		
    		customLog("Lien cliqued :");
    		customLog(bestMatch);
    			
    		_this.loadLink(bestMatch);
    		return bestMatch;
    	}
    	return null;
    } 
    
    
    _this.showLinkLoader = function(lienObj, posX, posY) {
    	var parent = $('body');
    	_this.linkLoader = new LinkLoader( _this , parent , lienObj , 75 , posX , posY );
    	_this.linkLoader.start();
    }
    
    _this.hideLinkLoader = function() {
    	_this.linkLoader._destroy();
    }
            
    _this.loadLink = function(lien) {
    	
    	if (lien.type == _GLOBALS.LinkTypeWeb || lien.type == _GLOBALS.LinkTypeMail)
    		window.open(lien.url,lien.target,"",false);

		if (lien.type == _GLOBALS.LinkTypeImageFiche ||
		 	lien.type == _GLOBALS.LinkTypeLightbox || 
		 	lien.type == _GLOBALS.LinkTypeVideoFiche
		) {	
			_this.hideVideo();	
			_this.popupLink = new PopupLink($('body'),_this,lien);
    	}
    	    	
    	if (lien.type == _GLOBALS.LinkTypeGotoPage) {
    		var gotoPage = lien.url.split(':').pop();
    		_GLOBALS.main.controlManager.goToPage(gotoPage);
    	}
    	
    }
    
    _this.popupIsClosed = function() {
    	_this.popupLink = null;
    	_this.showVideo();
    }    
	
	_this.resetVideo = function() {
		for (var pv in _this.videoIncruster)	{
			for (var v in _this.videoIncruster[pv])	{
				var videoIncruster = _this.videoIncruster[pv][v];
				videoIncruster.destroyVideo();
				_this.videoIncruster[pv][v] = null;
			}
			_this.videoIncruster[pv] = null;
		}
		_this.videoIncruster = new Array();
		customLog("on detruit tout les elements video du DOM, et on vide la liste");
	}
	
			
	_this.drawVideo = function(lienObj) {
    		var path = _GLOBALS.CONF.pages.videoIncrustePath;
    		var myclass = 'videoParent incruster';
    		var controls = 'controls="controls"';
    		var id = 'v';
			
			var origSize = {};
    		origSize.w = lienObj.w;
			origSize.h = lienObj.h;
    		
			var video = '<div class="'+ myclass +'" style="width:100%; height:100%;">';
    		
    		video += '<video id="'+id+'" class="video" width="100%" height="100%" autobuffer="true" '+controls+'>';
    		for (var i = 0; i < _GLOBALS.VideoTypeSupported.length; i++) {
    			video += '<source src="' + path + lienObj.urlvideo[i] + '?idvideo='+new Date().getTime()+'#'+new Date().getTime()+'" type="' + _GLOBALS.VideoTypeSupported[i] + '">';
    		}
    		video += 'Your browser does not support the video tag.</video>';
    		
    		video += '</div>';
    		return video;
    }
    
    _this.drawLinks = function(elem, pagenum, multiplicateurX) {
    			
		var decalageX = (elem.pos.x+(multiplicateurX*elem.pos.width));
        var decalageY = elem.pos.y;
               	        
        var links =  _this.getLinksForPage(pagenum+multiplicateurX, elem.pos.currScale, decalageX, decalageY);
        
        for (var l = 0; l < links.length; l++) {
        			
        	var lienObj = links[l];
            
        	if (lienObj.type == _GLOBALS.LinkTypeVideoIncruster || lienObj.type == _GLOBALS.LinkTypeVideoFiche) {
                
                if (lienObj.type == _GLOBALS.LinkTypeVideoIncruster) {
                	
                	if (_this.videoIncruster[lienObj.pagenum] == undefined) {              			
              			_this.videoIncruster[lienObj.pagenum] = new Array();
                	}
                	
                	if (_this.videoIncruster[lienObj.pagenum][lienObj._id] == undefined) {
              			var videoIncruster = new VideoIncruster(lienObj, _this);
              			
              			var html = videoIncruster.getHtml(_this.drawVideo(lienObj));
	               		$(html).appendTo($('body'));			
						
               			videoIncruster.setElement($('.linkVideo.'+lienObj._id));
               			_this.videoIncruster[lienObj.pagenum][lienObj._id] = videoIncruster;
               			
	                } else {
	                	
	                	var videoIncruster = _this.videoIncruster[lienObj.pagenum][lienObj._id];
	                	videoIncruster.resizeVideo();

	                	_this.hideVideo();
	                	_this.showVideo();
	                }
	                elem.ctx.fillStyle = "rgba(0,0,0,1)";
	                elem.ctx.fillRect(lienObj.x+decalageX,lienObj.y+decalageY,lienObj.w,lienObj.h);
                }
                
                if (lienObj.type == _GLOBALS.LinkTypeVideoFiche) {
                	_this.drawLienBox(elem,lienObj);
                }          
    			        		    			
        	} else if (lienObj.type == _GLOBALS.LinkTypeImageIncruster) {
				_this.drawImageOnContext(elem,lienObj);
  				
  			} else if (lienObj.type == _GLOBALS.LinkTypeAnimation) {
  				
  				if (_this.animations[lienObj.pagenum] == undefined) {              			
              		_this.animations[lienObj.pagenum] = new Array();
                }
                	
  				if (_this.animations[lienObj.pagenum][lienObj._id] == undefined) {  							
					var animation = new PageSwfLoader();
					animation.loadAnim(lienObj);
					_this.animations[lienObj.pagenum][lienObj._id] = animation;
					
  				} else {
  					var animation = _this.animations[lienObj.pagenum][lienObj._id];
  					console.log('resize animation');
	                animation.resize();               
  				}		
      
           	} else {
           		_this.drawLienBox(elem,lienObj);
  			
           	}
        }
   	}
   	
   	_this.drawLienBox = function(elem,lienObj) {
   		elem.ctx.beginPath();
        elem.ctx.rect(lienObj.xScreen,lienObj.yScreen,lienObj.w,lienObj.h);
        elem.ctx.fillStyle = "rgba(" + lienObj.color + ',' + lienObj.opacity + ")";
        elem.ctx.fill();
        if (lienObj.border) {
        	var color = "rgba(" + lienObj.color + ',' + 1 + ")";
        	if (lienObj.borderWidth == 1) {
        		_this.draw1pixelBorder(elem.ctx, lienObj.xScreen, lienObj.yScreen, lienObj.w, lienObj.h, color);
        	} else {
	        	elem.ctx.lineWidth = lienObj.borderWidth;
	        	elem.ctx.strokeStyle = color;
	        	elem.ctx.stroke();
        	}
        }	
   	}
   	   	
   	_this.draw1pixelBorder = function(context, x, y, w, h ,color) {
   		
   		//top
   		context.beginPath();
        context.rect(x,y,w,1);
        context.fillStyle = color;
        context.fill();
        //bot
        context.beginPath();
        context.rect(x,y+h-1,w,1);
        context.fillStyle = color;
        context.fill();
        //left
        context.beginPath();
        context.rect(x,y+1,1,h-2);
        context.fillStyle = color;
        context.fill();
        //right
        context.beginPath();
        context.rect(x+w-1,y+1,1,h-2);
        context.fillStyle = color;
        context.fill();
   	}     
   	   	
   	_this.drawImageOnContext = function(elem, lienObj) {
   		
   		if (elem.linksList[lienObj.url]) {
   			_this.onImageReady(elem,elem.linksList[lienObj.url],lienObj);
   		} else {
			var img = new Image();
			img.src = _GLOBALS.CONF.pages.imageIncrustePath + lienObj.url;
			img.onload = function(){
				_this.onImageReady(elem,img,lienObj);
				elem.linksList[lienObj.url] = img;
			}	
   		}	
   	}
   	
   	_this.onImageReady = function(elem, img, lienObj) {
		var ratioW = img.width/lienObj.w;
		var ratioH = img.height/lienObj.h;
		var newW = lienObj.w;
		var newH = lienObj.h;
		var newX = lienObj.xScreen;
		var newY = lienObj.yScreen;
		
		if (ratioH > ratioW) {
			newW = img.width / ratioH;
			newX += (lienObj.w - newW)/2;
		} else {
			newH = img.height / ratioW;
			newY += (lienObj.h - newH)/2;	
		}
		if (elem.ctx)
			elem.ctx.drawImage(img,(newX),(newY),(newW),(newH));
		//customLog('image Draw');	
   	}

	_this.showVideo = function()
	{
		clearTimeout(_this.videoTimer);
		_this.videoTimer = setTimeout(_this.showVideoSuite,500);		
	}
	
	_this.showVideoSuite = function() {
		var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;				
		var pageToShow = (_this.currentPageIsDouble()) ? 2 : 1;
			
		for (var j = 0; j < pageToShow; j++) {
			var pagen = pagenum+j;
			customLog('SHOW PAGE ' + pagen);
			if (_this.videoIncruster[pagen]) {
				for (var v in _this.videoIncruster[pagen])	{
					var videoIncruster = _this.videoIncruster[pagen][v];
					customLog('cool ' + pagen);
					if (videoIncruster.element) {
						videoIncruster.showVideo();
						videoIncruster.resizeVideo();			
					} else {
						customLog('a pu ' + pagen);
						var html = videoIncruster.getHtml(_this.drawVideo(videoIncruster.lienObj));
							               		$(html).appendTo($('body'));
						               			videoIncruster.setElement($('.linkVideo.'+videoIncruster.lienObj._id));			               			
					}
				}
			} 
		}
			    				
		for (var pv in _this.videoIncruster) {	
			if (pv*1 != pagenum && pv*1 != pagenum+pageToShow-1) {
				for (var v in _this.videoIncruster[pv])	{			
					var videoIncruster = _this.videoIncruster[pv][v];
					if (videoIncruster.element) {
						customLog('DEGAGE ' + pv );
						videoIncruster.destroyVideo();
					}					
					//_this.videoIncruster[pv][v] = null;
				}
				//_this.videoIncruster[pv] = null;
			}	
		}
	}
		
	_this.hideVideo = function( )
	{
		if ($('.linkVideo.show').length) {
			var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;				
			var pageToShow = (_this.currentPageIsDouble()) ? 2 : 1;

    		for (var j = 0; j < pageToShow; j++) {
    			var pagen = pagenum+j;
				if (_this.videoIncruster[pagen]) {
					for (var v in _this.videoIncruster[pagen])	{
						var videoIncruster = _this.videoIncruster[pagen][v];
						var v = $(videoIncruster.element).find('#v');
						$(v)[0].pause();
						videoIncruster.hideVideo();
					}					
				}
    		}
		}
	}
		
	_this.animationTimer;
	
	_this.showAnimation = function() {
		clearTimeout(_this.animationTimer);
		_this.animationTimer = setTimeout(_this.showAnimationSuite,500);	
	}
	
	_this.showAnimationSuite = function() {
	
	    var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
		
		var pageToShow = (_this.currentPageIsDouble()) ? 2 : 1;

    	for (var j = 0; j < pageToShow; j++) {
				var pagen = pagenum+j;
				if (_this.animations[pagen]) {
					for (var a in _this.animations[pagen])	{
						var animation = _this.animations[pagen][a];
						console.log('_this.showAnimationSuite');
						if (animation.div) {
							animation.resize();
							animation.showMe();							
						} else {
							animation.loadAnim(animation.lienObj);
						}
					}
				} 
			}
				    				
			for (var pa in _this.animations) {	
				if (pa*1 != pagenum && pa*1 != pagenum+pageToShow-1) {
					for (var a in _this.animations[pa])	{			
						var animation = _this.animations[pa][a];
						if (animation.div) {
							customLog('DEGAGE ' + pa );
							animation._destroy(); 
						}
					}
				}	
			}
	}
	
	_this.resizeAnimation = function() {
		if ($('.iconeDefault').length || $('.animPage').length) {
		    var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
			
			var pageToShow = (_this.currentPageIsDouble()) ? 2 : 1;
			
			for (var j = 0; j < pageToShow; j++) {
    			var pagen = pagenum+j;
				if (_this.animations[pagen]) {
					for (var a in _this.animations[pagen])	{
						var animation = _this.animations[pagen][a];
						if (animation.div) {
							animation.resize();
						}
					}					
				}
    		}
		}
	}
	
	_this.hideAnimation = function() {
		if ($('.iconeDefault').length || $('.animPage').length) {
		    var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
			
			var pageToShow = (_this.currentPageIsDouble()) ? 2 : 1;
			
			for (var j = 0; j < pageToShow; j++) {
    			var pagen = pagenum+j;
				if (_this.animations[pagen]) {
					for (var a in _this.animations[pagen])	{
						var animation = _this.animations[pagen][a];
						if (animation.div) {
							animation.hideMe();
						}
					}					
				}
    		}
		}
	}
	
	_this.moveAnimation = function(moveDiffX,moveDiffY) {
		if ($('.iconeDefault').length || $('.animPage').length) {
		    var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
			
			var pageToShow = (_this.currentPageIsDouble()) ? 2 : 1;
			
			for (var j = 0; j < pageToShow; j++) {
    			var pagen = pagenum+j;
				if (_this.animations[pagen]) {
					for (var a in _this.animations[pagen])	{
						var animation = _this.animations[pagen][a];
						if (animation.div) {
							animation.moveMe(moveDiffX,moveDiffY);
						}
					}					
				}
    		}
		}
	}
   	
	/* EVENTS */
	
	/*$(document).bind('webkitfullscreenchange', _this.onFullscreenChange);
	
	_this.onFullscreenChange = function( ) {
		alert('prout');
	}
	
	var previousState = 0;*/

	UTILS.onResizeCustom(function()
	{
		if( _this.popupLink && _this.popupLink.resize )
		{
			_this.popupLink.resize();
		}		
		_this.hideVideo();
		_this.showVideo();
		
		console.log("onResizeCustom");
		
		//_this.resizeAnimation();

	});
		
	_this.onDragElem = function(moveDiffX,moveDiffY) {
		_this.hideVideo();
		//_this.hideAnimation();
		
	}

	_this.onDropElem = function( ) {
		_this.showVideo();
		//_this.showAnimation();
	}
	
	_this.goToPage = function(nb)
	{
		_this.hideVideo();
		_this.showVideo();
		
		//_this.showAnimation();
	}   	
    _this._construct(); 
}
/*****/

_GLOBALS.callbackLoaded("LinksManager");