/** By Massi 11/06/2012 Proprieté de NetInteractive
 * Class : listLinksType 
 * Cette Class depend linksManager.js
 * 
 * Param (Object)linksListByPage ? Liste of links for one page 
 * Methode : abstract utilsFuncPosition	: Params ( $() currentElem , Object listObj , String linkTypeCurrent , $() elemCreated )return (this)
 * Methode : public LinkTypeZoomPartiel	: Params ( $() currentElem , Object listObj , String LinkTypeIs )return (this)
 * Methode : public LinkTypeVideo 		: Params ( $() currentElem , Object listObj , String LinkTypeIs )return (this)
 * Methode : public LinkTypeWeb			: Params ( $() currentElem , Object listObj , String LinkTypeIs )return (this)
 * Methode : public LinkTypeGalerie		: Params ( $() currentElem , Object listObj , String LinkTypeIs )return (this)
 * Methode : public LinkTypeFiche		: Params ( $() currentElem , Object listObj , String LinkTypeIs )return (this)
 * Methode : public LinkTypeAudio		: Params ( $() currentElem , Object listObj , String LinkTypeIs )return (this)
 * Methode : public LinkTypeGotoPage	: Params ( $() currentElem , Object listObj , String LinkTypeIs )return (this)
 * Methode : public LinkTypePhone		: Params ( $() currentElem , Object listObj , String LinkTypeIs )return (this)
 * Methode : public LinkTypeMail		: Params ( $() currentElem , Object listObj , String LinkTypeIs )return (this)
 * Methode : public LinkTypeNone		: Params ( $() currentElem , Object listObj , String LinkTypeIs )return (this)
*/

var listLinksType =
{
	/*abstract class*/
	utilsFuncPosition : function( currentElem , listObj , linkTypeCurrent , elemCreated )
	{
		var _this			= this;
		_this.currentElem	= currentElem;
		_this.elemCreated	= elemCreated;
		
		_this.originalParentWidth	= window.parent.mainInit.config.originalParentWidth;
		_this.originalParentHeight	= window.parent.mainInit.config.originalParentHeight;
		
		_this._construct = function()
		{
			_this.getList();
		}
		
		_this.getList = function()
		{
			for(var J in listObj )
			{
				_this.goPos(listObj[J] , J );
			}
			_this.generatEvents();
		}
		
		_this.goPos = function( params , idCount )
		{
			var prcWidth	= Math.ceil(100/(_this.originalParentWidth/params["width"]));
			var prcHeight	= Math.ceil(100/(_this.originalParentHeight/params["height"]));
			
			var prcLeft		= Math.ceil(100/(_this.originalParentWidth/params["left"]));
			var prcTop		= Math.ceil(100/(_this.originalParentHeight/params["top"]));
			
			var currentElemCreated = $(_this.elemCreated);
			currentElemCreated.attr("id",linkTypeCurrent+"_"+idCount);
			currentElemCreated.css({
				width:prcWidth+"%",
				height:prcHeight+"%",
				left:prcLeft+"%",
				top:prcTop+"%",
				zIndex:_this.originalZindex
			});
			
			var prcLeft		= Math.ceil((100/(prcWidth/prcLeft))*10)/10;
			var prcTop		= Math.ceil((100/(prcHeight/prcTop))*10)/10;
			
			currentElemCreated[0].paramsList = params;
			
			_this.currentElem.parent().append(currentElemCreated);
		}
		
		_this.generatEvents = function()
		{
			var allEleme = 	currentElem.parent().find(".extraLink");
			var allElemefilter = currentElem.parent().find(".filterHover");
			allElemefilter.fadeOut(2000);
		}
		
		_this._construct();
		return this;
	},
	
	/*public*/
	LinkTypeZoomPartiel : function( currentElem , listObj , LinkTypeIs )
	{
		var _this			= this;
		_this.LinkTypeIs	= LinkTypeIs;
		_this.currentElem	= currentElem;
		_this.elemCloned	= false;
		_this.originalZindex= 10;
		
		_this._construct = function()
		{			
			currentElem.children("."+_this.LinkTypeIs).unbind();
			
			if(!_this.elemCloned)
			{
				_this.cloneElem();
			}
			_this.getList();
		}
		
		_this.getList = function()
		{
			for(var J in listObj )
			{
				_this.goPos(listObj[J] , J );
			}
			_this.generatEvents();
		}
		
		_this.cloneElem = function()
		{
			_this.elemCloned = "<div class='extraLink "+_this.LinkTypeIs+"' style='position:absolute; overflow:hidden;' scaled='false' ><div style='display:block' class='interZoom' >"+_this.currentElem.html()+"</div><div class='filterHover' style='top:0;left:0;position:absolute;width:100%;height:100%;'></div></div>";
		}
		
		_this.goPos = function( params , idCount )
		{
			var prcWidth	= Math.ceil(100/(_this.originalParentWidth/params["width"]));
			var prcHeight	= Math.ceil(100/(_this.originalParentHeight/params["height"]));
			
			var prcLeft		= Math.ceil(100/(_this.originalParentWidth/params["left"]));
			var prcTop		= Math.ceil(100/(_this.originalParentHeight/params["top"]));
			
			var currentElemCloned = $(_this.elemCloned);
			currentElemCloned.attr("id","LinkTypeZoomPartiel_"+idCount);
			currentElemCloned.attr("original_left",prcLeft);
			currentElemCloned.attr("original_top",prcTop);
			
			currentElemCloned.css({
				width:prcWidth+"%",
				height:prcHeight+"%",
				left:prcLeft+"%",
				top:prcTop+"%",
				zIndex:_this.originalZindex
			});
		
			
			var prcLeft		= Math.ceil((100/(prcWidth/prcLeft))*10)/10;
			var prcTop		= Math.ceil((100/(prcHeight/prcTop))*10)/10;
			currentElemCloned.children(".interZoom").css(
			{
				left:-prcLeft+"%",
				top:-prcTop+"%",
				position:"absolute"				
			});
			
			_this.currentElem.parent().append(currentElemCloned);
		}
		
		_this.goZoom = function()
		{
			var toShow = currentElem.parent().find("."+_this.LinkTypeIs);
			if( !toHid.is(":visible") )
			{
				toHid.css("display","block");
			}
		}
		
		_this.goNoZoom = function()
		{
			var toHid = currentElem.parent().find("."+_this.LinkTypeIs);
			if( toHid.is(":visible") )
			{
				toHid.css("display","none");
			}
		}
		
		_this.zoom = function(zoomStat)
		{
			if(zoomStat)
			{
				_this.goZoom();
			}else
			{
				_this.goNoZoom();
			}
		}
		
		_this.generatEvents = function()
		{
			var allEleme = 	currentElem.parent().find("."+_this.LinkTypeIs);
			var allElemefilter = currentElem.parent().find(".filterHover");
			allElemefilter.fadeOut(2000);
			
			
			allEleme.bind("click",function()
			{
				var currElemeThis = $(this);
		
				if(!allEleme.not("#"+currElemeThis.attr("id")).length)
				{
					_this.complementAnim(currElemeThis);
				}
				else
				{
					allEleme.not("#"+currElemeThis.attr("id")).attr("scaled", "false");
					allEleme.not("#"+currElemeThis.attr("id")).css("z-index",_this.originalZindex);
					allEleme.not("#"+currElemeThis.attr("id")).transition({
						scale:1
					},100,function()
					{
						_this.complementAnim(currElemeThis);
					})
				}
			});
		}
		
		_this.complementAnim = function(currElemeThis)
		{
			if( currElemeThis.attr("scaled") != "true" )
			{
				currElemeThis.css("z-index",_this.originalZindex+1);
				currElemeThis.attr("scaled", "true");
				
				var centerPosLeft = Math.floor((50-((100*(currElemeThis.width()/currElemeThis.parent().width()))/2))*10)/10;
				var centerPosTop = Math.floor((50-((100*(currElemeThis.height()/currElemeThis.parent().height()))/2))*10)/10;
				
				currElemeThis.animate({
					left:centerPosLeft+"%",
					top:centerPosTop+"%"
				},200,function()
				{
					currElemeThis.transition({
					scale:2
					},200);
				});
				
				
			}else
			{
				currElemeThis.transition({
					scale:1
				},200,function()
				{
					currElemeThis.attr("scaled", "false");
					currElemeThis.css("z-index",_this.originalZindex);
					
					currElemeThis.animate({
					left:currElemeThis.attr("original_left")+"%",
					top:currElemeThis.attr("original_top")+"%"
					},200)
				})
				
			}
		}
		
		_this._construct();

		return this;
	},
	
	/*public*/
	LinkTypeVideo : function( currentElem , listObj , LinkTypeIs )
	{
		var _this			= this;
		_this.LinkTypeIs	= LinkTypeIs;
		_this.currentElem	= currentElem;
		_this.elemCreated	= false;
		
		_this._construct = function()
		{
			currentElem.children("."+_this.LinkTypeIs).unbind();			
			if(!_this.elemCreated)
			{
				_this.creatElemCurrent();
			}			
			window.parent.listLinksType.utilsFuncPosition( currentElem , listObj , _this.LinkTypeIs , _this.elemCreated );
		}
		
		_this.videoTpl = function( setupVdo , pathVdo , poster , vdoId )
		{
			if(!setupVdo)
			{
				setupVdo="";
			}
			
			if(!poster)
			{
				poster="";
			}
			else
			{
				poster="poster='"+poster+"'";
			}
			
			var tplVieo	= "";
			
			tplVieo 	+= '<video id="'+vdoId+'" class="video-js vjs-default-skin" controls';
			tplVieo 	+= ' preload="auto" '+poster+'>';
			tplVieo 	+= '<source src="'+pathVdo+'" type="video/mp4"/>';
			tplVieo 	+= '</video>';
			
			return tplVieo;
		}
		
		_this.creatElemCurrent = function()
		{
			var currVdo =_this.videoTpl(
			"",
			"http://video-js.zencoder.com/oceans-clip.mp4",
			"http://video-js.zencoder.com/oceans-clip.jpg",
			"vdoId1"
			);
			_this.elemCreated = "<div class='extraLink "+_this.LinkTypeIs+"' style='position:absolute;' >"+currVdo+"</div>";
		}
		
		// _V_("vdoId1", {}, function()
			// {
				// console.log(this);
			// });
		
		_this._construct();
		
		return this;
	},
	
	/*public*/
	LinkTypeWeb : function( currentElem , listObj , LinkTypeIs )
	{
		var _this			= this;
		_this.LinkTypeIs	= LinkTypeIs;
		_this.currentElem	= currentElem;
		_this.elemCreated	= false;
		
		_this._construct = function()
		{
			currentElem.children("."+_this.LinkTypeIs).unbind();
			
			if(!_this.elemCreated)
			{
				_this.creatElemCurrent();
			}
			
			window.parent.listLinksType.utilsFuncPosition( currentElem , listObj , _this.LinkTypeIs , _this.elemCreated );
			
			_this.createActions();
		}
		
		_this.creatElemCurrent = function()
		{
			_this.elemCreated = "<a href='javascript:void(0)' class='extraLink "+_this.LinkTypeIs+"' style='position:absolute;' ><div class='filterHover' style='top:0;left:0;position:absolute;width:100%;height:100%;'></div></a>";
		}
		
		_this.createActions = function()
		{
			currentElem.parent().find("."+_this.LinkTypeIs).click(function()
			{
				if($(this)[0].paramsList.target == "_blank")
				{
					window.open($(this)[0].paramsList.href);
				}else
				{
					window.location.href = $(this)[0].paramsList.href;
				}
				
			})
		}
		
		_this._construct();
	
		return this;
	},
	
	/*public*/
	LinkTypeGalerie : function( currentElem , listObj , LinkTypeIs )
	{
		var _this			= this;
		_this.LinkTypeIs	= LinkTypeIs;
		_this.currentElem	= currentElem;
		_this.elemCreated	= false;
		
		_this._construct = function()
		{
			currentElem.children("."+_this.LinkTypeIs).unbind();
			
			if(!_this.elemCreated)
			{
				_this.creatElemCurrent();
			}
			
			window.parent.listLinksType.utilsFuncPosition( currentElem , listObj , _this.LinkTypeIs , _this.elemCreated );
			
			_this.createActions();
		}
		
		_this.creatElemCurrent = function()
		{
			_this.elemCreated = "<a href='javascript:void(0)' class='extraLink "+_this.LinkTypeIs+"' style='position:absolute;' ><div class='filterHover' style='top:0;left:0;position:absolute;width:100%;height:100%;'></div></a>";
		}
		
		_this.createActions = function()
		{
			currentElem.parent().find("."+_this.LinkTypeIs).click(function()
			{
				alert(LinkTypeIs);			
			})
		}
		
		_this._construct();
	
		return this;
	},
	
	/*public*/
	LinkTypeFiche : function( currentElem , listObj , LinkTypeIs )
	{
		var _this			= this;
		_this.LinkTypeIs	= LinkTypeIs;
		_this.currentElem	= currentElem;
		_this.elemCreated	= false;
		
		_this._construct = function()
		{
			currentElem.children("."+_this.LinkTypeIs).unbind();
			
			if(!_this.elemCreated)
			{
				_this.creatElemCurrent();
			}
			
			window.parent.listLinksType.utilsFuncPosition( currentElem , listObj , _this.LinkTypeIs , _this.elemCreated );
			
			_this.createActions();
		}
		
		_this.creatElemCurrent = function()
		{
			_this.elemCreated = "<a href='javascript:void(0)' class='extraLink "+_this.LinkTypeIs+"' style='position:absolute;' ><div class='filterHover' style='top:0;left:0;position:absolute;width:100%;height:100%;'></div></a>";
		}
		
		_this.createActions = function()
		{
			currentElem.parent().find("."+_this.LinkTypeIs).click(function()
			{
				alert(LinkTypeIs);			
			})
		}
		
		_this._construct();
	
		return this;
	},
	
	/*public*/
	LinkTypeAudio : function( currentElem , listObj , LinkTypeIs )
	{
		var _this			= this;
		_this.LinkTypeIs	= LinkTypeIs;
		_this.currentElem	= currentElem;
		_this.elemCreated	= false;
		
		_this._construct = function()
		{
			currentElem.children("."+_this.LinkTypeIs).unbind();
			
			if(!_this.elemCreated)
			{
				_this.creatElemCurrent();
			}
			
			window.parent.listLinksType.utilsFuncPosition( currentElem , listObj , _this.LinkTypeIs , _this.elemCreated );
			
			_this.createActions();
		}
		
		_this.creatElemCurrent = function()
		{
			_this.elemCreated = "<a href='javascript:void(0)' class='extraLink "+_this.LinkTypeIs+"' style='position:absolute;' ><div class='filterHover' style='top:0;left:0;position:absolute;width:100%;height:100%;'></div></a>";
		}
		
		_this.createActions = function()
		{
			currentElem.parent().find("."+_this.LinkTypeIs).click(function()
			{
				alert(LinkTypeIs);			
			})
		}
		
		_this._construct();
	
		return this;
	},
	
	/*public*/
	LinkTypeGotoPage : function( currentElem , listObj , LinkTypeIs )
	{
		var _this			= this;
		_this.LinkTypeIs	= LinkTypeIs;
		_this.currentElem	= currentElem;
		_this.elemCreated	= false;
		
		_this._construct = function()
		{
			currentElem.children("."+_this.LinkTypeIs).unbind();
			
			if(!_this.elemCreated)
			{
				_this.creatElemCurrent();
			}
			
			window.parent.listLinksType.utilsFuncPosition( currentElem , listObj , _this.LinkTypeIs , _this.elemCreated );
			
			_this.createActions();
		}
		
		_this.creatElemCurrent = function()
		{
			_this.elemCreated = "<a href='javascript:void(0)' class='extraLink "+_this.LinkTypeIs+"' style='position:absolute;' ><div class='filterHover' style='top:0;left:0;position:absolute;width:100%;height:100%;'></div></a>";
		}
		
		_this.createActions = function()
		{
			currentElem.parent().find("."+_this.LinkTypeIs).click(function()
			{
				alert(LinkTypeIs);			
			})
		}
		
		_this._construct();
	
		return this;
	},
	
	/*public*/
	LinkTypePhone : function( currentElem , listObj , LinkTypeIs )
	{
		var _this			= this;
		_this.LinkTypeIs	= LinkTypeIs;
		_this.currentElem	= currentElem;
		_this.elemCreated	= false;
		
		_this._construct = function()
		{
			currentElem.children("."+_this.LinkTypeIs).unbind();
			
			if(!_this.elemCreated)
			{
				_this.creatElemCurrent();
			}
			
			window.parent.listLinksType.utilsFuncPosition( currentElem , listObj , _this.LinkTypeIs , _this.elemCreated );
			
			_this.createActions();
		}
		
		_this.creatElemCurrent = function()
		{
			_this.elemCreated = "<a href='javascript:void(0)' class='extraLink "+_this.LinkTypeIs+"' style='position:absolute;' ><div class='filterHover' style='top:0;left:0;position:absolute;width:100%;height:100%;'></div></a>";
		}
		
		_this.createActions = function()
		{
			currentElem.parent().find("."+_this.LinkTypeIs).click(function()
			{
				alert(LinkTypeIs);			
			})
		}
		
		_this._construct();
	
		return this;
	},
	
	/*public*/
	LinkTypeMail : function( currentElem , listObj , LinkTypeIs )
	{
		var _this			= this;
		_this.LinkTypeIs	= LinkTypeIs;
		_this.currentElem	= currentElem;
		_this.elemCreated	= false;
		
		_this._construct = function()
		{
			currentElem.children("."+_this.LinkTypeIs).unbind();
			
			if(!_this.elemCreated)
			{
				_this.creatElemCurrent();
			}
			
			window.parent.listLinksType.utilsFuncPosition( currentElem , listObj , _this.LinkTypeIs , _this.elemCreated );
			
			_this.createActions();
		}
		
		_this.creatElemCurrent = function()
		{
			_this.elemCreated = "<a href='javascript:void(0)' class='extraLink "+_this.LinkTypeIs+"' style='position:absolute;' ><div class='filterHover' style='top:0;left:0;position:absolute;width:100%;height:100%;'></div></a>";
		}
		
		_this.createActions = function()
		{
			currentElem.parent().find("."+_this.LinkTypeIs).click(function()
			{
				alert(LinkTypeIs);			
			})
		}
		
		_this._construct();
	
		return this;
	},
	
	/*public*/
	LinkTypeNone : function( currentElem , listObj , LinkTypeIs )
	{
		var _this			= this;
		_this.LinkTypeIs	= LinkTypeIs;
		_this.currentElem	= currentElem;
		_this.elemCreated	= false;
		
		_this._construct = function()
		{
			currentElem.children("."+_this.LinkTypeIs).unbind();
			
			if(!_this.elemCreated)
			{
				_this.creatElemCurrent();
			}
			
			window.parent.listLinksType.utilsFuncPosition( currentElem , listObj , _this.LinkTypeIs , _this.elemCreated );
			
			_this.createActions();
		}
		
		_this.creatElemCurrent = function()
		{
			_this.elemCreated = "<a href='javascript:void(0)' class='extraLink "+_this.LinkTypeIs+"' style='position:absolute;' ><div class='filterHover' style='top:0;left:0;position:absolute;width:100%;height:100%;'></div></a>";
		}
		
		_this.createActions = function()
		{
			currentElem.parent().find("."+_this.LinkTypeIs).click(function()
			{
				alert(LinkTypeIs);			
			})
		}
		
		_this._construct();
	
		return this;
	}
}