var MenuParamManager = function( parent , objName , menuParam , dynamiqueDesabler )
{
	var _this = this;
	_this.objName;
	_this.parent;
	_this.menuParam;
	_this.tools = parent.xmlLinksList.getXml.tools;
	_this.fonctionaliteMenu;
	_this.arrayOfClassElemForEvent		= new Array();
	_this.arrayOfClassElemForEventFuncs	= new Array();
	_this.dynamiqueDesabler				= dynamiqueDesabler;
	_this.objectToAppend				= "";
	_this.appendToElem					= "";
	_this.contDiv						= "";
	_this.menu_alpha					= _GLOBALS.CONF.menuCss.menu_alpha;
	_this.funcId						= "funcId_";
	_this.baliseName = 
	{
		conf	: "conf",
		gauche	: "gauche",
		milieu	: "milieu",
		droite	: "droite",
		bouton	: "bouton",
		button	: "button"
	}
	
	_this.simulViewMenu	=
	{
		gauche : new Array(),
		milieu : new Array(),
		droite : new Array()
	}
	
	_this.attrListAll =
	{
		type				: "type",
		classe 				: "classe",
		custom 				: "custom",
		tip 				: "tip"
	}
	
	_this._construct = function()
	{
		_this.objName			= objName;
		_this.parent			= parent;
		_this.menuParam			= menuParam;
		
		if(!_this.checkIfCustomEnabled())
		{
			return false;
		}
		
		_this.fonctionaliteMenu = new fonctionaliteMenuManager( _this , "fonctionaliteMenu" , _this.dynamiqueDesabler );
		
		_this.hardAddFonctionalityList();
		_this.constructMenuCss();
		_this.constructMenu();
	}
	
	_this.hardAddFonctionalityList = function()
	{
		for( var J in _this.fonctionaliteMenu.hardAddFonctionalityList )
		{
			var currF = _this.fonctionaliteMenu.hardAddFonctionalityList[J];
			if( currF.active )
			{
				var currBalise = _this.menuParam.find(_this.baliseName[ currF.elementPos ]);
				currBalise.children().each(function(e)
				{
					if( currF.elementPosNumber === e )
					{
						$(currF.xmlAdd).insertBefore($(this));
					}
				})
			}
		}
	}	
	
	_this.checkIfCustomEnabled = function()
	{
		var menuBasic = _this.tools.find("menuBasic");
		_this.objectToAppend = menuBasic.attr("className");
		_this.appendToElem = $(menuBasic.attr("appendToElem"));
		
		if( !menuBasic.attr("enabled") || menuBasic.attr("enabled") == "false" )
		{
			return false;
		}
		return true;
	}
	
	_this.constructMenuCss = function()
	{
		var menuBasic = _this.tools.find("menuBasic");
		var defCss = menuBasic.children("defCss");
		var styleCur = "";
		if(defCss)
		{
			styleCur = document.createElement("style");
			$(styleCur).append(defCss.text());
			$("head").append($(styleCur));
		}
	}
	
	_this.constructMenu = function()
	{
		_this.contDiv = $("<div class='"+_this.objectToAppend+"' ></div>");
		for( var J in _this.simulViewMenu )
		{
			var infoXML_Obj = _this.menuParam.find(_this.baliseName[J]).find(_this.baliseName.bouton);
			if(!infoXML_Obj.length)
			{
				infoXML_Obj = _this.menuParam.find(_this.baliseName[J]).find(_this.baliseName.button);
			}
			infoXML_Obj.each(function(e)
			{
				var attrList = _this.getAttrToArray($(this),J,e);
				_this.simulViewMenu[J].push(attrList);							
			})
		}
		return _this.simulViewMenu;
	}
	
	_this.getAttrToArray = function(OBJ,posE,cE)
	{
		var methodeNameArray = new Array();
		var OBJAttr = OBJ.attr(_this.attrListAll.type);
		if( OBJAttr && _this.fonctionaliteMenu.fonctionaliteList[OBJAttr] && _this.fonctionaliteMenu.fonctionaliteList[OBJAttr].active
		){}else
		{
			return false;
		}

		if( OBJAttr == _this.attrListAll.custom )
		{
			_this.fonctionaliteMenu.fonctionaliteList[_this.funcId+posE+"_"+cE] = {};
			var chil = OBJ.children("thisOnload");
			if( chil && chil.length && $.trim(chil) != "" )
			{
				var txt = chil.text();
				var currFunc = "";
				try
				{
					eval("currFunc = "+txt);
				}catch(e)
				{
					_GLOBALS.javascriptInit.debugEnable();
					console.log("Prod did some error in menuParam.xml codeJs => "+chil.text());
					console.log(e);
				}				
				_this.fonctionaliteMenu.fonctionaliteList[_this.funcId+posE+"_"+cE].actionOnload = currFunc;
			}
			
			var chil = OBJ.children("thisOnClick");
			if( chil && chil.length && $.trim(chil) != "" )
			{
				var txt = chil.text();
				var currFunc = "";
				try
				{
					eval("currFunc = "+txt);
				}catch(e)
				{
					_GLOBALS.javascriptInit.debugEnable();
					console.log("Prod did some error in menuParam.xml codeJs => "+chil.text());
					console.log(e);
				}
				_this.fonctionaliteMenu.fonctionaliteList[_this.funcId+posE+"_"+cE].func = currFunc;
			}
		}
		
		for( var J = 0 ; J < OBJ[0].attributes.length ; J++ )
		{
			if( _this.attrListAll[OBJ[0].attributes[J].name] )
			{
				methodeNameArray[ _this.attrListAll[OBJ[0].attributes[J].name] ] = OBJ.attr(OBJ[0].attributes[J].name);
			}
		}

		return methodeNameArray;
	}

	_this.setStyleContent = function()
	{
		var sty = "style='";
		var amount = _this.menu_alpha;
		var teinte = _this.menuParam[0].getAttribute("teinte");
		if( teinte )
		{
			_GLOBALS.CONF.iconesDefaultParam.teinte = UTILS.hex16(teinte);
			_GLOBALS.CONF.iconesDefaultParam.teinteRGB = new convertHexToRGB(_GLOBALS.CONF.iconesDefaultParam.teinte);
		}
		
		var hexColor = _this.menuParam[0].getAttribute("fond");
		
		if( !amount && amount!==0 )
		{
			amount = parseFloat(_this.menuParam[0].getAttribute("amount"))/100;
			if( amount !==0 && !amount )
			{
				amount = 1;
			}
		}
		
		
		if( hexColor )
		{
			// var rCol = parseInt(hexColor,16).toString(16);
			var rCol = UTILS.hex16(hexColor);
			var rCol = new convertHexToRGB(rCol);
			sty+="background-color:rgba("+rCol+" , "+amount+" );";
			_this.contDiv.css( "box-shadow" , "0px 0px 5px 1px rgba( 0, 0, 0, "+(amount/100)+" )");
		}
		
		sty+="' ";
		return sty;
	}
	
	//AND CSS
	_this.htmlMenu = function( htmlArray )
	{
		var styleTable = _this.setStyleContent();
		var maTable ="";
		for( J in htmlArray )
		{
			maTable += "<td class='menu_"+J+"'>"+htmlArray[J]+"</td>";
		}
		return $("<table class='menuTop' "+styleTable+" ><tr>"+maTable+"</tr></table>");
	}
	
	_this.customFunc = function(elem)
	{
		if(_this.fonctionaliteMenu.fonctionaliteList[elem.attr("funcid")].sended)
		{
			return void(0);
		}
		_this.fonctionaliteMenu.fonctionaliteList[elem.attr("funcid")].sended = true;
		if( _this.fonctionaliteMenu.fonctionaliteList[elem.attr("funcid")].actionOnload )
		{
			_this.fonctionaliteMenu.fonctionaliteList[elem.attr("funcid")].actionOnload(elem);
		}
		
		elem.unbind("click");
		elem.bind("click",function( event )
		{
			if( _this.fonctionaliteMenu.fonctionaliteList[$(this).attr("funcid")].func && _this.fonctionaliteMenu.fonctionaliteList[$(this).attr("funcid")].func != "" )
			{
				_this.fonctionaliteMenu.fonctionaliteList[$(this).attr("funcid")].func($(this));
			}
			UTILS.preventDefault(event);
		})
	}
	
	_this.activAllEventIco = function(currJqElem)
	{
		for( var i = 0 ; i < _this.arrayOfClassElemForEvent.length ; i++ )
		{
			var currElem = currJqElem.find("."+_this.arrayOfClassElemForEvent[i]);
			if( currElem.attr("funcid") && currElem.attr("currClass") == _this.attrListAll.custom )
			{
				currElem.each(function()
				{
					_this.customFunc($(this));
				});
				
			}else
			{
				if( _this.fonctionaliteMenu.fonctionaliteList[currElem.attr("currClass")].actionOnload )
				{
					_this.fonctionaliteMenu.fonctionaliteList[currElem.attr("currClass")].actionOnload(currElem);
				}
				
				currElem.unbind("click");
				currElem.bind("click",function( event )
				{
					if( _this.fonctionaliteMenu.fonctionaliteList[$(this).attr("currClass")].func && _this.fonctionaliteMenu.fonctionaliteList[$(this).attr("currClass")].func != "" )
					{
						_this.fonctionaliteMenu.fonctionaliteList[$(this).attr("currClass")].func($(this));
					}
					UTILS.preventDefault(event);
				})
			}
			
		}
	}
	
	_this.menuTouchStart = function(event)
	{
		var target = event.target || event.srcElement;
		$(target).parent("td").triggerHandler("click");
		UTILS.preventDefault(event);
	}
	
	_this.getMenu = function()
	{
		var htmlArray = new Array();
		for( var J in _this.simulViewMenu )
		{
			htmlArray[J] = "<table><tr>";
			for( var sJ in _this.simulViewMenu[J] )
			{
				if( !_this.simulViewMenu[J][sJ] )
				{
					continue;
				}
				var currFunc	= _this.simulViewMenu[J][sJ].func;				
				var currClass	= "menuTop_"+_this.simulViewMenu[J][sJ].type;
				var currElem	= "<td class='"+currClass+"' funcid='"+_this.funcId+J+"_"+sJ+"' currClass='"+_this.simulViewMenu[J][sJ].type+"' href='javascript:void(0)' ></td>";
				htmlArray[J]	+= currElem;
			
				_this.arrayOfClassElemForEvent.push(currClass);
				_this.arrayOfClassElemForEventFuncs[currClass] = currFunc;
				
			}
			htmlArray[J] += "</tr></table>";
		}
		
		var currJqElem = _this.htmlMenu( htmlArray );
		_this.activAllEventIco(currJqElem);
		_this.contDiv.append(currJqElem);
		_this.appendToElem.append(_this.contDiv);
		
		$("."+_this.objectToAppend)[0].addEventListener( "touchstart", _this.menuTouchStart , false);
		
		return currJqElem;
	}
	return _this._construct();
}
_GLOBALS.callbackLoaded("menuParamManager");