var PageSwfLoader = function() {
	var _this = this;
	_this.systemPath;
	_this.lienObj;
	_this.div;
	_this.name = "";
	_this.stage;
	_this.currentBox = {};
	_this.path ="";
	_this.swiffyJSON;
	
	_this._construct = function() {
		
		_this.systemPath = _GLOBALS.javascriptInit.path;

	}
		
	_this.loadAnim = function(lienObj) {
		_this.lienObj = lienObj;
		if (_this.div) {
			_this._destroy();
		}

		_this.name = UTILS.getFilenameWithoutExtension(lienObj.url)
		console.log('construct '+_this.name);
					
		_this.path = _GLOBALS.CONF.pages.videoIncrustePath + 'createjs/';
		var filepath = _this.path + _this.name + '.json';
		
		_this.loadCurrJson(filepath);
		
	}
	
	_this.loadCurrJson = function( cPath )
	{
		var div = '<div id="'+_this.name+'" class="animPage show" frameborder="0" marginheight="0" marginwidth="0" scrolling="false" ';
	      	div += 'style=" left:'+_this.lienObj.xScreen+'px; top:'+_this.lienObj.yScreen+'px; width:'+_this.lienObj.w+'px; height:'+_this.lienObj.h+'px">';
	      	div += '	<div id="'+_this.name+'Anim" style="width: 100%; height:100%; background:none;"></div>';
	      	div += '	<div id="'+_this.name+'Progress" style="position:absolute; left:25%; top:25%; width: 0px; height:10px; background:#FF9090; border: 1px solid black;"></div>';
	      	div += '</div>';
	      			      		
		$('body').append(div);
		_this.div = document.getElementById(_this.name);
		 	
		$.ajax(
		{
			xhr: function()
			{
				var xhr = new window.XMLHttpRequest();
				//Download progress
				xhr.addEventListener("progress", function(evt)
				{
					if (evt.lengthComputable)
					{
						var percentComplete = (evt.loaded / evt.total)*100;
						var progdiv = document.getElementById(_this.name+'Progress');
						$(progdiv).css('width',(percentComplete/2)+'%');
					}
				}, false);
				return xhr;
			},type: 'GET',url: cPath ,data: {},
			success: function(data)
			{
				_this.swiffyJSON =  jQuery.parseJSON(data);

		      	_this.currentBox.opacity = 1;      		
		      	
				var animdiv = document.getElementById(_this.name+'Anim');					
				_this.stage = new swiffy.Stage( animdiv, _this.swiffyJSON);
				_this.stage.start();
				
				var progdiv = document.getElementById(_this.name+'Progress');
				$(progdiv).remove();
				return void(0);
			},error:function(data)
			{
				console.log("error");
				_this._destroy();
				return void(0);
			}
		});	
		return void(0);		
	}
	
	_this._destroy = function() {
		console.log('destroy '+_this.name);
				
		$(_this.div).remove();
		_this.div = null;
		
		_this.stage = null;
		
		_this.deleteDeep(_this.swiffyJSON);

		_this.swiffyJSON = null;
		
		_this.currentBox = {};				
	}
	
	_this.deleteDeep = function(obj) {
		for (var i in obj) {
			var newobj = obj[i];
			if (typeof newobj == "object") {
				_this.deleteDeep(newobj);
			}			
			delete obj[i];
		}
	}

	_this.resize = function()
	{		
		if (_this.lienObj.w == _this.currentBox.w &&  _this.lienObj.h == _this.currentBox.h) {
			return false;	
		}
		//console.log('resize me');
		//console.log(_this.lienObj.h);
		$(_this.div).css('top',_this.lienObj.yScreen+'px');
		$(_this.div).css('left',_this.lienObj.xScreen+'px');
		$(_this.div).css('width',_this.lienObj.w+'px');
		$(_this.div).css('height',_this.lienObj.h+'px');
		
		_this.currentBox.x = _this.lienObj.xScreen;
		_this.currentBox.y = _this.lienObj.yScreen;
		_this.currentBox.w = _this.lienObj.w;
		_this.currentBox.h = _this.lienObj.h;
		
		return true;
	}
	
	_this.moveMe = function(moveDiffX,moveDiffY) {
		//$(_this.div).css('top',(_this.lienObj.yScreen+moveDiffY)+'px');
		$(_this.div).css('left',(_this.lienObj.xScreen+moveDiffX)+'px');
	}
	
	_this.hideMe = function() {

		if (_this.currentBox.opacity == 1) {
			//$(_this.div).css('display','none');
			$(_this.div).removeClass('show');
			$(_this.div).addClass('hide');
			console.log('hide me');
			_this.currentBox.opacity = 0;
		}
	}
	
	_this.showMe = function() {

		if (_this.currentBox.opacity == 0) {
			//$(_this.div).css('display','block');
			$(_this.div).removeClass('hide');
			$(_this.div).addClass('show');
			console.log('show me');
			_this.currentBox.opacity = 1;
		}
		
	}
	
	_this._construct();
	
}

_GLOBALS.callbackLoaded("PageSwfLoader");