var Utils = function()
{
	var _this = this;
	_this.onResizeCustomList = new Object();	
	
	_this.uniqueIdN = 0;
	
	_this._construct = function()
	{
		/*Accelerator func*/
		Math.abs = function(a)
		{
			return a < 0 ? -a : a;
		}
		
		Math.floor = function(a)
		{
			return a>>0;
		}
		
		Math.ceil = function(a)
		{
			var xa = Math.floor(a);
			return (a>xa)?xa++:a;
		}
		
		custFloor = function(numb,app)
		{
			if(!app){app = 100;	}
			return Math.floor(numb*app)/app;
		}
		
		return void(0);
		
	}
	
	/*Kev*/
	_this.arrondi = function(nombre)
	{
	   return Math.floor(nombre*100)/100;
	}
	
	_this.getFileExtension = function(filename)
	{
	   return (/[.]/.exec(filename)) ? /[^.]+$/.exec(filename) : undefined;
	}
	
	_this.getFilenameWithoutExtension = function(filename)
	{
	   return (/[.]/.exec(filename)) ? /^[^.]+/.exec(filename) : undefined;
	}
	/*****/
	
	_this.impair = function(nombre)
	{
	   return ((nombre)&1);
	}
	
	/*
	 * Fonction de clonage
	 * @author Keith Devens
	 * @see http://keithdevens.com/weblog/archive/2007/Jun/07/javascript.clone
	 */
	_this.clone = function(srcInstance)
	{
		/*Si l'instance source n'est pas un objet ou qu'elle ne vaut rien c'est une feuille donc on la retourne*/
		if(typeof(srcInstance) != 'object' || srcInstance == null)
		{
			return srcInstance;
		}
		/*On appel le constructeur de l'instance source pour cre une nouvelle instance de la mme classe*/
		var newInstance = srcInstance.constructor();
		/*On parcourt les proprits de l'objet et on les recopies dans la nouvelle instance*/
		for(var i in srcInstance)		{
			newInstance[i] = _this.clone(srcInstance[i]);			continue;
		}
		/*On retourne la nouvelle instance*/
		return newInstance;
	}	
	
	_this.getMaskOfPng = function( pathPng , inElementHtml , isColor )//return data of png
	{
		var imgObject = new Image();
		imgObject.src = pathPng;
		var sizeW	= 48;
		var sizeH	= 48;
		
		imgObject.onload = function()
		{
			var cvsElem		= document.createElement('canvas');
			
			var posToPutX	= sizeW/2 - imgObject.width/2;
			var posToPutY	= sizeH/2 - imgObject.height/2;
			
			// cvsElem.width	= imgObject.width;
			// cvsElem.height	= imgObject.height;
			
			cvsElem.width	= sizeW;
			cvsElem.height	= sizeH;
			var canvas		= cvsElem;
			var ctx			= cvsElem.getContext("2d");
			var image		= this;
			
			ctx.shadowColor		= "rgba( "+isColor+", 0.5 )";
			ctx.shadowOffsetX	= 2;
			ctx.shadowOffsetY	= 2;
			ctx.shadowBlur		= 2;
			ctx.drawImage(image,0,0);
			var imgd		= ctx.getImageData(0, 0, cvsElem.width , cvsElem.height );
			// Loops through all of the pixels and modifies the components.
			var imgDl		= imgd.data.length;
			var counter = 0;
			for ( var i = 0 ; i < imgDl ; i += 4 )
			{
				if( !imgd.data[i+3] )
				{
					// console.log(imgd.data[i+3]);
					// imgd.data[i+3]=0;
					continue;
				}
				
				imgd.data[i]	= isColor[0];   // Red component
				imgd.data[i+1]	= isColor[1]; // Blue component
				imgd.data[i+2]	= isColor[2]; // Green component
				// imgd.data[i+3]	= 255;
				counter++;
			}

			var currImgData = ctx.createImageData(cvsElem.width, cvsElem.height);
			// ctx.clear();
			ctx.putImageData(currImgData, 0, 0);

			ctx.putImageData(imgd, posToPutX, posToPutY);
			// inElementHtml.append("<img src='"+cvsElem.toDataURL("image/png")+"'/>");
			inElementHtml.append(cvsElem);
		}
	}
	
	
	_this.addslashes = function(str)
	{
		return (str + '').replace(/[\\"']/g, '\\$&').replace(/\u0000/g, '\\0');
	}

	_this.stripslashes = function(str)
	{
		return (str + '').replace(/\\(.?)/g, function (s, n1)
		{
			switch (n1)
			{
				case '\\':
					return '\\';
				case '0':            return '\u0000';
				case '':
					return '';
				default:
					return n1;
			}
		});
	}
	
	_this.preventDefault = function(event)
	{
		// event est l'objet Event
		if (event.stopPropagation)
		{
			event.stopPropagation();
		}
		event.cancelBubble = true;
		if (event.preventDefault)
		{
			event.preventDefault();
		}
		event.returnValue = false;
	}
	
	_this.byPageIfDouble = function( pageN )
	{
		var infos 					= new Object();
		infos["isDoubleDoc"]		= _GLOBALS.CONF.pages.doublePage;
		infos["isDoublePage"]		= new Object();
		infos["isDoublePage"][1]	= pageN;
		infos["isDoublePage"][2]	= 0;
		infos["isDouble"]			= 0;
		// pageN = Math.floor(pageN);
		
		var pgLength = _GLOBALS.CONF.pages.length;
		
		if( infos["isDoubleDoc"] )
		{
			if( pageN === 1 )
			{
				infos["isDoublePage"][1] = 1;
				infos["isDoublePage"][2] = 0;
				infos["isDouble"] = 0;
				return infos;
			}
			
			if( pageN === pgLength && !_this.impair(pgLength))
			{
				infos["isDoublePage"][1] = 0;
				infos["isDoublePage"][2] = 1;
				infos["isDouble"] = 0;
				return infos;
			}
			
			if( !_this.impair(pageN) )
			{
				infos["isDoublePage"][1] = 1;
				infos["isDoublePage"][2] = 0;
				infos["isDouble"] = 1;
				return infos;
			}
			else if( _this.impair(pageN) )
			{
				infos["isDoublePage"][1] = 0;
				infos["isDoublePage"][2] = 1;
				infos["isDouble"] = 1;
				return infos;
			}
			
		}
		return infos;		
	}
	
	_this.uniqueId = function()
	{
		_this.uniqueIdN++;
		return new Date().getTime()+"_"+_this.uniqueIdN++;
	}
	
	_this.clearOnResizeCustom = function(id)
	{
		if(_this.onResizeCustomList[id])
		{
			_this.onResizeCustomList[id] = null;
			delete _this.onResizeCustomList[id];
		}
	}
	
	_this.onResizeCustom = function(func)
	{
		var id = _this.uniqueId();
		_this.onResizeCustomList[id] = func;
		return id;
	}
	
	_this.onResizedCustom = function(event)
	{
		if(_GLOBALS.main.supportsOrientationChange)
		{
			//0
			$(".blockCont").children("canvas").transition(
			{
				// x:_GLOBALS.CONF.getDocument.width*2
				opacity: 0
			})
			if(!_GLOBALS.main.supportsOrientationChange)
			{
				clearTimeout(_this.timeResize);
			}
			_this.timeResize = setTimeout(function()
			{				
				for( var J in _this.onResizeCustomList )
				{
					_this.onResizeCustomList[J](event);
				}
			}, _GLOBALS.main.timeOfResizeMobile );
		}else
		{
			if(!_GLOBALS.main.supportsOrientationChange)
			{
				clearTimeout(_this.timeResize);
			}
			_this.timeResize = setTimeout(function()
			{				
				for( var J in _this.onResizeCustomList )
				{
					_this.onResizeCustomList[J](event);
				}
			}, _GLOBALS.main.timeOfResize );
		}
	}

	_this.byOffsetIndex = function( index )
	{
		if( _GLOBALS.CONF.decalagePage >= index )
		{
			index = _this.romanize(index);
		}else
		{
			index = index - _GLOBALS.CONF.decalagePage;
		}		
		return index;
	}
	
	_this.getPathImage = function( type , index )
	{
		return type+_GLOBALS.CONF.pages.defaultName+""+(index)+""+_GLOBALS.CONF.pages.imgFormat;
	}
	
	
	_this.hex16 = function(hex16)
	{
		if( hex16.length == 8 )
		{
			hex16 = hex16.substr(2,8);
		}
		return hex16;
	}
	
	
	_this.getRadiant = function( elem , rgbColor , hexColor , alpha , alpha2 , coefRadiant)
	{
		var coef = 50;
		if(coefRadiant)
		{
			coef = coefRadiant;
		}
		
		var spHex = rgbColor.split(",");
		
		for( var i = 0 ; i < spHex.length ; i++ )
		{
			spHex[i] = parseInt(parseInt(spHex[i]) + coef);
			if( spHex[i] > 255 )
			{
				spHex[i] = 255;
			}
		}
		
		var radiantR = "";
		radiantR += "background: rgb("+rgbColor+");";
		radiantR += "background: -moz-linear-gradient(-45deg,  rgba("+spHex+","+alpha2+") 0%, rgba("+rgbColor+","+alpha+") 50%);";
		radiantR += "background: -webkit-gradient(linear, left top, right bottom, color-stop(0%,rgba("+rgbColor+",1)), color-stop(50%,rgba("+rgbColor+","+alpha+")));";
		radiantR += "background: -webkit-linear-gradient(-45deg,  rgba("+spHex+","+alpha2+") 0%,rgba("+rgbColor+","+alpha+") 50%);";
		radiantR += "background: -o-linear-gradient(-45deg,  rgba("+spHex+","+alpha2+") 0%,rgba("+rgbColor+","+alpha+") 50%);";
		radiantR += "background: -ms-linear-gradient(-45deg,  rgba("+spHex+","+alpha2+") 0%,rgba("+rgbColor+","+alpha+") 50%);";
		radiantR += "background: linear-gradient(135deg,  rgba("+spHex+","+alpha2+") 0%,rgba("+rgbColor+","+alpha+") 50%);";
		radiantR += "filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#ffffff', endColorstr='"+hexColor+","+alpha+"',GradientType=1 );";
		return radiantR;
	}
	
	
	_this.romanize = function(num)
	{
		if (!+num)
			return false;
		var	digits = String(+num).split(""),
			key = ["","C","CC","CCC","CD","D","DC","DCC","DCCC","CM",
				   "","X","XX","XXX","XL","L","LX","LXX","LXXX","XC",
				   "","I","II","III","IV","V","VI","VII","VIII","IX"],
			roman = "",
			i = 3;
		while (i--)
			roman = (key[+digits.pop() + (i * 10)] || "") + roman;
		return Array(+digits.join("") + 1).join("M") + roman;
	}

	_this.deromanize = function(str)
	{
		var	str = str.toUpperCase(),
			validator = /^M*(?:D?C{0,3}|C[MD])(?:L?X{0,3}|X[CL])(?:V?I{0,3}|I[XV])$/,
			token = /[MDLV]|C[MD]?|X[CL]?|I[XV]?/g,
			key = {M:1000,CM:900,D:500,CD:400,C:100,XC:90,L:50,XL:40,X:10,IX:9,V:5,IV:4,I:1},
			num = 0, m;
		if (!(str && validator.test(str)))
			return false;
		while (m = token.exec(str))
			num += key[m[0]];
		return num;
	}
	
	_this.mailValid = function( email )
	{
		var reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
		var address = email;
		if(reg.test(address) == false)
		{
			return false;
		}
		return true;
	}
	
	_this.filleExist = function( fillePath , callback )
	{
		var statAbort = false;
		try
		{
			var xhrCurr = $.ajax(
			{
				xhr: function()
				{
					var xhr = new window.XMLHttpRequest();
					//Download progress
					xhr.addEventListener("progress", function(evt)
					{
						if (evt.lengthComputable)
						{
							//var percentComplete = evt.loaded / evt.total;
						}
					}, false);
					return xhr;
				},type: 'GET',url: fillePath,
				success: function(data)
				{
					if(callback)
					{
						statAbort = true;
						callback(true);
					}					
				},error:function(data)
				{
					if(!statAbort)
					{
						if(callback)
						{
							callback(false);
						}
					}
				}
			});	
		}catch(e)
		{
			if(callback)
			{
				callback(false);
			}
		}
	}

	_this.isMaster = function()
	{
		return _GLOBALS.isMaster;
	}
	
	_this.prodTools =
	{
		currentPage : function() // Int(null) -> return the current page
		{
			return _GLOBALS.getCurrentPage();
		},
		nextPage : function() // void(null) -> go to next pages
		{
			_GLOBALS.main.controlManager.nextPage();
			return void(0);
		},
		prevPage : function() // void(null) -> go to previews pages
		{
			_GLOBALS.main.controlManager.prevPage();
			return void(0);
		},
		goToPage : function(N) // void( Int $NumberOfPage ) -> be carfoul the first page begin always at 1
		{
			_GLOBALS.main.controlManager.goToPage(N);
			return void(0);
		},
		getPageLength : function() // Int(null) -> the Offset ("decalagePage") is added
		{
			return _GLOBALS.CONF.pages.length;
		},
		decalagePage : function() // Int(null) -> is the Offset or pagination ("decalagePage")
		{
			return _GLOBALS.CONF.decalagePage;
		},
		goDoublePage : function( doubleOrNot , autoOrNot , reset ) // void( Bool $setDoublePage , Bool $setAutoDouble , Bool $resetLastAction )
		{
			_GLOBALS.main.pagesLoader.goDoublePage( doubleOrNot , autoOrNot , reset );
			return void(0);
		},
		isMaster : function() // Bool(null) -> if 0 that's mean it's not a master
		{
			return _this.isMaster();
		},
		getClientPath : function() // String(null)
		{
			return _GLOBALS.CONF.getClientPath();
		},
		iconesPath : function() // String(null)
		{
			return _GLOBALS.CONF.iconesPath;
		},
		onShowTools : function(func) // void(function $callBack)
		{
			_GLOBALS.main.controlManager.onShowTools(func);
			return void(0);
		},
		onPageChange : function(func) // void(function $callBack)
		{
			_GLOBALS.main.pagesLoader.onPageChange(func);
			return void(0);
		},
		onResizeCustom : function(func) // Int(function $callBack)
		{
			return UTILS.onResizeCustom(func);
		},
		clearOnResizeCustom : function(funcId) // void(Int $idOfOnResizeCustom )
		{
			UTILS.clearOnResizeCustom(funcId);
			return void(0);
		},
		useCurrentCustomIcones : function( iconePath ,elem ) // void(String $url , Object HTML $elementHtml)
		{
			UTILS.getMaskOfPng( iconePath , elem , _GLOBALS.CONF.iconesDefaultParam.teinteRGB );
			return void(0);
		},
		getUserAgent:function() // String(null) -> smartphone, ipad, other if you want more detail of userAgent use navigator.userAgent()
		{
			return _GLOBALS.userAgentManager.userAgent;
		},
		getCurrentLangue:function() // String(null) -> fr, es, us, pl, etc...
		{
			return _GLOBALS.CONF.getDocument.lng;
		},
		get_X_Y_Z : function() // String(null)
		{
			return _GLOBALS.x_y_z_Manager.urlVarId;
		},
		getWordLangueByIndex : function(index) // String(Int $indexOfLangueInXmlFile)
		{
			return _GLOBALS.main.xmlLinksList.getXml.langue.find("menuitem[index="+index+"]").attr("label");
		},
		jsLoader : function( sUrl , oParams ) // void( String $url , Object ) -> exemple (./x/y/z/jsFile/customJs.js , {id:'1',x:'Hello'} ) 
		{
			_GLOBALS.javascriptInit.loadJs( sUrl , oParams );
		},
		getXmlByNameFile : function( fileName ) // Object( String $FileName ) -> exemple menuParam
		{
			if(_GLOBALS.main.xmlLinksList.getXml[fileName])
			{
				return _GLOBALS.main.xmlLinksList.getXml[fileName];
			}
			return "error or file not Existe";
		},
		setDisableCarrousel: function( path ) // void( bool $etat ) -> exemple if false it will hide the carrousel
		{
			_GLOBALS.CONF.setDisableCarrousel = false;
		},
		setFondRelatif: function( path ) // Object( String $FileName ) -> exemple FondRelatif_fr.png
		{
			var cImg = new Image();
			cImg.onload = function()
			{
				var elem = $("<div class='bgCustom' style='display:none;z-index:1;width:100%;height:100%;position:absolute;left:0;top:0;' ></div>");
				elem.css( "background" , "transparent url('"+path+"') center no-repeat");
				elem.css("background-size","cover");
				elem.css("background-clip","content-box");
				$("body").append(elem);
				setTimeout(function()
				{
					elem.fadeIn(400);
				},500)				
			};
			cImg.src = path;			
		},
		prodSpaceVar: {}// there is your variables stocker if you want add a globals viarable UTILS.prodTools.prodSpaceVar.myVar = "value of my global var"
		,
		help : function() // void(null) can i help you ?
		{
			alert("all infos is in your console debug, Do not use anything other than what is listed,\
			but you can make changes to the DOM with jQuery, if you want other function I can add ");
			_GLOBALS.javascriptInit.debugEnable();
			console.log(_this.prodTools);
			return void(0);
		}
	};
	_this._construct();
}

function isEventSupported(eventName, element)
{
	element = element || document.createElement(TAGNAMES[eventName] || 'div');
	eventName = 'on' + eventName;
   
	var isSupported = (eventName in element);
   
	if (!isSupported)
	{
		// if it has no `setAttribute` (i.e. doesn't implement Node interface), try generic element
		if (!element.setAttribute)
		{
			element = document.createElement('div');
		}
	
		if (element.setAttribute && element.removeAttribute)
		{
			element.setAttribute(eventName, '');
			isSupported = typeof element[eventName] == 'function';
			// if property was created, "remove it" (by setting value to `undefined`)
			if (typeof element[eventName] != 'undefined')
			{
				element[eventName] = undef;
			}
			element.removeAttribute(eventName);
		}
	}
   
	element = null;
	return isSupported;
}

var convertHexToRGB = function( hex , alphaC )
{
	this.resultH = new Array();
	this._construct = function()
	{
		this.resultH.push(this.hexToR(hex));
		this.resultH.push(this.hexToG(hex));
		this.resultH.push(this.hexToB(hex));

		if( typeof(alphaC) != "undefined" )
		{
			this.resultH.push(parseFloat(alphaC));
		}
		return this.resultH;
	}
	 
	this.hexToR = function(h)
	{
		return parseInt((this.cutHex(h)).substring(0,2),16);
	}

	this.hexToG = function(h)
	{
		return parseInt((this.cutHex(h)).substring(2,4),16);
	}

	this.hexToB = function(h)
	{
		return parseInt((this.cutHex(h)).substring(4,6),16);
	}

	this.cutHex = function(h)
	{
		return (h.charAt(0)=="#") ? h.substring(1,7):h;
	}

	return this._construct();
}

var dataToObject = function(obj)
{
	return eval('({'+obj+'})');
}

var drawCanvasTime = function( callback , cancel , id )
{
	if(cancel)
	{
		clearTimeout(id);
	}else
	{
		var timeToCall = 0;
		var id = window.setTimeout(function()
		{
			callback();
		},timeToCall);
		return id;
	}		
}

var UTILS = new Utils();
_GLOBALS.callbackLoaded("Utils");