var XmlLoader = function( parent , objName , path , xmlLisInArray , callBack )
{
	var _this				= this;
	_this.objName			= objName;
	_this.parent			= parent;
	_this.path				= path;
	
	_this.xmlNeededToLoad	= new Array(); 
	_this.xmlNeededToLoad	= xmlLisInArray;
	_this.currXmlLength		= 0;
	
	_this.getXml = {};
	
	_this._construct = function()
	{
		_this.whileListXml();
		return void(0);
	}
	
	_this.loadCurrXml = function( cPath , cIndex , xmlLength )
	{
		$.ajax(
		{
			xhr: function()
			{
				var xhr = new window.XMLHttpRequest();
				//Download progress
				xhr.addEventListener("progress", function(evt)
				{
					if (evt.lengthComputable)
					{
						var percentComplete = evt.loaded / evt.total;
						//Do something with download progress
						//console.log(evt);
					}
				}, false);
				return xhr;
			},type: 'GET',url: cPath ,data: {},
			success: function(data)
			{
				_this.currXmlLength++;
				_this.getXml[_this.xmlNeededToLoad[cIndex]] = $(data.documentElement);
				if( xmlLength == _this.currXmlLength )
				{
					if( callBack )
					{
						callBack(true);
					}
				}
				return void(0);
			},error:function(data)
			{
				_this.currXmlLength++;
				_this.getXml[_this.xmlNeededToLoad[cIndex]] = false;
				if( xmlLength == _this.currXmlLength )
				{
					if( callBack )
					{
						callBack(false);
					}
				}
				return void(0);
			}
		});	
		return void(0);		
	}
	
	_this.whileListXml = function()
	{
		var xmlLength = _this.xmlNeededToLoad.length;
		for( var i = 0 ; i < xmlLength ; i++ )
		{
			var pathGetXml = _this.path+_this.xmlNeededToLoad[i]+".xml";
			_this.loadCurrXml( pathGetXml , i , xmlLength );		
		}
		return void(0);
	}

	_this._construct();
}
_GLOBALS.callbackLoaded("XmlLoader");